# Directory used by GHC (and possibly other tools) for storing
# temporary files.  If your /tmp isn't big enough, either override
# this in build.mk or set your environment variable "TMPDIR" to point
# to somewhere with more space.  (TMPDIR=. is a good choice).

TMPDIR			= /tmp

# GhcOpts = -pgmC/net/dazdak/ghc-4.02/fptools/lib/i386-unknown-linux/ghc-4.02/hsc

# Compiler to use for building ghc (same as ./configure --with-hc=... )
WithGhcHc = /net/azdak/dsg/local/i386-unknown-linux/bin/ghc-4.04

# Option flags to pass to GHC when it's compiling RTS modules
# This is a good way to set things like -optc-g and -optc-DDEBUG for the RTS.
# GhcRtsHcOpts is used when compiling .hc files.
# GhcRtsCcOpts is used when compiling .c  files.

GhcRtsHcOpts= 
GhcRtsCcOpts= -optc-g -optc-DDEBUG

WAY_mg_HC_OPTS= -gransim -optc-DGRAN -optc-DGRAN_CHECK
WAY_mg_CC_OPTS= -optc-DGRAN -optc-DGRAN_CHECK 

# Robert, I think it's better to set DIST from the build.mk rather
# than from within the RTS (cleaner separation) -- HWL
WAY_mp_CC_OPTS= -optc-DDEBUG -optc-DDIST

WAY_s_CC_OPTS= -optc-DDEBUG

# Extra ways in which to build the compiler (for example, you might want to
# build a profiled compiler so you can see where it spends its time)
# GhcCompilerWays= mg

# What extra ways to build the libraries in
# In addition to the normal sequential way, the default is to also build
# profiled prelude libraries.
# When booting from .hc files, turn this off.
GhcLibWays= mp

# ushas option: be verbose when building the libraries to see where we crash
# HWL: for debugging GranSim generate .hc and .s files

#GhcLibHcOpts += -keep-hc-files-too -keep-s-files-too


