-- parser produced by Happy Version 1.6


module ParseIface ( parseIface, IfaceStuff(..) ) where

#include "HsVersions.h"

import HsSyn		-- quite a bit of stuff
import RdrHsSyn		-- oodles of synonyms
import HsTypes		( mkHsForAllTy, mkHsUsForAllTy )
import HsCore
import Literal		( Literal(..), mkMachInt, mkMachInt64, mkMachWord, mkMachWord64 )
import BasicTypes	( Fixity(..), FixityDirection(..), 
			  NewOrData(..), Version
			)
import CostCentre       ( CostCentre(..), IsCafCC(..), IsDupdCC(..) )
import CallConv         ( cCallConv )
import HsPragmas	( noDataPragmas, noClassPragmas )
import Type		( Kind, mkArrowKind, boxedTypeKind, openTypeKind, UsageAnn(..) )
import IdInfo           ( ArityInfo, exactArity, CprInfo(..), InlinePragInfo(..) )
import PrimOp           ( CCall(..), CCallTarget(..) )
import Lex		

import RnMonad		( ImportVersion, LocalVersion, ParsedIface(..), WhatsImported(..),
			  RdrNamePragma, ExportItem, RdrAvailInfo, GenAvailInfo(..), 
                          WhetherHasOrphans, IsBootInterface
			) 
import Bag		( emptyBag, unitBag, snocBag )
import FiniteMap	( emptyFM, unitFM, addToFM, plusFM, bagToFM, FiniteMap )
import RdrName          ( RdrName, mkRdrUnqual, mkSysQual, mkSysUnqual, mkRdrNameWkr )
import Name		( OccName, Provenance )
import OccName          ( mkSysOccFS,
			  tcName, varName, ipName, dataName, clsName, tvName, uvName,
			  EncodedFS 
			)
import Module           ( ModuleName, PackageName, mkSysModuleFS, mkModule )			
import PrelInfo         ( mkTupConRdrName, mkUbxTupConRdrName )
import SrcLoc		( SrcLoc )
import CmdLineOpts	( opt_InPackage )
import Maybes
import Outputable

import GlaExts
import FastString	( tailFS )

#if __HASKELL1__ > 4
import Ratio ( (%) )
#endif

data HappyAbsSyn 
	= HappyTerminal Token
	| HappyErrorToken Int
	| HappyAbsSyn4 (IfaceStuff)
	| HappyAbsSyn5 (ParsedIface)
	| HappyAbsSyn6 ([ImportVersion OccName])
	| HappyAbsSyn7 (ImportVersion OccName)
	| HappyAbsSyn8 (WhetherHasOrphans)
	| HappyAbsSyn9 (IsBootInterface)
	| HappyAbsSyn10 (WhatsImported OccName)
	| HappyAbsSyn11 ([LocalVersion OccName])
	| HappyAbsSyn12 (LocalVersion OccName)
	| HappyAbsSyn13 ([ExportItem])
	| HappyAbsSyn14 ([RdrAvailInfo])
	| HappyAbsSyn15 (RdrAvailInfo)
	| HappyAbsSyn16 ([OccName])
	| HappyAbsSyn17 (OccName)
	| HappyAbsSyn19 (FixityDirection)
	| HappyAbsSyn20 (Int)
	| HappyAbsSyn21 ([RdrNameSig])
	| HappyAbsSyn23 (RdrNameSig)
	| HappyAbsSyn24 ([RdrNameInstDecl])
	| HappyAbsSyn25 (RdrNameInstDecl)
	| HappyAbsSyn26 ([(Version, RdrNameHsDecl)])
	| HappyAbsSyn27 (RdrNameHsDecl)
	| HappyAbsSyn28 (RdrName -> [HsIdInfo RdrName])
	| HappyAbsSyn29 (ParseResult IfaceStuff)
	| HappyAbsSyn30 (([RdrNameRuleDecl], [RdrNameDeprecation]))
	| HappyAbsSyn32 ([RdrNameRuleDecl])
	| HappyAbsSyn33 (RdrNameRuleDecl)
	| HappyAbsSyn34 ([UfBinder RdrName])
	| HappyAbsSyn35 ([RdrNameDeprecation])
	| HappyAbsSyn36 (RdrNameDeprecation)
	| HappyAbsSyn37 (RdrNameIE)
	| HappyAbsSyn38 (Version)
	| HappyAbsSyn39 (RdrNameContext)
	| HappyAbsSyn40 ([RdrNameConDecl] {- empty for handwritten abstract -})
	| HappyAbsSyn41 ([RdrNameConDecl])
	| HappyAbsSyn42 (RdrNameConDecl)
	| HappyAbsSyn43 ([RdrNameConDecl] {- Empty if handwritten abstract -})
	| HappyAbsSyn44 (([HsTyVar RdrName], RdrNameContext))
	| HappyAbsSyn45 ([RdrNameBangType])
	| HappyAbsSyn46 (RdrNameBangType)
	| HappyAbsSyn47 ([([RdrName], RdrNameBangType)])
	| HappyAbsSyn48 (([RdrName], RdrNameBangType))
	| HappyAbsSyn49 (RdrNameHsType)
	| HappyAbsSyn50 ([RdrName])
	| HappyAbsSyn51 ([HsTyVar RdrName])
	| HappyAbsSyn54 (HsPred RdrName)
	| HappyAbsSyn55 ([RdrNameHsType] 			{- Zero or more -})
	| HappyAbsSyn56 ([RdrNameHsType] 			{- Two or more -})
	| HappyAbsSyn58 (MonoUsageAnn RdrName)
	| HappyAbsSyn60 ([RdrNameHsType] 	{-  Zero or more -})
	| HappyAbsSyn61 (PackageName)
	| HappyAbsSyn62 (ModuleName)
	| HappyAbsSyn63 (EncodedFS)
	| HappyAbsSyn64 ((EncodedFS, EncodedFS))
	| HappyAbsSyn66 (RdrName)
	| HappyAbsSyn88 (HsTyVar RdrName)
	| HappyAbsSyn90 ([([RdrName], [RdrName])])
	| HappyAbsSyn92 (([RdrName], [RdrName]))
	| HappyAbsSyn94 (Kind)
	| HappyAbsSyn96 ([HsIdInfo RdrName])
	| HappyAbsSyn97 (HsIdInfo RdrName)
	| HappyAbsSyn98 (InlinePragInfo)
	| HappyAbsSyn99 (UfExpr RdrName)
	| HappyAbsSyn102 ([UfExpr RdrName])
	| HappyAbsSyn106 ([(UfBinder RdrName, UfExpr RdrName)])
	| HappyAbsSyn107 ([UfAlt RdrName])
	| HappyAbsSyn108 (UfAlt RdrName)
	| HappyAbsSyn109 ((UfConAlt RdrName, [RdrName]))
	| HappyAbsSyn113 (Literal)
	| HappyAbsSyn114 (Integer)
	| HappyAbsSyn115 (Rational)
	| HappyAbsSyn116 (UfBinder RdrName)
	| HappyAbsSyn120 (FAST_STRING)
	| HappyAbsSyn121 (CostCentre)
	| HappyAbsSyn123 (IsDupdCC)
	| HappyAbsSyn124 (IsCafCC)
	| HappyAbsSyn125 (SrcLoc)
	| HappyAbsSyn126 (())

type HappyReduction = 
	   Int# 
	-> (Token)
	-> HappyState (Token) ([HappyAbsSyn] -> P(IfaceStuff))
	-> [HappyState (Token) ([HappyAbsSyn] -> P(IfaceStuff))] 
	-> [HappyAbsSyn] 
	-> P(IfaceStuff)

action_0,
 action_1,
 action_2,
 action_3,
 action_4,
 action_5,
 action_6,
 action_7,
 action_8,
 action_9,
 action_10,
 action_11,
 action_12,
 action_13,
 action_14,
 action_15,
 action_16,
 action_17,
 action_18,
 action_19,
 action_20,
 action_21,
 action_22,
 action_23,
 action_24,
 action_25,
 action_26,
 action_27,
 action_28,
 action_29,
 action_30,
 action_31,
 action_32,
 action_33,
 action_34,
 action_35,
 action_36,
 action_37,
 action_38,
 action_39,
 action_40,
 action_41,
 action_42,
 action_43,
 action_44,
 action_45,
 action_46,
 action_47,
 action_48,
 action_49,
 action_50,
 action_51,
 action_52,
 action_53,
 action_54,
 action_55,
 action_56,
 action_57,
 action_58,
 action_59,
 action_60,
 action_61,
 action_62,
 action_63,
 action_64,
 action_65,
 action_66,
 action_67,
 action_68,
 action_69,
 action_70,
 action_71,
 action_72,
 action_73,
 action_74,
 action_75,
 action_76,
 action_77,
 action_78,
 action_79,
 action_80,
 action_81,
 action_82,
 action_83,
 action_84,
 action_85,
 action_86,
 action_87,
 action_88,
 action_89,
 action_90,
 action_91,
 action_92,
 action_93,
 action_94,
 action_95,
 action_96,
 action_97,
 action_98,
 action_99,
 action_100,
 action_101,
 action_102,
 action_103,
 action_104,
 action_105,
 action_106,
 action_107,
 action_108,
 action_109,
 action_110,
 action_111,
 action_112,
 action_113,
 action_114,
 action_115,
 action_116,
 action_117,
 action_118,
 action_119,
 action_120,
 action_121,
 action_122,
 action_123,
 action_124,
 action_125,
 action_126,
 action_127,
 action_128,
 action_129,
 action_130,
 action_131,
 action_132,
 action_133,
 action_134,
 action_135,
 action_136,
 action_137,
 action_138,
 action_139,
 action_140,
 action_141,
 action_142,
 action_143,
 action_144,
 action_145,
 action_146,
 action_147,
 action_148,
 action_149,
 action_150,
 action_151,
 action_152,
 action_153,
 action_154,
 action_155,
 action_156,
 action_157,
 action_158,
 action_159,
 action_160,
 action_161,
 action_162,
 action_163,
 action_164,
 action_165,
 action_166,
 action_167,
 action_168,
 action_169,
 action_170,
 action_171,
 action_172,
 action_173,
 action_174,
 action_175,
 action_176,
 action_177,
 action_178,
 action_179,
 action_180,
 action_181,
 action_182,
 action_183,
 action_184,
 action_185,
 action_186,
 action_187,
 action_188,
 action_189,
 action_190,
 action_191,
 action_192,
 action_193,
 action_194,
 action_195,
 action_196,
 action_197,
 action_198,
 action_199,
 action_200,
 action_201,
 action_202,
 action_203,
 action_204,
 action_205,
 action_206,
 action_207,
 action_208,
 action_209,
 action_210,
 action_211,
 action_212,
 action_213,
 action_214,
 action_215,
 action_216,
 action_217,
 action_218,
 action_219,
 action_220,
 action_221,
 action_222,
 action_223,
 action_224,
 action_225,
 action_226,
 action_227,
 action_228,
 action_229,
 action_230,
 action_231,
 action_232,
 action_233,
 action_234,
 action_235,
 action_236,
 action_237,
 action_238,
 action_239,
 action_240,
 action_241,
 action_242,
 action_243,
 action_244,
 action_245,
 action_246,
 action_247,
 action_248,
 action_249,
 action_250,
 action_251,
 action_252,
 action_253,
 action_254,
 action_255,
 action_256,
 action_257,
 action_258,
 action_259,
 action_260,
 action_261,
 action_262,
 action_263,
 action_264,
 action_265,
 action_266,
 action_267,
 action_268,
 action_269,
 action_270,
 action_271,
 action_272,
 action_273,
 action_274,
 action_275,
 action_276,
 action_277,
 action_278,
 action_279,
 action_280,
 action_281,
 action_282,
 action_283,
 action_284,
 action_285,
 action_286,
 action_287,
 action_288,
 action_289,
 action_290,
 action_291,
 action_292,
 action_293,
 action_294,
 action_295,
 action_296,
 action_297,
 action_298,
 action_299,
 action_300,
 action_301,
 action_302,
 action_303,
 action_304,
 action_305,
 action_306,
 action_307,
 action_308,
 action_309,
 action_310,
 action_311,
 action_312,
 action_313,
 action_314,
 action_315,
 action_316,
 action_317,
 action_318,
 action_319,
 action_320,
 action_321,
 action_322,
 action_323,
 action_324,
 action_325,
 action_326,
 action_327,
 action_328,
 action_329,
 action_330,
 action_331,
 action_332,
 action_333,
 action_334,
 action_335,
 action_336,
 action_337,
 action_338,
 action_339,
 action_340,
 action_341,
 action_342,
 action_343,
 action_344,
 action_345,
 action_346,
 action_347,
 action_348,
 action_349,
 action_350,
 action_351,
 action_352,
 action_353,
 action_354,
 action_355,
 action_356,
 action_357,
 action_358,
 action_359,
 action_360,
 action_361,
 action_362,
 action_363,
 action_364,
 action_365,
 action_366,
 action_367,
 action_368,
 action_369,
 action_370,
 action_371,
 action_372,
 action_373,
 action_374,
 action_375,
 action_376,
 action_377,
 action_378,
 action_379,
 action_380,
 action_381,
 action_382,
 action_383,
 action_384,
 action_385,
 action_386,
 action_387,
 action_388,
 action_389,
 action_390,
 action_391,
 action_392,
 action_393,
 action_394,
 action_395,
 action_396,
 action_397,
 action_398,
 action_399,
 action_400,
 action_401,
 action_402,
 action_403,
 action_404,
 action_405,
 action_406,
 action_407,
 action_408,
 action_409,
 action_410,
 action_411,
 action_412,
 action_413,
 action_414,
 action_415,
 action_416,
 action_417,
 action_418,
 action_419,
 action_420,
 action_421,
 action_422,
 action_423,
 action_424,
 action_425,
 action_426,
 action_427,
 action_428,
 action_429,
 action_430,
 action_431,
 action_432,
 action_433,
 action_434,
 action_435,
 action_436,
 action_437,
 action_438,
 action_439,
 action_440,
 action_441,
 action_442,
 action_443,
 action_444,
 action_445,
 action_446,
 action_447,
 action_448,
 action_449,
 action_450,
 action_451,
 action_452,
 action_453,
 action_454,
 action_455,
 action_456,
 action_457,
 action_458,
 action_459,
 action_460,
 action_461,
 action_462,
 action_463,
 action_464,
 action_465,
 action_466,
 action_467,
 action_468,
 action_469,
 action_470,
 action_471,
 action_472,
 action_473,
 action_474,
 action_475,
 action_476,
 action_477,
 action_478,
 action_479,
 action_480,
 action_481,
 action_482,
 action_483,
 action_484,
 action_485,
 action_486,
 action_487,
 action_488,
 action_489,
 action_490,
 action_491,
 action_492,
 action_493,
 action_494 :: Int# -> HappyReduction

happyReduce_1,
 happyReduce_2,
 happyReduce_3,
 happyReduce_4,
 happyReduce_5,
 happyReduce_6,
 happyReduce_7,
 happyReduce_8,
 happyReduce_9,
 happyReduce_10,
 happyReduce_11,
 happyReduce_12,
 happyReduce_13,
 happyReduce_14,
 happyReduce_15,
 happyReduce_16,
 happyReduce_17,
 happyReduce_18,
 happyReduce_19,
 happyReduce_20,
 happyReduce_21,
 happyReduce_22,
 happyReduce_23,
 happyReduce_24,
 happyReduce_25,
 happyReduce_26,
 happyReduce_27,
 happyReduce_28,
 happyReduce_29,
 happyReduce_30,
 happyReduce_31,
 happyReduce_32,
 happyReduce_33,
 happyReduce_34,
 happyReduce_35,
 happyReduce_36,
 happyReduce_37,
 happyReduce_38,
 happyReduce_39,
 happyReduce_40,
 happyReduce_41,
 happyReduce_42,
 happyReduce_43,
 happyReduce_44,
 happyReduce_45,
 happyReduce_46,
 happyReduce_47,
 happyReduce_48,
 happyReduce_49,
 happyReduce_50,
 happyReduce_51,
 happyReduce_52,
 happyReduce_53,
 happyReduce_54,
 happyReduce_55,
 happyReduce_56,
 happyReduce_57,
 happyReduce_58,
 happyReduce_59,
 happyReduce_60,
 happyReduce_61,
 happyReduce_62,
 happyReduce_63,
 happyReduce_64,
 happyReduce_65,
 happyReduce_66,
 happyReduce_67,
 happyReduce_68,
 happyReduce_69,
 happyReduce_70,
 happyReduce_71,
 happyReduce_72,
 happyReduce_73,
 happyReduce_74,
 happyReduce_75,
 happyReduce_76,
 happyReduce_77,
 happyReduce_78,
 happyReduce_79,
 happyReduce_80,
 happyReduce_81,
 happyReduce_82,
 happyReduce_83,
 happyReduce_84,
 happyReduce_85,
 happyReduce_86,
 happyReduce_87,
 happyReduce_88,
 happyReduce_89,
 happyReduce_90,
 happyReduce_91,
 happyReduce_92,
 happyReduce_93,
 happyReduce_94,
 happyReduce_95,
 happyReduce_96,
 happyReduce_97,
 happyReduce_98,
 happyReduce_99,
 happyReduce_100,
 happyReduce_101,
 happyReduce_102,
 happyReduce_103,
 happyReduce_104,
 happyReduce_105,
 happyReduce_106,
 happyReduce_107,
 happyReduce_108,
 happyReduce_109,
 happyReduce_110,
 happyReduce_111,
 happyReduce_112,
 happyReduce_113,
 happyReduce_114,
 happyReduce_115,
 happyReduce_116,
 happyReduce_117,
 happyReduce_118,
 happyReduce_119,
 happyReduce_120,
 happyReduce_121,
 happyReduce_122,
 happyReduce_123,
 happyReduce_124,
 happyReduce_125,
 happyReduce_126,
 happyReduce_127,
 happyReduce_128,
 happyReduce_129,
 happyReduce_130,
 happyReduce_131,
 happyReduce_132,
 happyReduce_133,
 happyReduce_134,
 happyReduce_135,
 happyReduce_136,
 happyReduce_137,
 happyReduce_138,
 happyReduce_139,
 happyReduce_140,
 happyReduce_141,
 happyReduce_142,
 happyReduce_143,
 happyReduce_144,
 happyReduce_145,
 happyReduce_146,
 happyReduce_147,
 happyReduce_148,
 happyReduce_149,
 happyReduce_150,
 happyReduce_151,
 happyReduce_152,
 happyReduce_153,
 happyReduce_154,
 happyReduce_155,
 happyReduce_156,
 happyReduce_157,
 happyReduce_158,
 happyReduce_159,
 happyReduce_160,
 happyReduce_161,
 happyReduce_162,
 happyReduce_163,
 happyReduce_164,
 happyReduce_165,
 happyReduce_166,
 happyReduce_167,
 happyReduce_168,
 happyReduce_169,
 happyReduce_170,
 happyReduce_171,
 happyReduce_172,
 happyReduce_173,
 happyReduce_174,
 happyReduce_175,
 happyReduce_176,
 happyReduce_177,
 happyReduce_178,
 happyReduce_179,
 happyReduce_180,
 happyReduce_181,
 happyReduce_182,
 happyReduce_183,
 happyReduce_184,
 happyReduce_185,
 happyReduce_186,
 happyReduce_187,
 happyReduce_188,
 happyReduce_189,
 happyReduce_190,
 happyReduce_191,
 happyReduce_192,
 happyReduce_193,
 happyReduce_194,
 happyReduce_195,
 happyReduce_196,
 happyReduce_197,
 happyReduce_198,
 happyReduce_199,
 happyReduce_200,
 happyReduce_201,
 happyReduce_202,
 happyReduce_203,
 happyReduce_204,
 happyReduce_205,
 happyReduce_206,
 happyReduce_207,
 happyReduce_208,
 happyReduce_209,
 happyReduce_210,
 happyReduce_211,
 happyReduce_212,
 happyReduce_213,
 happyReduce_214,
 happyReduce_215,
 happyReduce_216,
 happyReduce_217,
 happyReduce_218,
 happyReduce_219,
 happyReduce_220,
 happyReduce_221,
 happyReduce_222,
 happyReduce_223,
 happyReduce_224,
 happyReduce_225,
 happyReduce_226,
 happyReduce_227,
 happyReduce_228,
 happyReduce_229,
 happyReduce_230,
 happyReduce_231,
 happyReduce_232,
 happyReduce_233,
 happyReduce_234,
 happyReduce_235,
 happyReduce_236,
 happyReduce_237,
 happyReduce_238,
 happyReduce_239,
 happyReduce_240,
 happyReduce_241,
 happyReduce_242,
 happyReduce_243,
 happyReduce_244,
 happyReduce_245,
 happyReduce_246,
 happyReduce_247,
 happyReduce_248,
 happyReduce_249,
 happyReduce_250,
 happyReduce_251,
 happyReduce_252,
 happyReduce_253,
 happyReduce_254,
 happyReduce_255,
 happyReduce_256,
 happyReduce_257,
 happyReduce_258,
 happyReduce_259,
 happyReduce_260,
 happyReduce_261,
 happyReduce_262,
 happyReduce_263,
 happyReduce_264,
 happyReduce_265,
 happyReduce_266,
 happyReduce_267,
 happyReduce_268,
 happyReduce_269,
 happyReduce_270,
 happyReduce_271,
 happyReduce_272,
 happyReduce_273,
 happyReduce_274,
 happyReduce_275,
 happyReduce_276,
 happyReduce_277,
 happyReduce_278,
 happyReduce_279,
 happyReduce_280,
 happyReduce_281,
 happyReduce_282,
 happyReduce_283,
 happyReduce_284,
 happyReduce_285,
 happyReduce_286,
 happyReduce_287 :: HappyReduction

action_0 (160#) = happyShift action_15
action_0 (163#) = happyShift action_16
action_0 (182#) = happyShift action_17
action_0 (183#) = happyShift action_18
action_0 (184#) = happyShift action_19
action_0 (185#) = happyShift action_20
action_0 (186#) = happyShift action_21
action_0 (187#) = happyShift action_22
action_0 (188#) = happyShift action_23
action_0 (189#) = happyShift action_24
action_0 (190#) = happyShift action_25
action_0 (191#) = happyShift action_26
action_0 (205#) = happyShift action_27
action_0 (207#) = happyShift action_28
action_0 (209#) = happyShift action_29
action_0 (211#) = happyShift action_30
action_0 (215#) = happyShift action_31
action_0 (216#) = happyShift action_32
action_0 (217#) = happyShift action_33
action_0 (218#) = happyShift action_34
action_0 (220#) = happyShift action_35
action_0 (222#) = happyShift action_36
action_0 (4#) = happyGoto action_1
action_0 (5#) = happyGoto action_2
action_0 (49#) = happyGoto action_3
action_0 (57#) = happyGoto action_4
action_0 (59#) = happyGoto action_5
action_0 (71#) = happyGoto action_6
action_0 (72#) = happyGoto action_7
action_0 (78#) = happyGoto action_8
action_0 (79#) = happyGoto action_9
action_0 (80#) = happyGoto action_10
action_0 (81#) = happyGoto action_11
action_0 (87#) = happyGoto action_12
action_0 (96#) = happyGoto action_13
action_0 (97#) = happyGoto action_14
action_0 x = happyTcHack x happyReduce_196

action_1 (231#) = happyAccept
action_1 x = happyTcHack x happyFail

action_2 x = happyTcHack x happyReduce_1

action_3 x = happyTcHack x happyReduce_2

action_4 (198#) = happyShift action_90
action_4 (205#) = happyShift action_27
action_4 (207#) = happyShift action_28
action_4 (209#) = happyShift action_29
action_4 (211#) = happyShift action_30
action_4 (215#) = happyShift action_31
action_4 (216#) = happyShift action_32
action_4 (217#) = happyShift action_33
action_4 (218#) = happyShift action_34
action_4 (220#) = happyShift action_35
action_4 (222#) = happyShift action_36
action_4 (59#) = happyGoto action_89
action_4 (71#) = happyGoto action_6
action_4 (72#) = happyGoto action_7
action_4 (78#) = happyGoto action_8
action_4 (79#) = happyGoto action_9
action_4 (80#) = happyGoto action_10
action_4 (81#) = happyGoto action_11
action_4 (87#) = happyGoto action_12
action_4 x = happyTcHack x happyReduce_98

action_5 x = happyTcHack x happyReduce_112

action_6 x = happyTcHack x happyReduce_167

action_7 x = happyTcHack x happyReduce_171

action_8 x = happyTcHack x happyReduce_168

action_9 x = happyTcHack x happyReduce_169

action_10 x = happyTcHack x happyReduce_170

action_11 x = happyTcHack x happyReduce_118

action_12 x = happyTcHack x happyReduce_119

action_13 x = happyTcHack x happyReduce_3

action_14 (184#) = happyShift action_19
action_14 (185#) = happyShift action_20
action_14 (186#) = happyShift action_21
action_14 (187#) = happyShift action_22
action_14 (188#) = happyShift action_23
action_14 (190#) = happyShift action_25
action_14 (96#) = happyGoto action_88
action_14 (97#) = happyGoto action_14
action_14 x = happyTcHack x happyReduce_196

action_15 (226#) = happyShift action_87
action_15 (61#) = happyGoto action_86
action_15 x = happyTcHack x happyReduce_129

action_16 (207#) = happyShift action_85
action_16 (51#) = happyGoto action_84
action_16 x = happyTcHack x happyFail

action_17 (202#) = happyShift action_81
action_17 (203#) = happyShift action_82
action_17 (215#) = happyShift action_83
action_17 (58#) = happyGoto action_79
action_17 (84#) = happyGoto action_80
action_17 x = happyTcHack x happyFail

action_18 (207#) = happyShift action_78
action_18 (50#) = happyGoto action_77
action_18 x = happyTcHack x happyFail

action_19 (227#) = happyShift action_76
action_19 x = happyTcHack x happyFail

action_20 (127#) = happyShift action_60
action_20 (135#) = happyShift action_61
action_20 (147#) = happyShift action_62
action_20 (151#) = happyShift action_63
action_20 (152#) = happyShift action_64
action_20 (153#) = happyShift action_65
action_20 (154#) = happyShift action_66
action_20 (155#) = happyShift action_67
action_20 (156#) = happyShift action_68
action_20 (157#) = happyShift action_69
action_20 (158#) = happyShift action_70
action_20 (159#) = happyShift action_71
action_20 (203#) = happyShift action_72
action_20 (215#) = happyShift action_73
action_20 (219#) = happyShift action_74
action_20 (221#) = happyShift action_75
action_20 (63#) = happyGoto action_55
action_20 (64#) = happyGoto action_56
action_20 (65#) = happyGoto action_57
action_20 (66#) = happyGoto action_58
action_20 (67#) = happyGoto action_59
action_20 x = happyTcHack x happyFail

action_21 x = happyTcHack x happyReduce_202

action_22 (207#) = happyShift action_54
action_22 (98#) = happyGoto action_53
action_22 x = happyTcHack x happyReduce_204

action_23 x = happyTcHack x happyReduce_201

action_24 (231#) = happyReduce_61
action_24 (32#) = happyGoto action_50
action_24 (33#) = happyGoto action_51
action_24 (125#) = happyGoto action_52
action_24 x = happyTcHack x happyReduce_285

action_25 x = happyTcHack x happyReduce_200

action_26 (35#) = happyGoto action_49
action_26 x = happyTcHack x happyReduce_65

action_27 (216#) = happyShift action_32
action_27 (218#) = happyShift action_34
action_27 (220#) = happyShift action_35
action_27 (222#) = happyShift action_36
action_27 (223#) = happyShift action_48
action_27 (68#) = happyGoto action_43
action_27 (71#) = happyGoto action_44
action_27 (72#) = happyGoto action_45
action_27 (82#) = happyGoto action_46
action_27 (83#) = happyGoto action_47
action_27 x = happyTcHack x happyFail

action_28 (163#) = happyShift action_16
action_28 (182#) = happyShift action_17
action_28 (183#) = happyShift action_18
action_28 (205#) = happyShift action_27
action_28 (207#) = happyShift action_28
action_28 (209#) = happyShift action_29
action_28 (211#) = happyShift action_30
action_28 (215#) = happyShift action_31
action_28 (216#) = happyShift action_32
action_28 (217#) = happyShift action_33
action_28 (218#) = happyShift action_34
action_28 (220#) = happyShift action_35
action_28 (222#) = happyShift action_36
action_28 (49#) = happyGoto action_42
action_28 (57#) = happyGoto action_4
action_28 (59#) = happyGoto action_5
action_28 (71#) = happyGoto action_6
action_28 (72#) = happyGoto action_7
action_28 (78#) = happyGoto action_8
action_28 (79#) = happyGoto action_9
action_28 (80#) = happyGoto action_10
action_28 (81#) = happyGoto action_11
action_28 (87#) = happyGoto action_12
action_28 x = happyTcHack x happyFail

action_29 (163#) = happyShift action_16
action_29 (182#) = happyShift action_17
action_29 (183#) = happyShift action_18
action_29 (205#) = happyShift action_27
action_29 (207#) = happyShift action_28
action_29 (209#) = happyShift action_29
action_29 (211#) = happyShift action_30
action_29 (215#) = happyShift action_31
action_29 (216#) = happyShift action_32
action_29 (217#) = happyShift action_33
action_29 (218#) = happyShift action_34
action_29 (220#) = happyShift action_35
action_29 (222#) = happyShift action_36
action_29 (49#) = happyGoto action_40
action_29 (56#) = happyGoto action_41
action_29 (57#) = happyGoto action_4
action_29 (59#) = happyGoto action_5
action_29 (71#) = happyGoto action_6
action_29 (72#) = happyGoto action_7
action_29 (78#) = happyGoto action_8
action_29 (79#) = happyGoto action_9
action_29 (80#) = happyGoto action_10
action_29 (81#) = happyGoto action_11
action_29 (87#) = happyGoto action_12
action_29 x = happyTcHack x happyFail

action_30 (163#) = happyShift action_16
action_30 (182#) = happyShift action_17
action_30 (183#) = happyShift action_18
action_30 (205#) = happyShift action_27
action_30 (207#) = happyShift action_28
action_30 (209#) = happyShift action_29
action_30 (211#) = happyShift action_30
action_30 (215#) = happyShift action_31
action_30 (216#) = happyShift action_32
action_30 (217#) = happyShift action_33
action_30 (218#) = happyShift action_34
action_30 (220#) = happyShift action_35
action_30 (222#) = happyShift action_36
action_30 (49#) = happyGoto action_37
action_30 (55#) = happyGoto action_38
action_30 (56#) = happyGoto action_39
action_30 (57#) = happyGoto action_4
action_30 (59#) = happyGoto action_5
action_30 (71#) = happyGoto action_6
action_30 (72#) = happyGoto action_7
action_30 (78#) = happyGoto action_8
action_30 (79#) = happyGoto action_9
action_30 (80#) = happyGoto action_10
action_30 (81#) = happyGoto action_11
action_30 (87#) = happyGoto action_12
action_30 x = happyTcHack x happyReduce_107

action_31 x = happyTcHack x happyReduce_179

action_32 x = happyTcHack x happyReduce_155

action_33 x = happyTcHack x happyReduce_180

action_34 x = happyTcHack x happyReduce_156

action_35 x = happyTcHack x happyReduce_157

action_36 x = happyTcHack x happyReduce_158

action_37 (214#) = happyShift action_155
action_37 x = happyTcHack x happyReduce_108

action_38 (212#) = happyShift action_156
action_38 x = happyTcHack x happyFail

action_39 x = happyTcHack x happyReduce_109

action_40 (210#) = happyShift action_154
action_40 (214#) = happyShift action_155
action_40 x = happyTcHack x happyFail

action_41 (210#) = happyShift action_153
action_41 x = happyTcHack x happyFail

action_42 (208#) = happyShift action_152
action_42 x = happyTcHack x happyFail

action_43 (193#) = happyShift action_151
action_43 x = happyTcHack x happyFail

action_44 x = happyTcHack x happyReduce_172

action_45 x = happyTcHack x happyReduce_174

action_46 x = happyTcHack x happyReduce_173

action_47 (205#) = happyShift action_27
action_47 (207#) = happyShift action_28
action_47 (209#) = happyShift action_29
action_47 (211#) = happyShift action_30
action_47 (215#) = happyShift action_31
action_47 (216#) = happyShift action_32
action_47 (217#) = happyShift action_33
action_47 (218#) = happyShift action_34
action_47 (220#) = happyShift action_35
action_47 (222#) = happyShift action_36
action_47 (59#) = happyGoto action_149
action_47 (60#) = happyGoto action_150
action_47 (71#) = happyGoto action_6
action_47 (72#) = happyGoto action_7
action_47 (78#) = happyGoto action_8
action_47 (79#) = happyGoto action_9
action_47 (80#) = happyGoto action_10
action_47 (81#) = happyGoto action_11
action_47 (87#) = happyGoto action_12
action_47 x = happyTcHack x happyReduce_126

action_48 x = happyTcHack x happyReduce_151

action_49 (127#) = happyShift action_60
action_49 (135#) = happyShift action_61
action_49 (147#) = happyShift action_62
action_49 (151#) = happyShift action_63
action_49 (152#) = happyShift action_64
action_49 (153#) = happyShift action_65
action_49 (154#) = happyShift action_66
action_49 (155#) = happyShift action_67
action_49 (156#) = happyShift action_68
action_49 (157#) = happyShift action_69
action_49 (158#) = happyShift action_70
action_49 (159#) = happyShift action_71
action_49 (203#) = happyShift action_72
action_49 (215#) = happyShift action_73
action_49 (216#) = happyShift action_32
action_49 (218#) = happyShift action_34
action_49 (226#) = happyShift action_148
action_49 (36#) = happyGoto action_144
action_49 (37#) = happyGoto action_145
action_49 (63#) = happyGoto action_55
action_49 (65#) = happyGoto action_57
action_49 (66#) = happyGoto action_146
action_49 (71#) = happyGoto action_107
action_49 (73#) = happyGoto action_109
action_49 (74#) = happyGoto action_147
action_49 x = happyTcHack x happyReduce_5

action_50 x = happyTcHack x happyReduce_4

action_51 (213#) = happyShift action_143
action_51 x = happyTcHack x happyFail

action_52 (226#) = happyShift action_142
action_52 x = happyTcHack x happyFail

action_53 (127#) = happyShift action_60
action_53 (128#) = happyShift action_119
action_53 (135#) = happyShift action_61
action_53 (143#) = happyShift action_120
action_53 (147#) = happyShift action_62
action_53 (151#) = happyShift action_63
action_53 (152#) = happyShift action_64
action_53 (153#) = happyShift action_65
action_53 (154#) = happyShift action_66
action_53 (155#) = happyShift action_67
action_53 (156#) = happyShift action_68
action_53 (157#) = happyShift action_69
action_53 (158#) = happyShift action_70
action_53 (159#) = happyShift action_71
action_53 (164#) = happyShift action_121
action_53 (165#) = happyShift action_122
action_53 (166#) = happyShift action_123
action_53 (167#) = happyShift action_124
action_53 (171#) = happyShift action_125
action_53 (172#) = happyShift action_126
action_53 (173#) = happyShift action_127
action_53 (174#) = happyShift action_128
action_53 (176#) = happyShift action_129
action_53 (177#) = happyShift action_130
action_53 (180#) = happyShift action_131
action_53 (181#) = happyShift action_132
action_53 (195#) = happyShift action_133
action_53 (202#) = happyShift action_134
action_53 (203#) = happyShift action_72
action_53 (205#) = happyShift action_135
action_53 (209#) = happyShift action_136
action_53 (211#) = happyShift action_137
action_53 (215#) = happyShift action_73
action_53 (216#) = happyShift action_32
action_53 (218#) = happyShift action_34
action_53 (219#) = happyShift action_74
action_53 (220#) = happyShift action_35
action_53 (221#) = happyShift action_75
action_53 (222#) = happyShift action_36
action_53 (225#) = happyShift action_138
action_53 (226#) = happyShift action_139
action_53 (227#) = happyShift action_140
action_53 (228#) = happyShift action_141
action_53 (63#) = happyGoto action_55
action_53 (64#) = happyGoto action_56
action_53 (65#) = happyGoto action_57
action_53 (66#) = happyGoto action_58
action_53 (67#) = happyGoto action_106
action_53 (71#) = happyGoto action_107
action_53 (72#) = happyGoto action_108
action_53 (73#) = happyGoto action_109
action_53 (74#) = happyGoto action_110
action_53 (75#) = happyGoto action_111
action_53 (99#) = happyGoto action_112
action_53 (100#) = happyGoto action_113
action_53 (103#) = happyGoto action_114
action_53 (113#) = happyGoto action_115
action_53 (114#) = happyGoto action_116
action_53 (115#) = happyGoto action_117
action_53 (121#) = happyGoto action_118
action_53 x = happyTcHack x happyFail

action_54 (203#) = happyShift action_104
action_54 (227#) = happyShift action_105
action_54 x = happyTcHack x happyFail

action_55 x = happyTcHack x happyReduce_147

action_56 x = happyTcHack x happyReduce_150

action_57 x = happyTcHack x happyReduce_148

action_58 x = happyTcHack x happyReduce_149

action_59 x = happyTcHack x happyReduce_203

action_60 x = happyTcHack x happyReduce_133

action_61 x = happyTcHack x happyReduce_135

action_62 x = happyTcHack x happyReduce_134

action_63 x = happyTcHack x happyReduce_136

action_64 x = happyTcHack x happyReduce_137

action_65 x = happyTcHack x happyReduce_138

action_66 x = happyTcHack x happyReduce_139

action_67 x = happyTcHack x happyReduce_140

action_68 x = happyTcHack x happyReduce_141

action_69 x = happyTcHack x happyReduce_142

action_70 x = happyTcHack x happyReduce_144

action_71 x = happyTcHack x happyReduce_143

action_72 x = happyTcHack x happyReduce_132

action_73 x = happyTcHack x happyReduce_131

action_74 x = happyTcHack x happyReduce_145

action_75 x = happyTcHack x happyReduce_146

action_76 x = happyTcHack x happyReduce_198

action_77 (201#) = happyShift action_103
action_77 x = happyTcHack x happyFail

action_78 (215#) = happyShift action_83
action_78 (84#) = happyGoto action_100
action_78 (85#) = happyGoto action_101
action_78 (86#) = happyGoto action_102
action_78 x = happyTcHack x happyReduce_177

action_79 (205#) = happyShift action_27
action_79 (207#) = happyShift action_28
action_79 (209#) = happyShift action_29
action_79 (211#) = happyShift action_30
action_79 (215#) = happyShift action_31
action_79 (216#) = happyShift action_32
action_79 (217#) = happyShift action_33
action_79 (218#) = happyShift action_34
action_79 (220#) = happyShift action_35
action_79 (222#) = happyShift action_36
action_79 (59#) = happyGoto action_99
action_79 (71#) = happyGoto action_6
action_79 (72#) = happyGoto action_7
action_79 (78#) = happyGoto action_8
action_79 (79#) = happyGoto action_9
action_79 (80#) = happyGoto action_10
action_79 (81#) = happyGoto action_11
action_79 (87#) = happyGoto action_12
action_79 x = happyTcHack x happyFail

action_80 x = happyTcHack x happyReduce_117

action_81 x = happyTcHack x happyReduce_115

action_82 x = happyTcHack x happyReduce_116

action_83 x = happyTcHack x happyReduce_175

action_84 (205#) = happyShift action_98
action_84 (52#) = happyGoto action_97
action_84 x = happyTcHack x happyReduce_101

action_85 (215#) = happyShift action_31
action_85 (217#) = happyShift action_33
action_85 (87#) = happyGoto action_94
action_85 (88#) = happyGoto action_95
action_85 (89#) = happyGoto action_96
action_85 x = happyTcHack x happyReduce_183

action_86 (216#) = happyShift action_93
action_86 (62#) = happyGoto action_92
action_86 x = happyTcHack x happyFail

action_87 x = happyTcHack x happyReduce_128

action_88 x = happyTcHack x happyReduce_197

action_89 x = happyTcHack x happyReduce_113

action_90 (163#) = happyShift action_16
action_90 (182#) = happyShift action_17
action_90 (183#) = happyShift action_18
action_90 (205#) = happyShift action_27
action_90 (207#) = happyShift action_28
action_90 (209#) = happyShift action_29
action_90 (211#) = happyShift action_30
action_90 (215#) = happyShift action_31
action_90 (216#) = happyShift action_32
action_90 (217#) = happyShift action_33
action_90 (218#) = happyShift action_34
action_90 (220#) = happyShift action_35
action_90 (222#) = happyShift action_36
action_90 (49#) = happyGoto action_91
action_90 (57#) = happyGoto action_4
action_90 (59#) = happyGoto action_5
action_90 (71#) = happyGoto action_6
action_90 (72#) = happyGoto action_7
action_90 (78#) = happyGoto action_8
action_90 (79#) = happyGoto action_9
action_90 (80#) = happyGoto action_10
action_90 (81#) = happyGoto action_11
action_90 (87#) = happyGoto action_12
action_90 x = happyTcHack x happyFail

action_91 x = happyTcHack x happyReduce_97

action_92 (227#) = happyShift action_214
action_92 x = happyTcHack x happyFail

action_93 x = happyTcHack x happyReduce_130

action_94 (193#) = happyShift action_213
action_94 x = happyTcHack x happyReduce_182

action_95 (215#) = happyShift action_31
action_95 (217#) = happyShift action_33
action_95 (87#) = happyGoto action_94
action_95 (88#) = happyGoto action_95
action_95 (89#) = happyGoto action_212
action_95 x = happyTcHack x happyReduce_183

action_96 (208#) = happyShift action_211
action_96 x = happyTcHack x happyFail

action_97 (201#) = happyShift action_210
action_97 x = happyTcHack x happyFail

action_98 (216#) = happyShift action_32
action_98 (218#) = happyShift action_34
action_98 (220#) = happyShift action_35
action_98 (222#) = happyShift action_36
action_98 (223#) = happyShift action_48
action_98 (53#) = happyGoto action_206
action_98 (54#) = happyGoto action_207
action_98 (68#) = happyGoto action_208
action_98 (71#) = happyGoto action_44
action_98 (72#) = happyGoto action_45
action_98 (82#) = happyGoto action_46
action_98 (83#) = happyGoto action_209
action_98 x = happyTcHack x happyFail

action_99 x = happyTcHack x happyReduce_114

action_100 x = happyTcHack x happyReduce_176

action_101 (215#) = happyShift action_83
action_101 (84#) = happyGoto action_100
action_101 (85#) = happyGoto action_101
action_101 (86#) = happyGoto action_205
action_101 x = happyTcHack x happyReduce_177

action_102 (208#) = happyShift action_204
action_102 x = happyTcHack x happyFail

action_103 (163#) = happyShift action_16
action_103 (182#) = happyShift action_17
action_103 (183#) = happyShift action_18
action_103 (205#) = happyShift action_27
action_103 (207#) = happyShift action_28
action_103 (209#) = happyShift action_29
action_103 (211#) = happyShift action_30
action_103 (215#) = happyShift action_31
action_103 (216#) = happyShift action_32
action_103 (217#) = happyShift action_33
action_103 (218#) = happyShift action_34
action_103 (220#) = happyShift action_35
action_103 (222#) = happyShift action_36
action_103 (49#) = happyGoto action_203
action_103 (57#) = happyGoto action_4
action_103 (59#) = happyGoto action_5
action_103 (71#) = happyGoto action_6
action_103 (72#) = happyGoto action_7
action_103 (78#) = happyGoto action_8
action_103 (79#) = happyGoto action_9
action_103 (80#) = happyGoto action_10
action_103 (81#) = happyGoto action_11
action_103 (87#) = happyGoto action_12
action_103 x = happyTcHack x happyFail

action_104 (227#) = happyShift action_202
action_104 x = happyTcHack x happyFail

action_105 (208#) = happyShift action_201
action_105 x = happyTcHack x happyFail

action_106 x = happyTcHack x happyReduce_223

action_107 x = happyTcHack x happyReduce_159

action_108 x = happyTcHack x happyReduce_162

action_109 x = happyTcHack x happyReduce_160

action_110 x = happyTcHack x happyReduce_161

action_111 x = happyTcHack x happyReduce_224

action_112 x = happyTcHack x happyReduce_199

action_113 (127#) = happyShift action_60
action_113 (135#) = happyShift action_61
action_113 (147#) = happyShift action_62
action_113 (151#) = happyShift action_63
action_113 (152#) = happyShift action_64
action_113 (153#) = happyShift action_65
action_113 (154#) = happyShift action_66
action_113 (155#) = happyShift action_67
action_113 (156#) = happyShift action_68
action_113 (157#) = happyShift action_69
action_113 (158#) = happyShift action_70
action_113 (159#) = happyShift action_71
action_113 (171#) = happyShift action_125
action_113 (172#) = happyShift action_126
action_113 (173#) = happyShift action_127
action_113 (174#) = happyShift action_128
action_113 (176#) = happyShift action_129
action_113 (199#) = happyShift action_200
action_113 (202#) = happyShift action_134
action_113 (203#) = happyShift action_72
action_113 (205#) = happyShift action_135
action_113 (209#) = happyShift action_136
action_113 (211#) = happyShift action_137
action_113 (215#) = happyShift action_73
action_113 (216#) = happyShift action_32
action_113 (218#) = happyShift action_34
action_113 (219#) = happyShift action_74
action_113 (220#) = happyShift action_35
action_113 (221#) = happyShift action_75
action_113 (222#) = happyShift action_36
action_113 (225#) = happyShift action_138
action_113 (226#) = happyShift action_139
action_113 (227#) = happyShift action_140
action_113 (228#) = happyShift action_141
action_113 (63#) = happyGoto action_55
action_113 (64#) = happyGoto action_56
action_113 (65#) = happyGoto action_57
action_113 (66#) = happyGoto action_58
action_113 (67#) = happyGoto action_106
action_113 (71#) = happyGoto action_107
action_113 (72#) = happyGoto action_108
action_113 (73#) = happyGoto action_109
action_113 (74#) = happyGoto action_110
action_113 (75#) = happyGoto action_111
action_113 (101#) = happyGoto action_198
action_113 (103#) = happyGoto action_199
action_113 (113#) = happyGoto action_115
action_113 (114#) = happyGoto action_116
action_113 (115#) = happyGoto action_117
action_113 x = happyTcHack x happyReduce_216

action_114 x = happyTcHack x happyReduce_218

action_115 x = happyTcHack x happyReduce_225

action_116 x = happyTcHack x happyReduce_253

action_117 x = happyTcHack x happyReduce_256

action_118 (127#) = happyShift action_60
action_118 (128#) = happyShift action_119
action_118 (135#) = happyShift action_61
action_118 (143#) = happyShift action_120
action_118 (147#) = happyShift action_62
action_118 (151#) = happyShift action_63
action_118 (152#) = happyShift action_64
action_118 (153#) = happyShift action_65
action_118 (154#) = happyShift action_66
action_118 (155#) = happyShift action_67
action_118 (156#) = happyShift action_68
action_118 (157#) = happyShift action_69
action_118 (158#) = happyShift action_70
action_118 (159#) = happyShift action_71
action_118 (164#) = happyShift action_121
action_118 (165#) = happyShift action_122
action_118 (166#) = happyShift action_123
action_118 (167#) = happyShift action_124
action_118 (171#) = happyShift action_125
action_118 (172#) = happyShift action_126
action_118 (173#) = happyShift action_127
action_118 (174#) = happyShift action_128
action_118 (176#) = happyShift action_129
action_118 (177#) = happyShift action_130
action_118 (180#) = happyShift action_131
action_118 (181#) = happyShift action_132
action_118 (195#) = happyShift action_133
action_118 (202#) = happyShift action_134
action_118 (203#) = happyShift action_72
action_118 (205#) = happyShift action_135
action_118 (209#) = happyShift action_136
action_118 (211#) = happyShift action_137
action_118 (215#) = happyShift action_73
action_118 (216#) = happyShift action_32
action_118 (218#) = happyShift action_34
action_118 (219#) = happyShift action_74
action_118 (220#) = happyShift action_35
action_118 (221#) = happyShift action_75
action_118 (222#) = happyShift action_36
action_118 (225#) = happyShift action_138
action_118 (226#) = happyShift action_139
action_118 (227#) = happyShift action_140
action_118 (228#) = happyShift action_141
action_118 (63#) = happyGoto action_55
action_118 (64#) = happyGoto action_56
action_118 (65#) = happyGoto action_57
action_118 (66#) = happyGoto action_58
action_118 (67#) = happyGoto action_106
action_118 (71#) = happyGoto action_107
action_118 (72#) = happyGoto action_108
action_118 (73#) = happyGoto action_109
action_118 (74#) = happyGoto action_110
action_118 (75#) = happyGoto action_111
action_118 (99#) = happyGoto action_197
action_118 (100#) = happyGoto action_113
action_118 (103#) = happyGoto action_114
action_118 (113#) = happyGoto action_115
action_118 (114#) = happyGoto action_116
action_118 (115#) = happyGoto action_117
action_118 (121#) = happyGoto action_118
action_118 x = happyTcHack x happyFail

action_119 (127#) = happyShift action_60
action_119 (128#) = happyShift action_119
action_119 (135#) = happyShift action_61
action_119 (143#) = happyShift action_120
action_119 (147#) = happyShift action_62
action_119 (151#) = happyShift action_63
action_119 (152#) = happyShift action_64
action_119 (153#) = happyShift action_65
action_119 (154#) = happyShift action_66
action_119 (155#) = happyShift action_67
action_119 (156#) = happyShift action_68
action_119 (157#) = happyShift action_69
action_119 (158#) = happyShift action_70
action_119 (159#) = happyShift action_71
action_119 (164#) = happyShift action_121
action_119 (165#) = happyShift action_122
action_119 (166#) = happyShift action_123
action_119 (167#) = happyShift action_124
action_119 (171#) = happyShift action_125
action_119 (172#) = happyShift action_126
action_119 (173#) = happyShift action_127
action_119 (174#) = happyShift action_128
action_119 (176#) = happyShift action_129
action_119 (177#) = happyShift action_130
action_119 (180#) = happyShift action_131
action_119 (181#) = happyShift action_132
action_119 (195#) = happyShift action_133
action_119 (202#) = happyShift action_134
action_119 (203#) = happyShift action_72
action_119 (205#) = happyShift action_135
action_119 (209#) = happyShift action_136
action_119 (211#) = happyShift action_137
action_119 (215#) = happyShift action_73
action_119 (216#) = happyShift action_32
action_119 (218#) = happyShift action_34
action_119 (219#) = happyShift action_74
action_119 (220#) = happyShift action_35
action_119 (221#) = happyShift action_75
action_119 (222#) = happyShift action_36
action_119 (225#) = happyShift action_138
action_119 (226#) = happyShift action_139
action_119 (227#) = happyShift action_140
action_119 (228#) = happyShift action_141
action_119 (63#) = happyGoto action_55
action_119 (64#) = happyGoto action_56
action_119 (65#) = happyGoto action_57
action_119 (66#) = happyGoto action_58
action_119 (67#) = happyGoto action_106
action_119 (71#) = happyGoto action_107
action_119 (72#) = happyGoto action_108
action_119 (73#) = happyGoto action_109
action_119 (74#) = happyGoto action_110
action_119 (75#) = happyGoto action_111
action_119 (99#) = happyGoto action_196
action_119 (100#) = happyGoto action_113
action_119 (103#) = happyGoto action_114
action_119 (113#) = happyGoto action_115
action_119 (114#) = happyGoto action_116
action_119 (115#) = happyGoto action_117
action_119 (121#) = happyGoto action_118
action_119 x = happyTcHack x happyFail

action_120 (205#) = happyShift action_195
action_120 x = happyTcHack x happyFail

action_121 (205#) = happyShift action_194
action_121 x = happyTcHack x happyFail

action_122 (205#) = happyShift action_27
action_122 (207#) = happyShift action_28
action_122 (209#) = happyShift action_29
action_122 (211#) = happyShift action_30
action_122 (215#) = happyShift action_31
action_122 (216#) = happyShift action_32
action_122 (217#) = happyShift action_33
action_122 (218#) = happyShift action_34
action_122 (220#) = happyShift action_35
action_122 (222#) = happyShift action_36
action_122 (59#) = happyGoto action_193
action_122 (71#) = happyGoto action_6
action_122 (72#) = happyGoto action_7
action_122 (78#) = happyGoto action_8
action_122 (79#) = happyGoto action_9
action_122 (80#) = happyGoto action_10
action_122 (81#) = happyGoto action_11
action_122 (87#) = happyGoto action_12
action_122 x = happyTcHack x happyFail

action_123 (127#) = happyShift action_60
action_123 (128#) = happyShift action_119
action_123 (135#) = happyShift action_61
action_123 (143#) = happyShift action_120
action_123 (147#) = happyShift action_62
action_123 (151#) = happyShift action_63
action_123 (152#) = happyShift action_64
action_123 (153#) = happyShift action_65
action_123 (154#) = happyShift action_66
action_123 (155#) = happyShift action_67
action_123 (156#) = happyShift action_68
action_123 (157#) = happyShift action_69
action_123 (158#) = happyShift action_70
action_123 (159#) = happyShift action_71
action_123 (164#) = happyShift action_121
action_123 (165#) = happyShift action_122
action_123 (166#) = happyShift action_123
action_123 (167#) = happyShift action_124
action_123 (171#) = happyShift action_125
action_123 (172#) = happyShift action_126
action_123 (173#) = happyShift action_127
action_123 (174#) = happyShift action_128
action_123 (176#) = happyShift action_129
action_123 (177#) = happyShift action_130
action_123 (180#) = happyShift action_131
action_123 (181#) = happyShift action_132
action_123 (195#) = happyShift action_133
action_123 (202#) = happyShift action_134
action_123 (203#) = happyShift action_72
action_123 (205#) = happyShift action_135
action_123 (209#) = happyShift action_136
action_123 (211#) = happyShift action_137
action_123 (215#) = happyShift action_73
action_123 (216#) = happyShift action_32
action_123 (218#) = happyShift action_34
action_123 (219#) = happyShift action_74
action_123 (220#) = happyShift action_35
action_123 (221#) = happyShift action_75
action_123 (222#) = happyShift action_36
action_123 (225#) = happyShift action_138
action_123 (226#) = happyShift action_139
action_123 (227#) = happyShift action_140
action_123 (228#) = happyShift action_141
action_123 (63#) = happyGoto action_55
action_123 (64#) = happyGoto action_56
action_123 (65#) = happyGoto action_57
action_123 (66#) = happyGoto action_58
action_123 (67#) = happyGoto action_106
action_123 (71#) = happyGoto action_107
action_123 (72#) = happyGoto action_108
action_123 (73#) = happyGoto action_109
action_123 (74#) = happyGoto action_110
action_123 (75#) = happyGoto action_111
action_123 (99#) = happyGoto action_192
action_123 (100#) = happyGoto action_113
action_123 (103#) = happyGoto action_114
action_123 (113#) = happyGoto action_115
action_123 (114#) = happyGoto action_116
action_123 (115#) = happyGoto action_117
action_123 (121#) = happyGoto action_118
action_123 x = happyTcHack x happyFail

action_124 (127#) = happyShift action_60
action_124 (128#) = happyShift action_119
action_124 (135#) = happyShift action_61
action_124 (143#) = happyShift action_120
action_124 (147#) = happyShift action_62
action_124 (151#) = happyShift action_63
action_124 (152#) = happyShift action_64
action_124 (153#) = happyShift action_65
action_124 (154#) = happyShift action_66
action_124 (155#) = happyShift action_67
action_124 (156#) = happyShift action_68
action_124 (157#) = happyShift action_69
action_124 (158#) = happyShift action_70
action_124 (159#) = happyShift action_71
action_124 (164#) = happyShift action_121
action_124 (165#) = happyShift action_122
action_124 (166#) = happyShift action_123
action_124 (167#) = happyShift action_124
action_124 (171#) = happyShift action_125
action_124 (172#) = happyShift action_126
action_124 (173#) = happyShift action_127
action_124 (174#) = happyShift action_128
action_124 (176#) = happyShift action_129
action_124 (177#) = happyShift action_130
action_124 (180#) = happyShift action_131
action_124 (181#) = happyShift action_132
action_124 (195#) = happyShift action_133
action_124 (202#) = happyShift action_134
action_124 (203#) = happyShift action_72
action_124 (205#) = happyShift action_135
action_124 (209#) = happyShift action_136
action_124 (211#) = happyShift action_137
action_124 (215#) = happyShift action_73
action_124 (216#) = happyShift action_32
action_124 (218#) = happyShift action_34
action_124 (219#) = happyShift action_74
action_124 (220#) = happyShift action_35
action_124 (221#) = happyShift action_75
action_124 (222#) = happyShift action_36
action_124 (225#) = happyShift action_138
action_124 (226#) = happyShift action_139
action_124 (227#) = happyShift action_140
action_124 (228#) = happyShift action_141
action_124 (63#) = happyGoto action_55
action_124 (64#) = happyGoto action_56
action_124 (65#) = happyGoto action_57
action_124 (66#) = happyGoto action_58
action_124 (67#) = happyGoto action_106
action_124 (71#) = happyGoto action_107
action_124 (72#) = happyGoto action_108
action_124 (73#) = happyGoto action_109
action_124 (74#) = happyGoto action_110
action_124 (75#) = happyGoto action_111
action_124 (99#) = happyGoto action_191
action_124 (100#) = happyGoto action_113
action_124 (103#) = happyGoto action_114
action_124 (113#) = happyGoto action_115
action_124 (114#) = happyGoto action_116
action_124 (115#) = happyGoto action_117
action_124 (121#) = happyGoto action_118
action_124 x = happyTcHack x happyFail

action_125 (202#) = happyShift action_190
action_125 (228#) = happyShift action_141
action_125 (115#) = happyGoto action_189
action_125 x = happyTcHack x happyFail

action_126 (202#) = happyShift action_185
action_126 (227#) = happyShift action_140
action_126 (114#) = happyGoto action_188
action_126 x = happyTcHack x happyFail

action_127 (202#) = happyShift action_185
action_127 (227#) = happyShift action_140
action_127 (114#) = happyGoto action_187
action_127 x = happyTcHack x happyFail

action_128 (202#) = happyShift action_185
action_128 (227#) = happyShift action_140
action_128 (114#) = happyGoto action_186
action_128 x = happyTcHack x happyFail

action_129 (202#) = happyShift action_185
action_129 (227#) = happyShift action_140
action_129 (114#) = happyGoto action_184
action_129 x = happyTcHack x happyFail

action_130 (226#) = happyShift action_183
action_130 x = happyTcHack x happyFail

action_131 (205#) = happyShift action_182
action_131 x = happyTcHack x happyFail

action_132 (205#) = happyShift action_181
action_132 x = happyTcHack x happyFail

action_133 (127#) = happyShift action_60
action_133 (135#) = happyShift action_61
action_133 (147#) = happyShift action_62
action_133 (151#) = happyShift action_63
action_133 (152#) = happyShift action_64
action_133 (153#) = happyShift action_65
action_133 (154#) = happyShift action_66
action_133 (155#) = happyShift action_67
action_133 (156#) = happyShift action_68
action_133 (157#) = happyShift action_69
action_133 (158#) = happyShift action_70
action_133 (159#) = happyShift action_71
action_133 (199#) = happyShift action_180
action_133 (203#) = happyShift action_72
action_133 (215#) = happyShift action_73
action_133 (63#) = happyGoto action_55
action_133 (65#) = happyGoto action_57
action_133 (66#) = happyGoto action_175
action_133 (116#) = happyGoto action_176
action_133 (117#) = happyGoto action_177
action_133 (118#) = happyGoto action_178
action_133 (119#) = happyGoto action_179
action_133 x = happyTcHack x happyReduce_268

action_134 (227#) = happyShift action_173
action_134 (228#) = happyShift action_174
action_134 x = happyTcHack x happyFail

action_135 (179#) = happyShift action_172
action_135 x = happyTcHack x happyFail

action_136 (127#) = happyShift action_60
action_136 (128#) = happyShift action_119
action_136 (135#) = happyShift action_61
action_136 (143#) = happyShift action_120
action_136 (147#) = happyShift action_62
action_136 (151#) = happyShift action_63
action_136 (152#) = happyShift action_64
action_136 (153#) = happyShift action_65
action_136 (154#) = happyShift action_66
action_136 (155#) = happyShift action_67
action_136 (156#) = happyShift action_68
action_136 (157#) = happyShift action_69
action_136 (158#) = happyShift action_70
action_136 (159#) = happyShift action_71
action_136 (164#) = happyShift action_121
action_136 (165#) = happyShift action_122
action_136 (166#) = happyShift action_123
action_136 (167#) = happyShift action_124
action_136 (171#) = happyShift action_125
action_136 (172#) = happyShift action_126
action_136 (173#) = happyShift action_127
action_136 (174#) = happyShift action_128
action_136 (176#) = happyShift action_129
action_136 (177#) = happyShift action_130
action_136 (180#) = happyShift action_131
action_136 (181#) = happyShift action_132
action_136 (195#) = happyShift action_133
action_136 (202#) = happyShift action_134
action_136 (203#) = happyShift action_72
action_136 (205#) = happyShift action_135
action_136 (209#) = happyShift action_136
action_136 (211#) = happyShift action_137
action_136 (215#) = happyShift action_73
action_136 (216#) = happyShift action_32
action_136 (218#) = happyShift action_34
action_136 (219#) = happyShift action_74
action_136 (220#) = happyShift action_35
action_136 (221#) = happyShift action_75
action_136 (222#) = happyShift action_36
action_136 (225#) = happyShift action_138
action_136 (226#) = happyShift action_139
action_136 (227#) = happyShift action_140
action_136 (228#) = happyShift action_141
action_136 (63#) = happyGoto action_55
action_136 (64#) = happyGoto action_56
action_136 (65#) = happyGoto action_57
action_136 (66#) = happyGoto action_58
action_136 (67#) = happyGoto action_106
action_136 (71#) = happyGoto action_107
action_136 (72#) = happyGoto action_108
action_136 (73#) = happyGoto action_109
action_136 (74#) = happyGoto action_110
action_136 (75#) = happyGoto action_111
action_136 (99#) = happyGoto action_170
action_136 (100#) = happyGoto action_113
action_136 (103#) = happyGoto action_114
action_136 (105#) = happyGoto action_171
action_136 (113#) = happyGoto action_115
action_136 (114#) = happyGoto action_116
action_136 (115#) = happyGoto action_117
action_136 (121#) = happyGoto action_118
action_136 x = happyTcHack x happyFail

action_137 (127#) = happyShift action_60
action_137 (128#) = happyShift action_119
action_137 (135#) = happyShift action_61
action_137 (143#) = happyShift action_120
action_137 (147#) = happyShift action_62
action_137 (151#) = happyShift action_63
action_137 (152#) = happyShift action_64
action_137 (153#) = happyShift action_65
action_137 (154#) = happyShift action_66
action_137 (155#) = happyShift action_67
action_137 (156#) = happyShift action_68
action_137 (157#) = happyShift action_69
action_137 (158#) = happyShift action_70
action_137 (159#) = happyShift action_71
action_137 (164#) = happyShift action_121
action_137 (165#) = happyShift action_122
action_137 (166#) = happyShift action_123
action_137 (167#) = happyShift action_124
action_137 (171#) = happyShift action_125
action_137 (172#) = happyShift action_126
action_137 (173#) = happyShift action_127
action_137 (174#) = happyShift action_128
action_137 (176#) = happyShift action_129
action_137 (177#) = happyShift action_130
action_137 (180#) = happyShift action_131
action_137 (181#) = happyShift action_132
action_137 (195#) = happyShift action_133
action_137 (202#) = happyShift action_134
action_137 (203#) = happyShift action_72
action_137 (205#) = happyShift action_135
action_137 (209#) = happyShift action_136
action_137 (211#) = happyShift action_137
action_137 (215#) = happyShift action_73
action_137 (216#) = happyShift action_32
action_137 (218#) = happyShift action_34
action_137 (219#) = happyShift action_74
action_137 (220#) = happyShift action_35
action_137 (221#) = happyShift action_75
action_137 (222#) = happyShift action_36
action_137 (225#) = happyShift action_138
action_137 (226#) = happyShift action_139
action_137 (227#) = happyShift action_140
action_137 (228#) = happyShift action_141
action_137 (63#) = happyGoto action_55
action_137 (64#) = happyGoto action_56
action_137 (65#) = happyGoto action_57
action_137 (66#) = happyGoto action_58
action_137 (67#) = happyGoto action_106
action_137 (71#) = happyGoto action_107
action_137 (72#) = happyGoto action_108
action_137 (73#) = happyGoto action_109
action_137 (74#) = happyGoto action_110
action_137 (75#) = happyGoto action_111
action_137 (99#) = happyGoto action_167
action_137 (100#) = happyGoto action_113
action_137 (103#) = happyGoto action_114
action_137 (104#) = happyGoto action_168
action_137 (105#) = happyGoto action_169
action_137 (113#) = happyGoto action_115
action_137 (114#) = happyGoto action_116
action_137 (115#) = happyGoto action_117
action_137 (121#) = happyGoto action_118
action_137 x = happyTcHack x happyReduce_230

action_138 x = happyTcHack x happyReduce_254

action_139 x = happyTcHack x happyReduce_255

action_140 x = happyTcHack x happyReduce_262

action_141 x = happyTcHack x happyReduce_264

action_142 (163#) = happyShift action_166
action_142 (34#) = happyGoto action_165
action_142 x = happyTcHack x happyFail

action_143 (231#) = happyReduce_61
action_143 (32#) = happyGoto action_164
action_143 (33#) = happyGoto action_51
action_143 (125#) = happyGoto action_52
action_143 x = happyTcHack x happyReduce_285

action_144 (213#) = happyShift action_163
action_144 x = happyTcHack x happyFail

action_145 (226#) = happyShift action_162
action_145 x = happyTcHack x happyFail

action_146 x = happyTcHack x happyReduce_69

action_147 x = happyTcHack x happyReduce_70

action_148 x = happyTcHack x happyReduce_67

action_149 (205#) = happyShift action_27
action_149 (207#) = happyShift action_28
action_149 (209#) = happyShift action_29
action_149 (211#) = happyShift action_30
action_149 (215#) = happyShift action_31
action_149 (216#) = happyShift action_32
action_149 (217#) = happyShift action_33
action_149 (218#) = happyShift action_34
action_149 (220#) = happyShift action_35
action_149 (222#) = happyShift action_36
action_149 (59#) = happyGoto action_149
action_149 (60#) = happyGoto action_161
action_149 (71#) = happyGoto action_6
action_149 (72#) = happyGoto action_7
action_149 (78#) = happyGoto action_8
action_149 (79#) = happyGoto action_9
action_149 (80#) = happyGoto action_10
action_149 (81#) = happyGoto action_11
action_149 (87#) = happyGoto action_12
action_149 x = happyTcHack x happyReduce_126

action_150 (206#) = happyShift action_160
action_150 x = happyTcHack x happyFail

action_151 (163#) = happyShift action_16
action_151 (182#) = happyShift action_17
action_151 (183#) = happyShift action_18
action_151 (205#) = happyShift action_27
action_151 (207#) = happyShift action_28
action_151 (209#) = happyShift action_29
action_151 (211#) = happyShift action_30
action_151 (215#) = happyShift action_31
action_151 (216#) = happyShift action_32
action_151 (217#) = happyShift action_33
action_151 (218#) = happyShift action_34
action_151 (220#) = happyShift action_35
action_151 (222#) = happyShift action_36
action_151 (49#) = happyGoto action_159
action_151 (57#) = happyGoto action_4
action_151 (59#) = happyGoto action_5
action_151 (71#) = happyGoto action_6
action_151 (72#) = happyGoto action_7
action_151 (78#) = happyGoto action_8
action_151 (79#) = happyGoto action_9
action_151 (80#) = happyGoto action_10
action_151 (81#) = happyGoto action_11
action_151 (87#) = happyGoto action_12
action_151 x = happyTcHack x happyFail

action_152 x = happyTcHack x happyReduce_122

action_153 x = happyTcHack x happyReduce_120

action_154 x = happyTcHack x happyReduce_125

action_155 (163#) = happyShift action_16
action_155 (182#) = happyShift action_17
action_155 (183#) = happyShift action_18
action_155 (205#) = happyShift action_27
action_155 (207#) = happyShift action_28
action_155 (209#) = happyShift action_29
action_155 (211#) = happyShift action_30
action_155 (215#) = happyShift action_31
action_155 (216#) = happyShift action_32
action_155 (217#) = happyShift action_33
action_155 (218#) = happyShift action_34
action_155 (220#) = happyShift action_35
action_155 (222#) = happyShift action_36
action_155 (49#) = happyGoto action_157
action_155 (56#) = happyGoto action_158
action_155 (57#) = happyGoto action_4
action_155 (59#) = happyGoto action_5
action_155 (71#) = happyGoto action_6
action_155 (72#) = happyGoto action_7
action_155 (78#) = happyGoto action_8
action_155 (79#) = happyGoto action_9
action_155 (80#) = happyGoto action_10
action_155 (81#) = happyGoto action_11
action_155 (87#) = happyGoto action_12
action_155 x = happyTcHack x happyFail

action_156 x = happyTcHack x happyReduce_121

action_157 (214#) = happyShift action_155
action_157 x = happyTcHack x happyReduce_110

action_158 x = happyTcHack x happyReduce_111

action_159 (206#) = happyShift action_252
action_159 x = happyTcHack x happyFail

action_160 x = happyTcHack x happyReduce_123

action_161 x = happyTcHack x happyReduce_127

action_162 x = happyTcHack x happyReduce_68

action_163 x = happyTcHack x happyReduce_66

action_164 x = happyTcHack x happyReduce_62

action_165 (127#) = happyShift action_60
action_165 (135#) = happyShift action_61
action_165 (147#) = happyShift action_62
action_165 (151#) = happyShift action_63
action_165 (152#) = happyShift action_64
action_165 (153#) = happyShift action_65
action_165 (154#) = happyShift action_66
action_165 (155#) = happyShift action_67
action_165 (156#) = happyShift action_68
action_165 (157#) = happyShift action_69
action_165 (158#) = happyShift action_70
action_165 (159#) = happyShift action_71
action_165 (203#) = happyShift action_72
action_165 (215#) = happyShift action_73
action_165 (219#) = happyShift action_74
action_165 (221#) = happyShift action_75
action_165 (63#) = happyGoto action_55
action_165 (64#) = happyGoto action_56
action_165 (65#) = happyGoto action_57
action_165 (66#) = happyGoto action_58
action_165 (67#) = happyGoto action_251
action_165 x = happyTcHack x happyFail

action_166 (205#) = happyShift action_250
action_166 x = happyTcHack x happyFail

action_167 (214#) = happyShift action_248
action_167 x = happyTcHack x happyReduce_231

action_168 (212#) = happyShift action_249
action_168 x = happyTcHack x happyFail

action_169 x = happyTcHack x happyReduce_232

action_170 (210#) = happyShift action_247
action_170 (214#) = happyShift action_248
action_170 x = happyTcHack x happyFail

action_171 (210#) = happyShift action_246
action_171 x = happyTcHack x happyFail

action_172 (215#) = happyShift action_242
action_172 (216#) = happyShift action_243
action_172 (226#) = happyShift action_244
action_172 (229#) = happyShift action_245
action_172 (120#) = happyGoto action_241
action_172 x = happyTcHack x happyFail

action_173 x = happyTcHack x happyReduce_263

action_174 x = happyTcHack x happyReduce_265

action_175 (193#) = happyShift action_240
action_175 x = happyTcHack x happyFail

action_176 (127#) = happyShift action_60
action_176 (135#) = happyShift action_61
action_176 (147#) = happyShift action_62
action_176 (151#) = happyShift action_63
action_176 (152#) = happyShift action_64
action_176 (153#) = happyShift action_65
action_176 (154#) = happyShift action_66
action_176 (155#) = happyShift action_67
action_176 (156#) = happyShift action_68
action_176 (157#) = happyShift action_69
action_176 (158#) = happyShift action_70
action_176 (159#) = happyShift action_71
action_176 (199#) = happyShift action_180
action_176 (203#) = happyShift action_72
action_176 (215#) = happyShift action_73
action_176 (63#) = happyGoto action_55
action_176 (65#) = happyGoto action_57
action_176 (66#) = happyGoto action_175
action_176 (116#) = happyGoto action_176
action_176 (117#) = happyGoto action_239
action_176 (118#) = happyGoto action_178
action_176 (119#) = happyGoto action_179
action_176 x = happyTcHack x happyReduce_268

action_177 (198#) = happyShift action_238
action_177 x = happyTcHack x happyFail

action_178 x = happyTcHack x happyReduce_266

action_179 x = happyTcHack x happyReduce_267

action_180 (215#) = happyShift action_31
action_180 (217#) = happyShift action_33
action_180 (87#) = happyGoto action_237
action_180 x = happyTcHack x happyFail

action_181 (216#) = happyShift action_93
action_181 (62#) = happyGoto action_236
action_181 x = happyTcHack x happyFail

action_182 (127#) = happyShift action_60
action_182 (135#) = happyShift action_61
action_182 (147#) = happyShift action_62
action_182 (151#) = happyShift action_63
action_182 (152#) = happyShift action_64
action_182 (153#) = happyShift action_65
action_182 (154#) = happyShift action_66
action_182 (155#) = happyShift action_67
action_182 (156#) = happyShift action_68
action_182 (157#) = happyShift action_69
action_182 (158#) = happyShift action_70
action_182 (159#) = happyShift action_71
action_182 (203#) = happyShift action_72
action_182 (215#) = happyShift action_73
action_182 (216#) = happyShift action_235
action_182 (63#) = happyGoto action_233
action_182 (122#) = happyGoto action_234
action_182 x = happyTcHack x happyFail

action_183 (205#) = happyShift action_27
action_183 (207#) = happyShift action_28
action_183 (209#) = happyShift action_29
action_183 (211#) = happyShift action_30
action_183 (215#) = happyShift action_31
action_183 (216#) = happyShift action_32
action_183 (217#) = happyShift action_33
action_183 (218#) = happyShift action_34
action_183 (220#) = happyShift action_35
action_183 (222#) = happyShift action_36
action_183 (59#) = happyGoto action_232
action_183 (71#) = happyGoto action_6
action_183 (72#) = happyGoto action_7
action_183 (78#) = happyGoto action_8
action_183 (79#) = happyGoto action_9
action_183 (80#) = happyGoto action_10
action_183 (81#) = happyGoto action_11
action_183 (87#) = happyGoto action_12
action_183 x = happyTcHack x happyFail

action_184 x = happyTcHack x happyReduce_261

action_185 (227#) = happyShift action_173
action_185 x = happyTcHack x happyFail

action_186 x = happyTcHack x happyReduce_258

action_187 x = happyTcHack x happyReduce_259

action_188 x = happyTcHack x happyReduce_257

action_189 x = happyTcHack x happyReduce_260

action_190 (228#) = happyShift action_174
action_190 x = happyTcHack x happyFail

action_191 x = happyTcHack x happyReduce_213

action_192 x = happyTcHack x happyReduce_212

action_193 (127#) = happyShift action_60
action_193 (128#) = happyShift action_119
action_193 (135#) = happyShift action_61
action_193 (143#) = happyShift action_120
action_193 (147#) = happyShift action_62
action_193 (151#) = happyShift action_63
action_193 (152#) = happyShift action_64
action_193 (153#) = happyShift action_65
action_193 (154#) = happyShift action_66
action_193 (155#) = happyShift action_67
action_193 (156#) = happyShift action_68
action_193 (157#) = happyShift action_69
action_193 (158#) = happyShift action_70
action_193 (159#) = happyShift action_71
action_193 (164#) = happyShift action_121
action_193 (165#) = happyShift action_122
action_193 (166#) = happyShift action_123
action_193 (167#) = happyShift action_124
action_193 (171#) = happyShift action_125
action_193 (172#) = happyShift action_126
action_193 (173#) = happyShift action_127
action_193 (174#) = happyShift action_128
action_193 (176#) = happyShift action_129
action_193 (177#) = happyShift action_130
action_193 (180#) = happyShift action_131
action_193 (181#) = happyShift action_132
action_193 (195#) = happyShift action_133
action_193 (202#) = happyShift action_134
action_193 (203#) = happyShift action_72
action_193 (205#) = happyShift action_135
action_193 (209#) = happyShift action_136
action_193 (211#) = happyShift action_137
action_193 (215#) = happyShift action_73
action_193 (216#) = happyShift action_32
action_193 (218#) = happyShift action_34
action_193 (219#) = happyShift action_74
action_193 (220#) = happyShift action_35
action_193 (221#) = happyShift action_75
action_193 (222#) = happyShift action_36
action_193 (225#) = happyShift action_138
action_193 (226#) = happyShift action_139
action_193 (227#) = happyShift action_140
action_193 (228#) = happyShift action_141
action_193 (63#) = happyGoto action_55
action_193 (64#) = happyGoto action_56
action_193 (65#) = happyGoto action_57
action_193 (66#) = happyGoto action_58
action_193 (67#) = happyGoto action_106
action_193 (71#) = happyGoto action_107
action_193 (72#) = happyGoto action_108
action_193 (73#) = happyGoto action_109
action_193 (74#) = happyGoto action_110
action_193 (75#) = happyGoto action_111
action_193 (99#) = happyGoto action_231
action_193 (100#) = happyGoto action_113
action_193 (103#) = happyGoto action_114
action_193 (113#) = happyGoto action_115
action_193 (114#) = happyGoto action_116
action_193 (115#) = happyGoto action_117
action_193 (121#) = happyGoto action_118
action_193 x = happyTcHack x happyFail

action_194 (127#) = happyShift action_60
action_194 (135#) = happyShift action_61
action_194 (147#) = happyShift action_62
action_194 (151#) = happyShift action_63
action_194 (152#) = happyShift action_64
action_194 (153#) = happyShift action_65
action_194 (154#) = happyShift action_66
action_194 (155#) = happyShift action_67
action_194 (156#) = happyShift action_68
action_194 (157#) = happyShift action_69
action_194 (158#) = happyShift action_70
action_194 (159#) = happyShift action_71
action_194 (203#) = happyShift action_72
action_194 (215#) = happyShift action_73
action_194 (63#) = happyGoto action_55
action_194 (65#) = happyGoto action_57
action_194 (66#) = happyGoto action_175
action_194 (106#) = happyGoto action_229
action_194 (118#) = happyGoto action_230
action_194 x = happyTcHack x happyReduce_235

action_195 (127#) = happyShift action_60
action_195 (135#) = happyShift action_61
action_195 (147#) = happyShift action_62
action_195 (151#) = happyShift action_63
action_195 (152#) = happyShift action_64
action_195 (153#) = happyShift action_65
action_195 (154#) = happyShift action_66
action_195 (155#) = happyShift action_67
action_195 (156#) = happyShift action_68
action_195 (157#) = happyShift action_69
action_195 (158#) = happyShift action_70
action_195 (159#) = happyShift action_71
action_195 (203#) = happyShift action_72
action_195 (215#) = happyShift action_73
action_195 (63#) = happyGoto action_55
action_195 (65#) = happyGoto action_57
action_195 (66#) = happyGoto action_175
action_195 (118#) = happyGoto action_228
action_195 x = happyTcHack x happyFail

action_196 (146#) = happyShift action_227
action_196 x = happyTcHack x happyFail

action_197 x = happyTcHack x happyReduce_215

action_198 x = happyTcHack x happyReduce_217

action_199 x = happyTcHack x happyReduce_220

action_200 (205#) = happyShift action_27
action_200 (207#) = happyShift action_28
action_200 (209#) = happyShift action_29
action_200 (211#) = happyShift action_30
action_200 (215#) = happyShift action_31
action_200 (216#) = happyShift action_32
action_200 (217#) = happyShift action_33
action_200 (218#) = happyShift action_34
action_200 (220#) = happyShift action_35
action_200 (222#) = happyShift action_36
action_200 (59#) = happyGoto action_226
action_200 (71#) = happyGoto action_6
action_200 (72#) = happyGoto action_7
action_200 (78#) = happyGoto action_8
action_200 (79#) = happyGoto action_9
action_200 (80#) = happyGoto action_10
action_200 (81#) = happyGoto action_11
action_200 (87#) = happyGoto action_12
action_200 x = happyTcHack x happyFail

action_201 x = happyTcHack x happyReduce_205

action_202 (208#) = happyShift action_225
action_202 x = happyTcHack x happyFail

action_203 x = happyTcHack x happyReduce_95

action_204 x = happyTcHack x happyReduce_99

action_205 x = happyTcHack x happyReduce_178

action_206 (206#) = happyShift action_224
action_206 x = happyTcHack x happyFail

action_207 (214#) = happyShift action_223
action_207 x = happyTcHack x happyReduce_103

action_208 (193#) = happyShift action_222
action_208 x = happyTcHack x happyFail

action_209 (205#) = happyShift action_27
action_209 (207#) = happyShift action_28
action_209 (209#) = happyShift action_29
action_209 (211#) = happyShift action_30
action_209 (215#) = happyShift action_31
action_209 (216#) = happyShift action_32
action_209 (217#) = happyShift action_33
action_209 (218#) = happyShift action_34
action_209 (220#) = happyShift action_35
action_209 (222#) = happyShift action_36
action_209 (59#) = happyGoto action_149
action_209 (60#) = happyGoto action_221
action_209 (71#) = happyGoto action_6
action_209 (72#) = happyGoto action_7
action_209 (78#) = happyGoto action_8
action_209 (79#) = happyGoto action_9
action_209 (80#) = happyGoto action_10
action_209 (81#) = happyGoto action_11
action_209 (87#) = happyGoto action_12
action_209 x = happyTcHack x happyReduce_126

action_210 (163#) = happyShift action_16
action_210 (182#) = happyShift action_17
action_210 (183#) = happyShift action_18
action_210 (205#) = happyShift action_27
action_210 (207#) = happyShift action_28
action_210 (209#) = happyShift action_29
action_210 (211#) = happyShift action_30
action_210 (215#) = happyShift action_31
action_210 (216#) = happyShift action_32
action_210 (217#) = happyShift action_33
action_210 (218#) = happyShift action_34
action_210 (220#) = happyShift action_35
action_210 (222#) = happyShift action_36
action_210 (49#) = happyGoto action_220
action_210 (57#) = happyGoto action_4
action_210 (59#) = happyGoto action_5
action_210 (71#) = happyGoto action_6
action_210 (72#) = happyGoto action_7
action_210 (78#) = happyGoto action_8
action_210 (79#) = happyGoto action_9
action_210 (80#) = happyGoto action_10
action_210 (81#) = happyGoto action_11
action_210 (87#) = happyGoto action_12
action_210 x = happyTcHack x happyFail

action_211 x = happyTcHack x happyReduce_100

action_212 x = happyTcHack x happyReduce_184

action_213 (209#) = happyShift action_218
action_213 (217#) = happyShift action_219
action_213 (95#) = happyGoto action_217
action_213 x = happyTcHack x happyFail

action_214 (203#) = happyShift action_216
action_214 (8#) = happyGoto action_215
action_214 x = happyTcHack x happyReduce_10

action_215 (227#) = happyShift action_273
action_215 (126#) = happyGoto action_272
action_215 x = happyTcHack x happyReduce_286

action_216 x = happyTcHack x happyReduce_11

action_217 x = happyTcHack x happyReduce_181

action_218 (209#) = happyShift action_218
action_218 (217#) = happyShift action_219
action_218 (94#) = happyGoto action_270
action_218 (95#) = happyGoto action_271
action_218 x = happyTcHack x happyFail

action_219 x = happyTcHack x happyReduce_194

action_220 x = happyTcHack x happyReduce_96

action_221 x = happyTcHack x happyReduce_105

action_222 (163#) = happyShift action_16
action_222 (182#) = happyShift action_17
action_222 (183#) = happyShift action_18
action_222 (205#) = happyShift action_27
action_222 (207#) = happyShift action_28
action_222 (209#) = happyShift action_29
action_222 (211#) = happyShift action_30
action_222 (215#) = happyShift action_31
action_222 (216#) = happyShift action_32
action_222 (217#) = happyShift action_33
action_222 (218#) = happyShift action_34
action_222 (220#) = happyShift action_35
action_222 (222#) = happyShift action_36
action_222 (49#) = happyGoto action_269
action_222 (57#) = happyGoto action_4
action_222 (59#) = happyGoto action_5
action_222 (71#) = happyGoto action_6
action_222 (72#) = happyGoto action_7
action_222 (78#) = happyGoto action_8
action_222 (79#) = happyGoto action_9
action_222 (80#) = happyGoto action_10
action_222 (81#) = happyGoto action_11
action_222 (87#) = happyGoto action_12
action_222 x = happyTcHack x happyFail

action_223 (216#) = happyShift action_32
action_223 (218#) = happyShift action_34
action_223 (220#) = happyShift action_35
action_223 (222#) = happyShift action_36
action_223 (223#) = happyShift action_48
action_223 (53#) = happyGoto action_268
action_223 (54#) = happyGoto action_207
action_223 (68#) = happyGoto action_208
action_223 (71#) = happyGoto action_44
action_223 (72#) = happyGoto action_45
action_223 (82#) = happyGoto action_46
action_223 (83#) = happyGoto action_209
action_223 x = happyTcHack x happyFail

action_224 x = happyTcHack x happyReduce_102

action_225 x = happyTcHack x happyReduce_206

action_226 x = happyTcHack x happyReduce_219

action_227 (127#) = happyShift action_60
action_227 (135#) = happyShift action_61
action_227 (147#) = happyShift action_62
action_227 (151#) = happyShift action_63
action_227 (152#) = happyShift action_64
action_227 (153#) = happyShift action_65
action_227 (154#) = happyShift action_66
action_227 (155#) = happyShift action_67
action_227 (156#) = happyShift action_68
action_227 (157#) = happyShift action_69
action_227 (158#) = happyShift action_70
action_227 (159#) = happyShift action_71
action_227 (203#) = happyShift action_72
action_227 (215#) = happyShift action_73
action_227 (63#) = happyGoto action_55
action_227 (65#) = happyGoto action_57
action_227 (66#) = happyGoto action_267
action_227 x = happyTcHack x happyFail

action_228 (194#) = happyShift action_266
action_228 x = happyTcHack x happyFail

action_229 (206#) = happyShift action_265
action_229 x = happyTcHack x happyFail

action_230 (194#) = happyShift action_264
action_230 x = happyTcHack x happyFail

action_231 x = happyTcHack x happyReduce_214

action_232 x = happyTcHack x happyReduce_211

action_233 x = happyTcHack x happyReduce_280

action_234 (216#) = happyShift action_93
action_234 (62#) = happyGoto action_263
action_234 x = happyTcHack x happyFail

action_235 x = happyTcHack x happyReduce_279

action_236 (206#) = happyShift action_262
action_236 x = happyTcHack x happyFail

action_237 (193#) = happyShift action_261
action_237 x = happyTcHack x happyReduce_272

action_238 (127#) = happyShift action_60
action_238 (128#) = happyShift action_119
action_238 (135#) = happyShift action_61
action_238 (143#) = happyShift action_120
action_238 (147#) = happyShift action_62
action_238 (151#) = happyShift action_63
action_238 (152#) = happyShift action_64
action_238 (153#) = happyShift action_65
action_238 (154#) = happyShift action_66
action_238 (155#) = happyShift action_67
action_238 (156#) = happyShift action_68
action_238 (157#) = happyShift action_69
action_238 (158#) = happyShift action_70
action_238 (159#) = happyShift action_71
action_238 (164#) = happyShift action_121
action_238 (165#) = happyShift action_122
action_238 (166#) = happyShift action_123
action_238 (167#) = happyShift action_124
action_238 (171#) = happyShift action_125
action_238 (172#) = happyShift action_126
action_238 (173#) = happyShift action_127
action_238 (174#) = happyShift action_128
action_238 (176#) = happyShift action_129
action_238 (177#) = happyShift action_130
action_238 (180#) = happyShift action_131
action_238 (181#) = happyShift action_132
action_238 (195#) = happyShift action_133
action_238 (202#) = happyShift action_134
action_238 (203#) = happyShift action_72
action_238 (205#) = happyShift action_135
action_238 (209#) = happyShift action_136
action_238 (211#) = happyShift action_137
action_238 (215#) = happyShift action_73
action_238 (216#) = happyShift action_32
action_238 (218#) = happyShift action_34
action_238 (219#) = happyShift action_74
action_238 (220#) = happyShift action_35
action_238 (221#) = happyShift action_75
action_238 (222#) = happyShift action_36
action_238 (225#) = happyShift action_138
action_238 (226#) = happyShift action_139
action_238 (227#) = happyShift action_140
action_238 (228#) = happyShift action_141
action_238 (63#) = happyGoto action_55
action_238 (64#) = happyGoto action_56
action_238 (65#) = happyGoto action_57
action_238 (66#) = happyGoto action_58
action_238 (67#) = happyGoto action_106
action_238 (71#) = happyGoto action_107
action_238 (72#) = happyGoto action_108
action_238 (73#) = happyGoto action_109
action_238 (74#) = happyGoto action_110
action_238 (75#) = happyGoto action_111
action_238 (99#) = happyGoto action_260
action_238 (100#) = happyGoto action_113
action_238 (103#) = happyGoto action_114
action_238 (113#) = happyGoto action_115
action_238 (114#) = happyGoto action_116
action_238 (115#) = happyGoto action_117
action_238 (121#) = happyGoto action_118
action_238 x = happyTcHack x happyFail

action_239 x = happyTcHack x happyReduce_269

action_240 (205#) = happyShift action_27
action_240 (207#) = happyShift action_28
action_240 (209#) = happyShift action_29
action_240 (211#) = happyShift action_30
action_240 (215#) = happyShift action_31
action_240 (216#) = happyShift action_32
action_240 (217#) = happyShift action_33
action_240 (218#) = happyShift action_34
action_240 (220#) = happyShift action_35
action_240 (222#) = happyShift action_36
action_240 (59#) = happyGoto action_259
action_240 (71#) = happyGoto action_6
action_240 (72#) = happyGoto action_7
action_240 (78#) = happyGoto action_8
action_240 (79#) = happyGoto action_9
action_240 (80#) = happyGoto action_10
action_240 (81#) = happyGoto action_11
action_240 (87#) = happyGoto action_12
action_240 x = happyTcHack x happyFail

action_241 (163#) = happyShift action_16
action_241 (182#) = happyShift action_17
action_241 (183#) = happyShift action_18
action_241 (205#) = happyShift action_27
action_241 (207#) = happyShift action_28
action_241 (209#) = happyShift action_29
action_241 (211#) = happyShift action_30
action_241 (215#) = happyShift action_31
action_241 (216#) = happyShift action_32
action_241 (217#) = happyShift action_33
action_241 (218#) = happyShift action_34
action_241 (220#) = happyShift action_35
action_241 (222#) = happyShift action_36
action_241 (49#) = happyGoto action_258
action_241 (57#) = happyGoto action_4
action_241 (59#) = happyGoto action_5
action_241 (71#) = happyGoto action_6
action_241 (72#) = happyGoto action_7
action_241 (78#) = happyGoto action_8
action_241 (79#) = happyGoto action_9
action_241 (80#) = happyGoto action_10
action_241 (81#) = happyGoto action_11
action_241 (87#) = happyGoto action_12
action_241 x = happyTcHack x happyFail

action_242 x = happyTcHack x happyReduce_275

action_243 x = happyTcHack x happyReduce_276

action_244 x = happyTcHack x happyReduce_273

action_245 x = happyTcHack x happyReduce_274

action_246 x = happyTcHack x happyReduce_227

action_247 x = happyTcHack x happyReduce_226

action_248 (127#) = happyShift action_60
action_248 (128#) = happyShift action_119
action_248 (135#) = happyShift action_61
action_248 (143#) = happyShift action_120
action_248 (147#) = happyShift action_62
action_248 (151#) = happyShift action_63
action_248 (152#) = happyShift action_64
action_248 (153#) = happyShift action_65
action_248 (154#) = happyShift action_66
action_248 (155#) = happyShift action_67
action_248 (156#) = happyShift action_68
action_248 (157#) = happyShift action_69
action_248 (158#) = happyShift action_70
action_248 (159#) = happyShift action_71
action_248 (164#) = happyShift action_121
action_248 (165#) = happyShift action_122
action_248 (166#) = happyShift action_123
action_248 (167#) = happyShift action_124
action_248 (171#) = happyShift action_125
action_248 (172#) = happyShift action_126
action_248 (173#) = happyShift action_127
action_248 (174#) = happyShift action_128
action_248 (176#) = happyShift action_129
action_248 (177#) = happyShift action_130
action_248 (180#) = happyShift action_131
action_248 (181#) = happyShift action_132
action_248 (195#) = happyShift action_133
action_248 (202#) = happyShift action_134
action_248 (203#) = happyShift action_72
action_248 (205#) = happyShift action_135
action_248 (209#) = happyShift action_136
action_248 (211#) = happyShift action_137
action_248 (215#) = happyShift action_73
action_248 (216#) = happyShift action_32
action_248 (218#) = happyShift action_34
action_248 (219#) = happyShift action_74
action_248 (220#) = happyShift action_35
action_248 (221#) = happyShift action_75
action_248 (222#) = happyShift action_36
action_248 (225#) = happyShift action_138
action_248 (226#) = happyShift action_139
action_248 (227#) = happyShift action_140
action_248 (228#) = happyShift action_141
action_248 (63#) = happyGoto action_55
action_248 (64#) = happyGoto action_56
action_248 (65#) = happyGoto action_57
action_248 (66#) = happyGoto action_58
action_248 (67#) = happyGoto action_106
action_248 (71#) = happyGoto action_107
action_248 (72#) = happyGoto action_108
action_248 (73#) = happyGoto action_109
action_248 (74#) = happyGoto action_110
action_248 (75#) = happyGoto action_111
action_248 (99#) = happyGoto action_256
action_248 (100#) = happyGoto action_113
action_248 (103#) = happyGoto action_114
action_248 (105#) = happyGoto action_257
action_248 (113#) = happyGoto action_115
action_248 (114#) = happyGoto action_116
action_248 (115#) = happyGoto action_117
action_248 (121#) = happyGoto action_118
action_248 x = happyTcHack x happyFail

action_249 x = happyTcHack x happyReduce_228

action_250 (127#) = happyShift action_60
action_250 (135#) = happyShift action_61
action_250 (147#) = happyShift action_62
action_250 (151#) = happyShift action_63
action_250 (152#) = happyShift action_64
action_250 (153#) = happyShift action_65
action_250 (154#) = happyShift action_66
action_250 (155#) = happyShift action_67
action_250 (156#) = happyShift action_68
action_250 (157#) = happyShift action_69
action_250 (158#) = happyShift action_70
action_250 (159#) = happyShift action_71
action_250 (199#) = happyShift action_180
action_250 (203#) = happyShift action_72
action_250 (215#) = happyShift action_73
action_250 (63#) = happyGoto action_55
action_250 (65#) = happyGoto action_57
action_250 (66#) = happyGoto action_175
action_250 (116#) = happyGoto action_176
action_250 (117#) = happyGoto action_255
action_250 (118#) = happyGoto action_178
action_250 (119#) = happyGoto action_179
action_250 x = happyTcHack x happyReduce_268

action_251 (127#) = happyShift action_60
action_251 (135#) = happyShift action_61
action_251 (147#) = happyShift action_62
action_251 (151#) = happyShift action_63
action_251 (152#) = happyShift action_64
action_251 (153#) = happyShift action_65
action_251 (154#) = happyShift action_66
action_251 (155#) = happyShift action_67
action_251 (156#) = happyShift action_68
action_251 (157#) = happyShift action_69
action_251 (158#) = happyShift action_70
action_251 (159#) = happyShift action_71
action_251 (171#) = happyShift action_125
action_251 (172#) = happyShift action_126
action_251 (173#) = happyShift action_127
action_251 (174#) = happyShift action_128
action_251 (176#) = happyShift action_129
action_251 (199#) = happyShift action_200
action_251 (202#) = happyShift action_134
action_251 (203#) = happyShift action_72
action_251 (205#) = happyShift action_135
action_251 (209#) = happyShift action_136
action_251 (211#) = happyShift action_137
action_251 (215#) = happyShift action_73
action_251 (216#) = happyShift action_32
action_251 (218#) = happyShift action_34
action_251 (219#) = happyShift action_74
action_251 (220#) = happyShift action_35
action_251 (221#) = happyShift action_75
action_251 (222#) = happyShift action_36
action_251 (225#) = happyShift action_138
action_251 (226#) = happyShift action_139
action_251 (227#) = happyShift action_140
action_251 (228#) = happyShift action_141
action_251 (63#) = happyGoto action_55
action_251 (64#) = happyGoto action_56
action_251 (65#) = happyGoto action_57
action_251 (66#) = happyGoto action_58
action_251 (67#) = happyGoto action_106
action_251 (71#) = happyGoto action_107
action_251 (72#) = happyGoto action_108
action_251 (73#) = happyGoto action_109
action_251 (74#) = happyGoto action_110
action_251 (75#) = happyGoto action_111
action_251 (101#) = happyGoto action_253
action_251 (102#) = happyGoto action_254
action_251 (103#) = happyGoto action_199
action_251 (113#) = happyGoto action_115
action_251 (114#) = happyGoto action_116
action_251 (115#) = happyGoto action_117
action_251 x = happyTcHack x happyReduce_221

action_252 x = happyTcHack x happyReduce_124

action_253 (127#) = happyShift action_60
action_253 (135#) = happyShift action_61
action_253 (147#) = happyShift action_62
action_253 (151#) = happyShift action_63
action_253 (152#) = happyShift action_64
action_253 (153#) = happyShift action_65
action_253 (154#) = happyShift action_66
action_253 (155#) = happyShift action_67
action_253 (156#) = happyShift action_68
action_253 (157#) = happyShift action_69
action_253 (158#) = happyShift action_70
action_253 (159#) = happyShift action_71
action_253 (171#) = happyShift action_125
action_253 (172#) = happyShift action_126
action_253 (173#) = happyShift action_127
action_253 (174#) = happyShift action_128
action_253 (176#) = happyShift action_129
action_253 (199#) = happyShift action_200
action_253 (202#) = happyShift action_134
action_253 (203#) = happyShift action_72
action_253 (205#) = happyShift action_135
action_253 (209#) = happyShift action_136
action_253 (211#) = happyShift action_137
action_253 (215#) = happyShift action_73
action_253 (216#) = happyShift action_32
action_253 (218#) = happyShift action_34
action_253 (219#) = happyShift action_74
action_253 (220#) = happyShift action_35
action_253 (221#) = happyShift action_75
action_253 (222#) = happyShift action_36
action_253 (225#) = happyShift action_138
action_253 (226#) = happyShift action_139
action_253 (227#) = happyShift action_140
action_253 (228#) = happyShift action_141
action_253 (63#) = happyGoto action_55
action_253 (64#) = happyGoto action_56
action_253 (65#) = happyGoto action_57
action_253 (66#) = happyGoto action_58
action_253 (67#) = happyGoto action_106
action_253 (71#) = happyGoto action_107
action_253 (72#) = happyGoto action_108
action_253 (73#) = happyGoto action_109
action_253 (74#) = happyGoto action_110
action_253 (75#) = happyGoto action_111
action_253 (101#) = happyGoto action_253
action_253 (102#) = happyGoto action_287
action_253 (103#) = happyGoto action_199
action_253 (113#) = happyGoto action_115
action_253 (114#) = happyGoto action_116
action_253 (115#) = happyGoto action_117
action_253 x = happyTcHack x happyReduce_221

action_254 (194#) = happyShift action_286
action_254 x = happyTcHack x happyFail

action_255 (206#) = happyShift action_285
action_255 x = happyTcHack x happyFail

action_256 (214#) = happyShift action_248
action_256 x = happyTcHack x happyReduce_233

action_257 x = happyTcHack x happyReduce_234

action_258 (206#) = happyShift action_284
action_258 x = happyTcHack x happyFail

action_259 x = happyTcHack x happyReduce_270

action_260 x = happyTcHack x happyReduce_207

action_261 (209#) = happyShift action_218
action_261 (217#) = happyShift action_219
action_261 (95#) = happyGoto action_283
action_261 x = happyTcHack x happyFail

action_262 x = happyTcHack x happyReduce_277

action_263 (203#) = happyShift action_282
action_263 (123#) = happyGoto action_281
action_263 x = happyTcHack x happyReduce_281

action_264 (127#) = happyShift action_60
action_264 (128#) = happyShift action_119
action_264 (135#) = happyShift action_61
action_264 (143#) = happyShift action_120
action_264 (147#) = happyShift action_62
action_264 (151#) = happyShift action_63
action_264 (152#) = happyShift action_64
action_264 (153#) = happyShift action_65
action_264 (154#) = happyShift action_66
action_264 (155#) = happyShift action_67
action_264 (156#) = happyShift action_68
action_264 (157#) = happyShift action_69
action_264 (158#) = happyShift action_70
action_264 (159#) = happyShift action_71
action_264 (164#) = happyShift action_121
action_264 (165#) = happyShift action_122
action_264 (166#) = happyShift action_123
action_264 (167#) = happyShift action_124
action_264 (171#) = happyShift action_125
action_264 (172#) = happyShift action_126
action_264 (173#) = happyShift action_127
action_264 (174#) = happyShift action_128
action_264 (176#) = happyShift action_129
action_264 (177#) = happyShift action_130
action_264 (180#) = happyShift action_131
action_264 (181#) = happyShift action_132
action_264 (195#) = happyShift action_133
action_264 (202#) = happyShift action_134
action_264 (203#) = happyShift action_72
action_264 (205#) = happyShift action_135
action_264 (209#) = happyShift action_136
action_264 (211#) = happyShift action_137
action_264 (215#) = happyShift action_73
action_264 (216#) = happyShift action_32
action_264 (218#) = happyShift action_34
action_264 (219#) = happyShift action_74
action_264 (220#) = happyShift action_35
action_264 (221#) = happyShift action_75
action_264 (222#) = happyShift action_36
action_264 (225#) = happyShift action_138
action_264 (226#) = happyShift action_139
action_264 (227#) = happyShift action_140
action_264 (228#) = happyShift action_141
action_264 (63#) = happyGoto action_55
action_264 (64#) = happyGoto action_56
action_264 (65#) = happyGoto action_57
action_264 (66#) = happyGoto action_58
action_264 (67#) = happyGoto action_106
action_264 (71#) = happyGoto action_107
action_264 (72#) = happyGoto action_108
action_264 (73#) = happyGoto action_109
action_264 (74#) = happyGoto action_110
action_264 (75#) = happyGoto action_111
action_264 (99#) = happyGoto action_280
action_264 (100#) = happyGoto action_113
action_264 (103#) = happyGoto action_114
action_264 (113#) = happyGoto action_115
action_264 (114#) = happyGoto action_116
action_264 (115#) = happyGoto action_117
action_264 (121#) = happyGoto action_118
action_264 x = happyTcHack x happyFail

action_265 (138#) = happyShift action_279
action_265 x = happyTcHack x happyFail

action_266 (127#) = happyShift action_60
action_266 (128#) = happyShift action_119
action_266 (135#) = happyShift action_61
action_266 (143#) = happyShift action_120
action_266 (147#) = happyShift action_62
action_266 (151#) = happyShift action_63
action_266 (152#) = happyShift action_64
action_266 (153#) = happyShift action_65
action_266 (154#) = happyShift action_66
action_266 (155#) = happyShift action_67
action_266 (156#) = happyShift action_68
action_266 (157#) = happyShift action_69
action_266 (158#) = happyShift action_70
action_266 (159#) = happyShift action_71
action_266 (164#) = happyShift action_121
action_266 (165#) = happyShift action_122
action_266 (166#) = happyShift action_123
action_266 (167#) = happyShift action_124
action_266 (171#) = happyShift action_125
action_266 (172#) = happyShift action_126
action_266 (173#) = happyShift action_127
action_266 (174#) = happyShift action_128
action_266 (176#) = happyShift action_129
action_266 (177#) = happyShift action_130
action_266 (180#) = happyShift action_131
action_266 (181#) = happyShift action_132
action_266 (195#) = happyShift action_133
action_266 (202#) = happyShift action_134
action_266 (203#) = happyShift action_72
action_266 (205#) = happyShift action_135
action_266 (209#) = happyShift action_136
action_266 (211#) = happyShift action_137
action_266 (215#) = happyShift action_73
action_266 (216#) = happyShift action_32
action_266 (218#) = happyShift action_34
action_266 (219#) = happyShift action_74
action_266 (220#) = happyShift action_35
action_266 (221#) = happyShift action_75
action_266 (222#) = happyShift action_36
action_266 (225#) = happyShift action_138
action_266 (226#) = happyShift action_139
action_266 (227#) = happyShift action_140
action_266 (228#) = happyShift action_141
action_266 (63#) = happyGoto action_55
action_266 (64#) = happyGoto action_56
action_266 (65#) = happyGoto action_57
action_266 (66#) = happyGoto action_58
action_266 (67#) = happyGoto action_106
action_266 (71#) = happyGoto action_107
action_266 (72#) = happyGoto action_108
action_266 (73#) = happyGoto action_109
action_266 (74#) = happyGoto action_110
action_266 (75#) = happyGoto action_111
action_266 (99#) = happyGoto action_278
action_266 (100#) = happyGoto action_113
action_266 (103#) = happyGoto action_114
action_266 (113#) = happyGoto action_115
action_266 (114#) = happyGoto action_116
action_266 (115#) = happyGoto action_117
action_266 (121#) = happyGoto action_118
action_266 x = happyTcHack x happyFail

action_267 (205#) = happyShift action_277
action_267 x = happyTcHack x happyFail

action_268 x = happyTcHack x happyReduce_104

action_269 x = happyTcHack x happyReduce_106

action_270 (210#) = happyShift action_276
action_270 x = happyTcHack x happyFail

action_271 (198#) = happyShift action_275
action_271 x = happyTcHack x happyReduce_192

action_272 (150#) = happyShift action_274
action_272 x = happyTcHack x happyFail

action_273 x = happyTcHack x happyReduce_287

action_274 (13#) = happyGoto action_304
action_274 x = happyTcHack x happyReduce_20

action_275 (209#) = happyShift action_218
action_275 (217#) = happyShift action_219
action_275 (94#) = happyGoto action_303
action_275 (95#) = happyGoto action_271
action_275 x = happyTcHack x happyFail

action_276 x = happyTcHack x happyReduce_195

action_277 (168#) = happyShift action_299
action_277 (171#) = happyShift action_125
action_277 (172#) = happyShift action_126
action_277 (173#) = happyShift action_127
action_277 (174#) = happyShift action_128
action_277 (176#) = happyShift action_129
action_277 (177#) = happyShift action_300
action_277 (202#) = happyShift action_134
action_277 (209#) = happyShift action_301
action_277 (211#) = happyShift action_302
action_277 (216#) = happyShift action_32
action_277 (218#) = happyShift action_34
action_277 (220#) = happyShift action_35
action_277 (222#) = happyShift action_36
action_277 (225#) = happyShift action_138
action_277 (226#) = happyShift action_139
action_277 (227#) = happyShift action_140
action_277 (228#) = happyShift action_141
action_277 (71#) = happyGoto action_107
action_277 (72#) = happyGoto action_108
action_277 (73#) = happyGoto action_109
action_277 (74#) = happyGoto action_110
action_277 (75#) = happyGoto action_294
action_277 (107#) = happyGoto action_295
action_277 (108#) = happyGoto action_296
action_277 (109#) = happyGoto action_297
action_277 (113#) = happyGoto action_298
action_277 (114#) = happyGoto action_116
action_277 (115#) = happyGoto action_117
action_277 x = happyTcHack x happyFail

action_278 (206#) = happyShift action_293
action_278 x = happyTcHack x happyFail

action_279 (127#) = happyShift action_60
action_279 (128#) = happyShift action_119
action_279 (135#) = happyShift action_61
action_279 (143#) = happyShift action_120
action_279 (147#) = happyShift action_62
action_279 (151#) = happyShift action_63
action_279 (152#) = happyShift action_64
action_279 (153#) = happyShift action_65
action_279 (154#) = happyShift action_66
action_279 (155#) = happyShift action_67
action_279 (156#) = happyShift action_68
action_279 (157#) = happyShift action_69
action_279 (158#) = happyShift action_70
action_279 (159#) = happyShift action_71
action_279 (164#) = happyShift action_121
action_279 (165#) = happyShift action_122
action_279 (166#) = happyShift action_123
action_279 (167#) = happyShift action_124
action_279 (171#) = happyShift action_125
action_279 (172#) = happyShift action_126
action_279 (173#) = happyShift action_127
action_279 (174#) = happyShift action_128
action_279 (176#) = happyShift action_129
action_279 (177#) = happyShift action_130
action_279 (180#) = happyShift action_131
action_279 (181#) = happyShift action_132
action_279 (195#) = happyShift action_133
action_279 (202#) = happyShift action_134
action_279 (203#) = happyShift action_72
action_279 (205#) = happyShift action_135
action_279 (209#) = happyShift action_136
action_279 (211#) = happyShift action_137
action_279 (215#) = happyShift action_73
action_279 (216#) = happyShift action_32
action_279 (218#) = happyShift action_34
action_279 (219#) = happyShift action_74
action_279 (220#) = happyShift action_35
action_279 (221#) = happyShift action_75
action_279 (222#) = happyShift action_36
action_279 (225#) = happyShift action_138
action_279 (226#) = happyShift action_139
action_279 (227#) = happyShift action_140
action_279 (228#) = happyShift action_141
action_279 (63#) = happyGoto action_55
action_279 (64#) = happyGoto action_56
action_279 (65#) = happyGoto action_57
action_279 (66#) = happyGoto action_58
action_279 (67#) = happyGoto action_106
action_279 (71#) = happyGoto action_107
action_279 (72#) = happyGoto action_108
action_279 (73#) = happyGoto action_109
action_279 (74#) = happyGoto action_110
action_279 (75#) = happyGoto action_111
action_279 (99#) = happyGoto action_292
action_279 (100#) = happyGoto action_113
action_279 (103#) = happyGoto action_114
action_279 (113#) = happyGoto action_115
action_279 (114#) = happyGoto action_116
action_279 (115#) = happyGoto action_117
action_279 (121#) = happyGoto action_118
action_279 x = happyTcHack x happyFail

action_280 (213#) = happyShift action_291
action_280 x = happyTcHack x happyFail

action_281 (186#) = happyShift action_290
action_281 (124#) = happyGoto action_289
action_281 x = happyTcHack x happyReduce_283

action_282 x = happyTcHack x happyReduce_282

action_283 x = happyTcHack x happyReduce_271

action_284 x = happyTcHack x happyReduce_229

action_285 x = happyTcHack x happyReduce_64

action_286 (127#) = happyShift action_60
action_286 (128#) = happyShift action_119
action_286 (135#) = happyShift action_61
action_286 (143#) = happyShift action_120
action_286 (147#) = happyShift action_62
action_286 (151#) = happyShift action_63
action_286 (152#) = happyShift action_64
action_286 (153#) = happyShift action_65
action_286 (154#) = happyShift action_66
action_286 (155#) = happyShift action_67
action_286 (156#) = happyShift action_68
action_286 (157#) = happyShift action_69
action_286 (158#) = happyShift action_70
action_286 (159#) = happyShift action_71
action_286 (164#) = happyShift action_121
action_286 (165#) = happyShift action_122
action_286 (166#) = happyShift action_123
action_286 (167#) = happyShift action_124
action_286 (171#) = happyShift action_125
action_286 (172#) = happyShift action_126
action_286 (173#) = happyShift action_127
action_286 (174#) = happyShift action_128
action_286 (176#) = happyShift action_129
action_286 (177#) = happyShift action_130
action_286 (180#) = happyShift action_131
action_286 (181#) = happyShift action_132
action_286 (195#) = happyShift action_133
action_286 (202#) = happyShift action_134
action_286 (203#) = happyShift action_72
action_286 (205#) = happyShift action_135
action_286 (209#) = happyShift action_136
action_286 (211#) = happyShift action_137
action_286 (215#) = happyShift action_73
action_286 (216#) = happyShift action_32
action_286 (218#) = happyShift action_34
action_286 (219#) = happyShift action_74
action_286 (220#) = happyShift action_35
action_286 (221#) = happyShift action_75
action_286 (222#) = happyShift action_36
action_286 (225#) = happyShift action_138
action_286 (226#) = happyShift action_139
action_286 (227#) = happyShift action_140
action_286 (228#) = happyShift action_141
action_286 (63#) = happyGoto action_55
action_286 (64#) = happyGoto action_56
action_286 (65#) = happyGoto action_57
action_286 (66#) = happyGoto action_58
action_286 (67#) = happyGoto action_106
action_286 (71#) = happyGoto action_107
action_286 (72#) = happyGoto action_108
action_286 (73#) = happyGoto action_109
action_286 (74#) = happyGoto action_110
action_286 (75#) = happyGoto action_111
action_286 (99#) = happyGoto action_288
action_286 (100#) = happyGoto action_113
action_286 (103#) = happyGoto action_114
action_286 (113#) = happyGoto action_115
action_286 (114#) = happyGoto action_116
action_286 (115#) = happyGoto action_117
action_286 (121#) = happyGoto action_118
action_286 x = happyTcHack x happyFail

action_287 x = happyTcHack x happyReduce_222

action_288 x = happyTcHack x happyReduce_63

action_289 (206#) = happyShift action_321
action_289 x = happyTcHack x happyFail

action_290 x = happyTcHack x happyReduce_284

action_291 (127#) = happyShift action_60
action_291 (135#) = happyShift action_61
action_291 (147#) = happyShift action_62
action_291 (151#) = happyShift action_63
action_291 (152#) = happyShift action_64
action_291 (153#) = happyShift action_65
action_291 (154#) = happyShift action_66
action_291 (155#) = happyShift action_67
action_291 (156#) = happyShift action_68
action_291 (157#) = happyShift action_69
action_291 (158#) = happyShift action_70
action_291 (159#) = happyShift action_71
action_291 (203#) = happyShift action_72
action_291 (215#) = happyShift action_73
action_291 (63#) = happyGoto action_55
action_291 (65#) = happyGoto action_57
action_291 (66#) = happyGoto action_175
action_291 (106#) = happyGoto action_320
action_291 (118#) = happyGoto action_230
action_291 x = happyTcHack x happyReduce_235

action_292 x = happyTcHack x happyReduce_210

action_293 (138#) = happyShift action_319
action_293 x = happyTcHack x happyFail

action_294 (127#) = happyShift action_60
action_294 (135#) = happyShift action_61
action_294 (147#) = happyShift action_62
action_294 (151#) = happyShift action_63
action_294 (152#) = happyShift action_64
action_294 (153#) = happyShift action_65
action_294 (154#) = happyShift action_66
action_294 (155#) = happyShift action_67
action_294 (156#) = happyShift action_68
action_294 (157#) = happyShift action_69
action_294 (158#) = happyShift action_70
action_294 (159#) = happyShift action_71
action_294 (199#) = happyShift action_318
action_294 (203#) = happyShift action_72
action_294 (215#) = happyShift action_73
action_294 (63#) = happyGoto action_55
action_294 (65#) = happyGoto action_57
action_294 (66#) = happyGoto action_315
action_294 (110#) = happyGoto action_316
action_294 (111#) = happyGoto action_317
action_294 x = happyTcHack x happyReduce_247

action_295 (206#) = happyShift action_314
action_295 x = happyTcHack x happyFail

action_296 (213#) = happyShift action_313
action_296 x = happyTcHack x happyReduce_237

action_297 (198#) = happyShift action_312
action_297 x = happyTcHack x happyFail

action_298 x = happyTcHack x happyReduce_240

action_299 x = happyTcHack x happyReduce_245

action_300 (226#) = happyShift action_311
action_300 x = happyTcHack x happyFail

action_301 (127#) = happyShift action_60
action_301 (135#) = happyShift action_61
action_301 (147#) = happyShift action_62
action_301 (151#) = happyShift action_63
action_301 (152#) = happyShift action_64
action_301 (153#) = happyShift action_65
action_301 (154#) = happyShift action_66
action_301 (155#) = happyShift action_67
action_301 (156#) = happyShift action_68
action_301 (157#) = happyShift action_69
action_301 (158#) = happyShift action_70
action_301 (159#) = happyShift action_71
action_301 (168#) = happyShift action_299
action_301 (171#) = happyShift action_125
action_301 (172#) = happyShift action_126
action_301 (173#) = happyShift action_127
action_301 (174#) = happyShift action_128
action_301 (176#) = happyShift action_129
action_301 (177#) = happyShift action_300
action_301 (202#) = happyShift action_134
action_301 (203#) = happyShift action_72
action_301 (209#) = happyShift action_301
action_301 (211#) = happyShift action_302
action_301 (215#) = happyShift action_73
action_301 (216#) = happyShift action_32
action_301 (218#) = happyShift action_34
action_301 (220#) = happyShift action_35
action_301 (222#) = happyShift action_36
action_301 (225#) = happyShift action_138
action_301 (226#) = happyShift action_139
action_301 (227#) = happyShift action_140
action_301 (228#) = happyShift action_141
action_301 (63#) = happyGoto action_55
action_301 (65#) = happyGoto action_57
action_301 (66#) = happyGoto action_307
action_301 (71#) = happyGoto action_107
action_301 (72#) = happyGoto action_108
action_301 (73#) = happyGoto action_109
action_301 (74#) = happyGoto action_110
action_301 (75#) = happyGoto action_294
action_301 (109#) = happyGoto action_309
action_301 (112#) = happyGoto action_310
action_301 (113#) = happyGoto action_298
action_301 (114#) = happyGoto action_116
action_301 (115#) = happyGoto action_117
action_301 x = happyTcHack x happyFail

action_302 (127#) = happyShift action_60
action_302 (135#) = happyShift action_61
action_302 (147#) = happyShift action_62
action_302 (151#) = happyShift action_63
action_302 (152#) = happyShift action_64
action_302 (153#) = happyShift action_65
action_302 (154#) = happyShift action_66
action_302 (155#) = happyShift action_67
action_302 (156#) = happyShift action_68
action_302 (157#) = happyShift action_69
action_302 (158#) = happyShift action_70
action_302 (159#) = happyShift action_71
action_302 (203#) = happyShift action_72
action_302 (215#) = happyShift action_73
action_302 (63#) = happyGoto action_55
action_302 (65#) = happyGoto action_57
action_302 (66#) = happyGoto action_307
action_302 (112#) = happyGoto action_308
action_302 x = happyTcHack x happyFail

action_303 x = happyTcHack x happyReduce_193

action_304 (161#) = happyShift action_306
action_304 (6#) = happyGoto action_305
action_304 x = happyTcHack x happyReduce_7

action_305 (137#) = happyShift action_335
action_305 (7#) = happyGoto action_333
action_305 (24#) = happyGoto action_334
action_305 x = happyTcHack x happyReduce_44

action_306 (216#) = happyShift action_93
action_306 (62#) = happyGoto action_332
action_306 x = happyTcHack x happyFail

action_307 (214#) = happyShift action_331
action_307 x = happyTcHack x happyReduce_251

action_308 (212#) = happyShift action_330
action_308 x = happyTcHack x happyFail

action_309 (210#) = happyShift action_329
action_309 x = happyTcHack x happyFail

action_310 (210#) = happyShift action_328
action_310 x = happyTcHack x happyFail

action_311 (205#) = happyShift action_27
action_311 (207#) = happyShift action_28
action_311 (209#) = happyShift action_29
action_311 (211#) = happyShift action_30
action_311 (215#) = happyShift action_31
action_311 (216#) = happyShift action_32
action_311 (217#) = happyShift action_33
action_311 (218#) = happyShift action_34
action_311 (220#) = happyShift action_35
action_311 (222#) = happyShift action_36
action_311 (59#) = happyGoto action_327
action_311 (71#) = happyGoto action_6
action_311 (72#) = happyGoto action_7
action_311 (78#) = happyGoto action_8
action_311 (79#) = happyGoto action_9
action_311 (80#) = happyGoto action_10
action_311 (81#) = happyGoto action_11
action_311 (87#) = happyGoto action_12
action_311 x = happyTcHack x happyFail

action_312 (127#) = happyShift action_60
action_312 (128#) = happyShift action_119
action_312 (135#) = happyShift action_61
action_312 (143#) = happyShift action_120
action_312 (147#) = happyShift action_62
action_312 (151#) = happyShift action_63
action_312 (152#) = happyShift action_64
action_312 (153#) = happyShift action_65
action_312 (154#) = happyShift action_66
action_312 (155#) = happyShift action_67
action_312 (156#) = happyShift action_68
action_312 (157#) = happyShift action_69
action_312 (158#) = happyShift action_70
action_312 (159#) = happyShift action_71
action_312 (164#) = happyShift action_121
action_312 (165#) = happyShift action_122
action_312 (166#) = happyShift action_123
action_312 (167#) = happyShift action_124
action_312 (171#) = happyShift action_125
action_312 (172#) = happyShift action_126
action_312 (173#) = happyShift action_127
action_312 (174#) = happyShift action_128
action_312 (176#) = happyShift action_129
action_312 (177#) = happyShift action_130
action_312 (180#) = happyShift action_131
action_312 (181#) = happyShift action_132
action_312 (195#) = happyShift action_133
action_312 (202#) = happyShift action_134
action_312 (203#) = happyShift action_72
action_312 (205#) = happyShift action_135
action_312 (209#) = happyShift action_136
action_312 (211#) = happyShift action_137
action_312 (215#) = happyShift action_73
action_312 (216#) = happyShift action_32
action_312 (218#) = happyShift action_34
action_312 (219#) = happyShift action_74
action_312 (220#) = happyShift action_35
action_312 (221#) = happyShift action_75
action_312 (222#) = happyShift action_36
action_312 (225#) = happyShift action_138
action_312 (226#) = happyShift action_139
action_312 (227#) = happyShift action_140
action_312 (228#) = happyShift action_141
action_312 (63#) = happyGoto action_55
action_312 (64#) = happyGoto action_56
action_312 (65#) = happyGoto action_57
action_312 (66#) = happyGoto action_58
action_312 (67#) = happyGoto action_106
action_312 (71#) = happyGoto action_107
action_312 (72#) = happyGoto action_108
action_312 (73#) = happyGoto action_109
action_312 (74#) = happyGoto action_110
action_312 (75#) = happyGoto action_111
action_312 (99#) = happyGoto action_326
action_312 (100#) = happyGoto action_113
action_312 (103#) = happyGoto action_114
action_312 (113#) = happyGoto action_115
action_312 (114#) = happyGoto action_116
action_312 (115#) = happyGoto action_117
action_312 (121#) = happyGoto action_118
action_312 x = happyTcHack x happyFail

action_313 (168#) = happyShift action_299
action_313 (171#) = happyShift action_125
action_313 (172#) = happyShift action_126
action_313 (173#) = happyShift action_127
action_313 (174#) = happyShift action_128
action_313 (176#) = happyShift action_129
action_313 (177#) = happyShift action_300
action_313 (202#) = happyShift action_134
action_313 (209#) = happyShift action_301
action_313 (211#) = happyShift action_302
action_313 (216#) = happyShift action_32
action_313 (218#) = happyShift action_34
action_313 (220#) = happyShift action_35
action_313 (222#) = happyShift action_36
action_313 (225#) = happyShift action_138
action_313 (226#) = happyShift action_139
action_313 (227#) = happyShift action_140
action_313 (228#) = happyShift action_141
action_313 (71#) = happyGoto action_107
action_313 (72#) = happyGoto action_108
action_313 (73#) = happyGoto action_109
action_313 (74#) = happyGoto action_110
action_313 (75#) = happyGoto action_294
action_313 (107#) = happyGoto action_325
action_313 (108#) = happyGoto action_296
action_313 (109#) = happyGoto action_297
action_313 (113#) = happyGoto action_298
action_313 (114#) = happyGoto action_116
action_313 (115#) = happyGoto action_117
action_313 x = happyTcHack x happyFail

action_314 x = happyTcHack x happyReduce_208

action_315 x = happyTcHack x happyReduce_249

action_316 x = happyTcHack x happyReduce_242

action_317 (127#) = happyShift action_60
action_317 (135#) = happyShift action_61
action_317 (147#) = happyShift action_62
action_317 (151#) = happyShift action_63
action_317 (152#) = happyShift action_64
action_317 (153#) = happyShift action_65
action_317 (154#) = happyShift action_66
action_317 (155#) = happyShift action_67
action_317 (156#) = happyShift action_68
action_317 (157#) = happyShift action_69
action_317 (158#) = happyShift action_70
action_317 (159#) = happyShift action_71
action_317 (199#) = happyShift action_318
action_317 (203#) = happyShift action_72
action_317 (215#) = happyShift action_73
action_317 (63#) = happyGoto action_55
action_317 (65#) = happyGoto action_57
action_317 (66#) = happyGoto action_315
action_317 (110#) = happyGoto action_324
action_317 (111#) = happyGoto action_317
action_317 x = happyTcHack x happyReduce_247

action_318 (215#) = happyShift action_31
action_318 (217#) = happyShift action_33
action_318 (87#) = happyGoto action_323
action_318 x = happyTcHack x happyFail

action_319 (127#) = happyShift action_60
action_319 (128#) = happyShift action_119
action_319 (135#) = happyShift action_61
action_319 (143#) = happyShift action_120
action_319 (147#) = happyShift action_62
action_319 (151#) = happyShift action_63
action_319 (152#) = happyShift action_64
action_319 (153#) = happyShift action_65
action_319 (154#) = happyShift action_66
action_319 (155#) = happyShift action_67
action_319 (156#) = happyShift action_68
action_319 (157#) = happyShift action_69
action_319 (158#) = happyShift action_70
action_319 (159#) = happyShift action_71
action_319 (164#) = happyShift action_121
action_319 (165#) = happyShift action_122
action_319 (166#) = happyShift action_123
action_319 (167#) = happyShift action_124
action_319 (171#) = happyShift action_125
action_319 (172#) = happyShift action_126
action_319 (173#) = happyShift action_127
action_319 (174#) = happyShift action_128
action_319 (176#) = happyShift action_129
action_319 (177#) = happyShift action_130
action_319 (180#) = happyShift action_131
action_319 (181#) = happyShift action_132
action_319 (195#) = happyShift action_133
action_319 (202#) = happyShift action_134
action_319 (203#) = happyShift action_72
action_319 (205#) = happyShift action_135
action_319 (209#) = happyShift action_136
action_319 (211#) = happyShift action_137
action_319 (215#) = happyShift action_73
action_319 (216#) = happyShift action_32
action_319 (218#) = happyShift action_34
action_319 (219#) = happyShift action_74
action_319 (220#) = happyShift action_35
action_319 (221#) = happyShift action_75
action_319 (222#) = happyShift action_36
action_319 (225#) = happyShift action_138
action_319 (226#) = happyShift action_139
action_319 (227#) = happyShift action_140
action_319 (228#) = happyShift action_141
action_319 (63#) = happyGoto action_55
action_319 (64#) = happyGoto action_56
action_319 (65#) = happyGoto action_57
action_319 (66#) = happyGoto action_58
action_319 (67#) = happyGoto action_106
action_319 (71#) = happyGoto action_107
action_319 (72#) = happyGoto action_108
action_319 (73#) = happyGoto action_109
action_319 (74#) = happyGoto action_110
action_319 (75#) = happyGoto action_111
action_319 (99#) = happyGoto action_322
action_319 (100#) = happyGoto action_113
action_319 (103#) = happyGoto action_114
action_319 (113#) = happyGoto action_115
action_319 (114#) = happyGoto action_116
action_319 (115#) = happyGoto action_117
action_319 (121#) = happyGoto action_118
action_319 x = happyTcHack x happyFail

action_320 x = happyTcHack x happyReduce_236

action_321 x = happyTcHack x happyReduce_278

action_322 x = happyTcHack x happyReduce_209

action_323 x = happyTcHack x happyReduce_250

action_324 x = happyTcHack x happyReduce_248

action_325 x = happyTcHack x happyReduce_238

action_326 x = happyTcHack x happyReduce_239

action_327 x = happyTcHack x happyReduce_241

action_328 x = happyTcHack x happyReduce_243

action_329 x = happyTcHack x happyReduce_246

action_330 x = happyTcHack x happyReduce_244

action_331 (127#) = happyShift action_60
action_331 (135#) = happyShift action_61
action_331 (147#) = happyShift action_62
action_331 (151#) = happyShift action_63
action_331 (152#) = happyShift action_64
action_331 (153#) = happyShift action_65
action_331 (154#) = happyShift action_66
action_331 (155#) = happyShift action_67
action_331 (156#) = happyShift action_68
action_331 (157#) = happyShift action_69
action_331 (158#) = happyShift action_70
action_331 (159#) = happyShift action_71
action_331 (203#) = happyShift action_72
action_331 (215#) = happyShift action_73
action_331 (63#) = happyGoto action_55
action_331 (65#) = happyGoto action_57
action_331 (66#) = happyGoto action_307
action_331 (112#) = happyGoto action_344
action_331 x = happyTcHack x happyFail

action_332 (127#) = happyShift action_60
action_332 (135#) = happyShift action_61
action_332 (147#) = happyShift action_62
action_332 (151#) = happyShift action_63
action_332 (152#) = happyShift action_64
action_332 (153#) = happyShift action_65
action_332 (154#) = happyShift action_66
action_332 (155#) = happyShift action_67
action_332 (156#) = happyShift action_68
action_332 (157#) = happyShift action_69
action_332 (158#) = happyShift action_70
action_332 (159#) = happyShift action_71
action_332 (203#) = happyShift action_72
action_332 (215#) = happyShift action_73
action_332 (216#) = happyShift action_32
action_332 (218#) = happyShift action_34
action_332 (14#) = happyGoto action_340
action_332 (15#) = happyGoto action_341
action_332 (63#) = happyGoto action_55
action_332 (65#) = happyGoto action_342
action_332 (71#) = happyGoto action_6
action_332 (78#) = happyGoto action_8
action_332 (79#) = happyGoto action_343
action_332 x = happyTcHack x happyReduce_22

action_333 x = happyTcHack x happyReduce_8

action_334 (224#) = happyReduce_47
action_334 (227#) = happyReduce_47
action_334 (231#) = happyReduce_47
action_334 (25#) = happyGoto action_337
action_334 (26#) = happyGoto action_338
action_334 (125#) = happyGoto action_339
action_334 x = happyTcHack x happyReduce_285

action_335 (216#) = happyShift action_93
action_335 (62#) = happyGoto action_336
action_335 x = happyTcHack x happyFail

action_336 (227#) = happyShift action_354
action_336 x = happyTcHack x happyFail

action_337 x = happyTcHack x happyReduce_45

action_338 (227#) = happyShift action_353
action_338 (30#) = happyGoto action_351
action_338 (38#) = happyGoto action_352
action_338 x = happyTcHack x happyReduce_58

action_339 (142#) = happyShift action_350
action_339 x = happyTcHack x happyFail

action_340 (213#) = happyShift action_349
action_340 x = happyTcHack x happyFail

action_341 (127#) = happyShift action_60
action_341 (135#) = happyShift action_61
action_341 (147#) = happyShift action_62
action_341 (151#) = happyShift action_63
action_341 (152#) = happyShift action_64
action_341 (153#) = happyShift action_65
action_341 (154#) = happyShift action_66
action_341 (155#) = happyShift action_67
action_341 (156#) = happyShift action_68
action_341 (157#) = happyShift action_69
action_341 (158#) = happyShift action_70
action_341 (159#) = happyShift action_71
action_341 (203#) = happyShift action_72
action_341 (215#) = happyShift action_73
action_341 (216#) = happyShift action_32
action_341 (218#) = happyShift action_34
action_341 (14#) = happyGoto action_348
action_341 (15#) = happyGoto action_341
action_341 (63#) = happyGoto action_55
action_341 (65#) = happyGoto action_342
action_341 (71#) = happyGoto action_6
action_341 (78#) = happyGoto action_8
action_341 (79#) = happyGoto action_343
action_341 x = happyTcHack x happyReduce_22

action_342 x = happyTcHack x happyReduce_25

action_343 (196#) = happyShift action_346
action_343 (205#) = happyShift action_347
action_343 (16#) = happyGoto action_345
action_343 x = happyTcHack x happyReduce_24

action_344 x = happyTcHack x happyReduce_252

action_345 x = happyTcHack x happyReduce_26

action_346 (205#) = happyShift action_347
action_346 (16#) = happyGoto action_366
action_346 x = happyTcHack x happyFail

action_347 (127#) = happyShift action_60
action_347 (135#) = happyShift action_61
action_347 (147#) = happyShift action_62
action_347 (151#) = happyShift action_63
action_347 (152#) = happyShift action_64
action_347 (153#) = happyShift action_65
action_347 (154#) = happyShift action_66
action_347 (155#) = happyShift action_67
action_347 (156#) = happyShift action_68
action_347 (157#) = happyShift action_69
action_347 (158#) = happyShift action_70
action_347 (159#) = happyShift action_71
action_347 (203#) = happyShift action_72
action_347 (215#) = happyShift action_73
action_347 (216#) = happyShift action_32
action_347 (218#) = happyShift action_34
action_347 (17#) = happyGoto action_362
action_347 (18#) = happyGoto action_363
action_347 (63#) = happyGoto action_55
action_347 (65#) = happyGoto action_364
action_347 (71#) = happyGoto action_107
action_347 (73#) = happyGoto action_365
action_347 x = happyTcHack x happyFail

action_348 x = happyTcHack x happyReduce_23

action_349 x = happyTcHack x happyReduce_21

action_350 (163#) = happyShift action_16
action_350 (182#) = happyShift action_17
action_350 (183#) = happyShift action_18
action_350 (205#) = happyShift action_27
action_350 (207#) = happyShift action_28
action_350 (209#) = happyShift action_29
action_350 (211#) = happyShift action_30
action_350 (215#) = happyShift action_31
action_350 (216#) = happyShift action_32
action_350 (217#) = happyShift action_33
action_350 (218#) = happyShift action_34
action_350 (220#) = happyShift action_35
action_350 (222#) = happyShift action_36
action_350 (49#) = happyGoto action_361
action_350 (57#) = happyGoto action_4
action_350 (59#) = happyGoto action_5
action_350 (71#) = happyGoto action_6
action_350 (72#) = happyGoto action_7
action_350 (78#) = happyGoto action_8
action_350 (79#) = happyGoto action_9
action_350 (80#) = happyGoto action_10
action_350 (81#) = happyGoto action_11
action_350 (87#) = happyGoto action_12
action_350 x = happyTcHack x happyFail

action_351 (231#) = happyReduce_6
action_351 (29#) = happyGoto action_358
action_351 (31#) = happyGoto action_359
action_351 (125#) = happyGoto action_360
action_351 x = happyTcHack x happyReduce_285

action_352 (27#) = happyGoto action_356
action_352 (125#) = happyGoto action_357
action_352 x = happyTcHack x happyReduce_285

action_353 x = happyTcHack x happyReduce_71

action_354 (203#) = happyShift action_216
action_354 (8#) = happyGoto action_355
action_354 x = happyTcHack x happyReduce_10

action_355 (199#) = happyShift action_382
action_355 (9#) = happyGoto action_381
action_355 x = happyTcHack x happyReduce_12

action_356 (213#) = happyShift action_380
action_356 x = happyTcHack x happyFail

action_357 (127#) = happyShift action_60
action_357 (129#) = happyShift action_373
action_357 (130#) = happyShift action_374
action_357 (135#) = happyShift action_61
action_357 (139#) = happyShift action_375
action_357 (140#) = happyShift action_376
action_357 (141#) = happyShift action_377
action_357 (145#) = happyShift action_378
action_357 (147#) = happyShift action_62
action_357 (149#) = happyShift action_379
action_357 (151#) = happyShift action_63
action_357 (152#) = happyShift action_64
action_357 (153#) = happyShift action_65
action_357 (154#) = happyShift action_66
action_357 (155#) = happyShift action_67
action_357 (156#) = happyShift action_68
action_357 (157#) = happyShift action_69
action_357 (158#) = happyShift action_70
action_357 (159#) = happyShift action_71
action_357 (203#) = happyShift action_72
action_357 (215#) = happyShift action_73
action_357 (19#) = happyGoto action_371
action_357 (63#) = happyGoto action_55
action_357 (65#) = happyGoto action_57
action_357 (66#) = happyGoto action_372
action_357 x = happyTcHack x happyFail

action_358 x = happyTcHack x happyReduce_60

action_359 x = happyTcHack x happyReduce_59

action_360 (224#) = happyShift action_370
action_360 x = happyTcHack x happyFail

action_361 (194#) = happyShift action_369
action_361 x = happyTcHack x happyFail

action_362 (127#) = happyShift action_60
action_362 (135#) = happyShift action_61
action_362 (147#) = happyShift action_62
action_362 (151#) = happyShift action_63
action_362 (152#) = happyShift action_64
action_362 (153#) = happyShift action_65
action_362 (154#) = happyShift action_66
action_362 (155#) = happyShift action_67
action_362 (156#) = happyShift action_68
action_362 (157#) = happyShift action_69
action_362 (158#) = happyShift action_70
action_362 (159#) = happyShift action_71
action_362 (203#) = happyShift action_72
action_362 (215#) = happyShift action_73
action_362 (216#) = happyShift action_32
action_362 (218#) = happyShift action_34
action_362 (17#) = happyGoto action_362
action_362 (18#) = happyGoto action_368
action_362 (63#) = happyGoto action_55
action_362 (65#) = happyGoto action_364
action_362 (71#) = happyGoto action_107
action_362 (73#) = happyGoto action_365
action_362 x = happyTcHack x happyReduce_31

action_363 (206#) = happyShift action_367
action_363 x = happyTcHack x happyFail

action_364 x = happyTcHack x happyReduce_29

action_365 x = happyTcHack x happyReduce_30

action_366 x = happyTcHack x happyReduce_27

action_367 x = happyTcHack x happyReduce_28

action_368 x = happyTcHack x happyReduce_32

action_369 (127#) = happyShift action_60
action_369 (135#) = happyShift action_61
action_369 (147#) = happyShift action_62
action_369 (151#) = happyShift action_63
action_369 (152#) = happyShift action_64
action_369 (153#) = happyShift action_65
action_369 (154#) = happyShift action_66
action_369 (155#) = happyShift action_67
action_369 (156#) = happyShift action_68
action_369 (157#) = happyShift action_69
action_369 (158#) = happyShift action_70
action_369 (159#) = happyShift action_71
action_369 (203#) = happyShift action_72
action_369 (215#) = happyShift action_73
action_369 (63#) = happyGoto action_55
action_369 (65#) = happyGoto action_57
action_369 (66#) = happyGoto action_393
action_369 x = happyTcHack x happyFail

action_370 x = happyTcHack x happyReduce_57

action_371 (227#) = happyShift action_392
action_371 (20#) = happyGoto action_391
action_371 x = happyTcHack x happyReduce_36

action_372 (193#) = happyShift action_390
action_372 x = happyTcHack x happyFail

action_373 (205#) = happyShift action_387
action_373 (39#) = happyGoto action_389
action_373 x = happyTcHack x happyReduce_72

action_374 (205#) = happyShift action_387
action_374 (39#) = happyGoto action_388
action_374 x = happyTcHack x happyReduce_72

action_375 x = happyTcHack x happyReduce_35

action_376 x = happyTcHack x happyReduce_33

action_377 x = happyTcHack x happyReduce_34

action_378 (205#) = happyShift action_387
action_378 (39#) = happyGoto action_386
action_378 x = happyTcHack x happyReduce_72

action_379 (216#) = happyShift action_32
action_379 (218#) = happyShift action_34
action_379 (71#) = happyGoto action_6
action_379 (78#) = happyGoto action_8
action_379 (79#) = happyGoto action_9
action_379 (80#) = happyGoto action_385
action_379 x = happyTcHack x happyFail

action_380 x = happyTcHack x happyReduce_48

action_381 (193#) = happyShift action_384
action_381 (10#) = happyGoto action_383
action_381 x = happyTcHack x happyReduce_14

action_382 x = happyTcHack x happyReduce_13

action_383 (213#) = happyShift action_408
action_383 x = happyTcHack x happyFail

action_384 (127#) = happyShift action_60
action_384 (135#) = happyShift action_61
action_384 (147#) = happyShift action_62
action_384 (151#) = happyShift action_63
action_384 (152#) = happyShift action_64
action_384 (153#) = happyShift action_65
action_384 (154#) = happyShift action_66
action_384 (155#) = happyShift action_67
action_384 (156#) = happyShift action_68
action_384 (157#) = happyShift action_69
action_384 (158#) = happyShift action_70
action_384 (159#) = happyShift action_71
action_384 (203#) = happyShift action_72
action_384 (215#) = happyShift action_73
action_384 (216#) = happyShift action_32
action_384 (218#) = happyShift action_34
action_384 (11#) = happyGoto action_404
action_384 (12#) = happyGoto action_405
action_384 (63#) = happyGoto action_55
action_384 (65#) = happyGoto action_406
action_384 (71#) = happyGoto action_6
action_384 (78#) = happyGoto action_8
action_384 (79#) = happyGoto action_407
action_384 x = happyTcHack x happyReduce_16

action_385 (215#) = happyShift action_31
action_385 (217#) = happyShift action_33
action_385 (87#) = happyGoto action_94
action_385 (88#) = happyGoto action_95
action_385 (89#) = happyGoto action_403
action_385 x = happyTcHack x happyReduce_183

action_386 (216#) = happyShift action_32
action_386 (218#) = happyShift action_34
action_386 (71#) = happyGoto action_6
action_386 (78#) = happyGoto action_8
action_386 (79#) = happyGoto action_9
action_386 (80#) = happyGoto action_402
action_386 x = happyTcHack x happyFail

action_387 (216#) = happyShift action_32
action_387 (218#) = happyShift action_34
action_387 (220#) = happyShift action_35
action_387 (222#) = happyShift action_36
action_387 (223#) = happyShift action_48
action_387 (53#) = happyGoto action_401
action_387 (54#) = happyGoto action_207
action_387 (68#) = happyGoto action_208
action_387 (71#) = happyGoto action_44
action_387 (72#) = happyGoto action_45
action_387 (82#) = happyGoto action_46
action_387 (83#) = happyGoto action_209
action_387 x = happyTcHack x happyFail

action_388 (216#) = happyShift action_32
action_388 (218#) = happyShift action_34
action_388 (71#) = happyGoto action_6
action_388 (78#) = happyGoto action_8
action_388 (79#) = happyGoto action_9
action_388 (80#) = happyGoto action_400
action_388 x = happyTcHack x happyFail

action_389 (216#) = happyShift action_32
action_389 (218#) = happyShift action_34
action_389 (71#) = happyGoto action_6
action_389 (78#) = happyGoto action_8
action_389 (79#) = happyGoto action_9
action_389 (80#) = happyGoto action_399
action_389 x = happyTcHack x happyFail

action_390 (163#) = happyShift action_16
action_390 (182#) = happyShift action_17
action_390 (183#) = happyShift action_18
action_390 (205#) = happyShift action_27
action_390 (207#) = happyShift action_28
action_390 (209#) = happyShift action_29
action_390 (211#) = happyShift action_30
action_390 (215#) = happyShift action_31
action_390 (216#) = happyShift action_32
action_390 (217#) = happyShift action_33
action_390 (218#) = happyShift action_34
action_390 (220#) = happyShift action_35
action_390 (222#) = happyShift action_36
action_390 (49#) = happyGoto action_398
action_390 (57#) = happyGoto action_4
action_390 (59#) = happyGoto action_5
action_390 (71#) = happyGoto action_6
action_390 (72#) = happyGoto action_7
action_390 (78#) = happyGoto action_8
action_390 (79#) = happyGoto action_9
action_390 (80#) = happyGoto action_10
action_390 (81#) = happyGoto action_11
action_390 (87#) = happyGoto action_12
action_390 x = happyTcHack x happyFail

action_391 (127#) = happyShift action_60
action_391 (135#) = happyShift action_61
action_391 (147#) = happyShift action_62
action_391 (151#) = happyShift action_63
action_391 (152#) = happyShift action_64
action_391 (153#) = happyShift action_65
action_391 (154#) = happyShift action_66
action_391 (155#) = happyShift action_67
action_391 (156#) = happyShift action_68
action_391 (157#) = happyShift action_69
action_391 (158#) = happyShift action_70
action_391 (159#) = happyShift action_71
action_391 (203#) = happyShift action_72
action_391 (215#) = happyShift action_73
action_391 (216#) = happyShift action_32
action_391 (218#) = happyShift action_34
action_391 (63#) = happyGoto action_55
action_391 (65#) = happyGoto action_57
action_391 (66#) = happyGoto action_395
action_391 (71#) = happyGoto action_107
action_391 (73#) = happyGoto action_109
action_391 (74#) = happyGoto action_396
action_391 (77#) = happyGoto action_397
action_391 x = happyTcHack x happyFail

action_392 x = happyTcHack x happyReduce_37

action_393 (213#) = happyShift action_394
action_393 x = happyTcHack x happyFail

action_394 x = happyTcHack x happyReduce_46

action_395 x = happyTcHack x happyReduce_165

action_396 x = happyTcHack x happyReduce_166

action_397 x = happyTcHack x happyReduce_54

action_398 (224#) = happyReduce_285
action_398 (28#) = happyGoto action_417
action_398 (29#) = happyGoto action_418
action_398 (125#) = happyGoto action_360
action_398 x = happyTcHack x happyReduce_55

action_399 (215#) = happyShift action_31
action_399 (217#) = happyShift action_33
action_399 (87#) = happyGoto action_94
action_399 (88#) = happyGoto action_95
action_399 (89#) = happyGoto action_416
action_399 x = happyTcHack x happyReduce_183

action_400 (215#) = happyShift action_31
action_400 (217#) = happyShift action_33
action_400 (87#) = happyGoto action_94
action_400 (88#) = happyGoto action_95
action_400 (89#) = happyGoto action_415
action_400 x = happyTcHack x happyReduce_183

action_401 (206#) = happyShift action_414
action_401 x = happyTcHack x happyFail

action_402 (215#) = happyShift action_31
action_402 (217#) = happyShift action_33
action_402 (87#) = happyGoto action_94
action_402 (88#) = happyGoto action_95
action_402 (89#) = happyGoto action_413
action_402 x = happyTcHack x happyReduce_183

action_403 (194#) = happyShift action_412
action_403 x = happyTcHack x happyFail

action_404 x = happyTcHack x happyReduce_15

action_405 (127#) = happyShift action_60
action_405 (135#) = happyShift action_61
action_405 (147#) = happyShift action_62
action_405 (151#) = happyShift action_63
action_405 (152#) = happyShift action_64
action_405 (153#) = happyShift action_65
action_405 (154#) = happyShift action_66
action_405 (155#) = happyShift action_67
action_405 (156#) = happyShift action_68
action_405 (157#) = happyShift action_69
action_405 (158#) = happyShift action_70
action_405 (159#) = happyShift action_71
action_405 (203#) = happyShift action_72
action_405 (215#) = happyShift action_73
action_405 (216#) = happyShift action_32
action_405 (218#) = happyShift action_34
action_405 (11#) = happyGoto action_411
action_405 (12#) = happyGoto action_405
action_405 (63#) = happyGoto action_55
action_405 (65#) = happyGoto action_406
action_405 (71#) = happyGoto action_6
action_405 (78#) = happyGoto action_8
action_405 (79#) = happyGoto action_407
action_405 x = happyTcHack x happyReduce_16

action_406 (227#) = happyShift action_410
action_406 x = happyTcHack x happyFail

action_407 (227#) = happyShift action_409
action_407 x = happyTcHack x happyFail

action_408 x = happyTcHack x happyReduce_9

action_409 x = happyTcHack x happyReduce_19

action_410 x = happyTcHack x happyReduce_18

action_411 x = happyTcHack x happyReduce_17

action_412 (163#) = happyShift action_16
action_412 (182#) = happyShift action_17
action_412 (183#) = happyShift action_18
action_412 (205#) = happyShift action_27
action_412 (207#) = happyShift action_28
action_412 (209#) = happyShift action_29
action_412 (211#) = happyShift action_30
action_412 (215#) = happyShift action_31
action_412 (216#) = happyShift action_32
action_412 (217#) = happyShift action_33
action_412 (218#) = happyShift action_34
action_412 (220#) = happyShift action_35
action_412 (222#) = happyShift action_36
action_412 (49#) = happyGoto action_426
action_412 (57#) = happyGoto action_4
action_412 (59#) = happyGoto action_5
action_412 (71#) = happyGoto action_6
action_412 (72#) = happyGoto action_7
action_412 (78#) = happyGoto action_8
action_412 (79#) = happyGoto action_9
action_412 (80#) = happyGoto action_10
action_412 (81#) = happyGoto action_11
action_412 (87#) = happyGoto action_12
action_412 x = happyTcHack x happyFail

action_413 (213#) = happyReduce_80
action_413 (43#) = happyGoto action_424
action_413 (125#) = happyGoto action_425
action_413 x = happyTcHack x happyReduce_285

action_414 (201#) = happyShift action_423
action_414 x = happyTcHack x happyFail

action_415 (194#) = happyShift action_422
action_415 (40#) = happyGoto action_421
action_415 x = happyTcHack x happyReduce_74

action_416 (196#) = happyShift action_420
action_416 (90#) = happyGoto action_419
action_416 x = happyTcHack x happyReduce_185

action_417 x = happyTcHack x happyReduce_49

action_418 x = happyTcHack x happyReduce_56

action_419 (150#) = happyShift action_435
action_419 (21#) = happyGoto action_434
action_419 x = happyTcHack x happyReduce_38

action_420 (91#) = happyGoto action_431
action_420 (92#) = happyGoto action_432
action_420 (93#) = happyGoto action_433
action_420 x = happyTcHack x happyReduce_190

action_421 x = happyTcHack x happyReduce_51

action_422 (41#) = happyGoto action_428
action_422 (42#) = happyGoto action_429
action_422 (125#) = happyGoto action_430
action_422 x = happyTcHack x happyReduce_285

action_423 x = happyTcHack x happyReduce_73

action_424 x = happyTcHack x happyReduce_52

action_425 (194#) = happyShift action_427
action_425 x = happyTcHack x happyFail

action_426 x = happyTcHack x happyReduce_50

action_427 (163#) = happyShift action_441
action_427 (44#) = happyGoto action_443
action_427 x = happyTcHack x happyReduce_83

action_428 x = happyTcHack x happyReduce_75

action_429 (196#) = happyShift action_442
action_429 x = happyTcHack x happyReduce_76

action_430 (163#) = happyShift action_441
action_430 (44#) = happyGoto action_440
action_430 x = happyTcHack x happyReduce_83

action_431 (214#) = happyShift action_439
action_431 x = happyTcHack x happyReduce_186

action_432 x = happyTcHack x happyReduce_188

action_433 (198#) = happyShift action_438
action_433 (215#) = happyShift action_31
action_433 (217#) = happyShift action_33
action_433 (87#) = happyGoto action_437
action_433 x = happyTcHack x happyFail

action_434 x = happyTcHack x happyReduce_53

action_435 (205#) = happyShift action_436
action_435 x = happyTcHack x happyFail

action_436 (22#) = happyGoto action_450
action_436 (23#) = happyGoto action_451
action_436 (125#) = happyGoto action_452
action_436 x = happyTcHack x happyReduce_285

action_437 x = happyTcHack x happyReduce_191

action_438 (93#) = happyGoto action_449
action_438 x = happyTcHack x happyReduce_190

action_439 (92#) = happyGoto action_448
action_439 (93#) = happyGoto action_433
action_439 x = happyTcHack x happyReduce_190

action_440 (216#) = happyShift action_32
action_440 (218#) = happyShift action_34
action_440 (71#) = happyGoto action_107
action_440 (73#) = happyGoto action_109
action_440 (74#) = happyGoto action_447
action_440 x = happyTcHack x happyFail

action_441 (207#) = happyShift action_85
action_441 (51#) = happyGoto action_446
action_441 x = happyTcHack x happyFail

action_442 (41#) = happyGoto action_445
action_442 (42#) = happyGoto action_429
action_442 (125#) = happyGoto action_430
action_442 x = happyTcHack x happyReduce_285

action_443 (216#) = happyShift action_32
action_443 (218#) = happyShift action_34
action_443 (71#) = happyGoto action_107
action_443 (73#) = happyGoto action_109
action_443 (74#) = happyGoto action_444
action_443 x = happyTcHack x happyFail

action_444 (205#) = happyShift action_463
action_444 (207#) = happyShift action_28
action_444 (209#) = happyShift action_29
action_444 (211#) = happyShift action_30
action_444 (215#) = happyShift action_31
action_444 (216#) = happyShift action_32
action_444 (217#) = happyShift action_33
action_444 (218#) = happyShift action_34
action_444 (220#) = happyShift action_35
action_444 (222#) = happyShift action_36
action_444 (59#) = happyGoto action_462
action_444 (71#) = happyGoto action_6
action_444 (72#) = happyGoto action_7
action_444 (78#) = happyGoto action_8
action_444 (79#) = happyGoto action_9
action_444 (80#) = happyGoto action_10
action_444 (81#) = happyGoto action_11
action_444 (87#) = happyGoto action_12
action_444 x = happyTcHack x happyFail

action_445 x = happyTcHack x happyReduce_77

action_446 (205#) = happyShift action_98
action_446 (52#) = happyGoto action_461
action_446 x = happyTcHack x happyReduce_101

action_447 (203#) = happyShift action_459
action_447 (205#) = happyShift action_460
action_447 (207#) = happyShift action_28
action_447 (209#) = happyShift action_29
action_447 (211#) = happyShift action_30
action_447 (215#) = happyShift action_31
action_447 (216#) = happyShift action_32
action_447 (217#) = happyShift action_33
action_447 (218#) = happyShift action_34
action_447 (220#) = happyShift action_35
action_447 (222#) = happyShift action_36
action_447 (45#) = happyGoto action_456
action_447 (46#) = happyGoto action_457
action_447 (59#) = happyGoto action_458
action_447 (71#) = happyGoto action_6
action_447 (72#) = happyGoto action_7
action_447 (78#) = happyGoto action_8
action_447 (79#) = happyGoto action_9
action_447 (80#) = happyGoto action_10
action_447 (81#) = happyGoto action_11
action_447 (87#) = happyGoto action_12
action_447 x = happyTcHack x happyReduce_85

action_448 x = happyTcHack x happyReduce_187

action_449 (215#) = happyShift action_31
action_449 (217#) = happyShift action_33
action_449 (87#) = happyGoto action_437
action_449 x = happyTcHack x happyReduce_189

action_450 (206#) = happyShift action_455
action_450 x = happyTcHack x happyFail

action_451 (213#) = happyShift action_454
action_451 x = happyTcHack x happyReduce_40

action_452 (127#) = happyShift action_60
action_452 (135#) = happyShift action_61
action_452 (147#) = happyShift action_62
action_452 (151#) = happyShift action_63
action_452 (152#) = happyShift action_64
action_452 (153#) = happyShift action_65
action_452 (154#) = happyShift action_66
action_452 (155#) = happyShift action_67
action_452 (156#) = happyShift action_68
action_452 (157#) = happyShift action_69
action_452 (158#) = happyShift action_70
action_452 (159#) = happyShift action_71
action_452 (203#) = happyShift action_72
action_452 (215#) = happyShift action_73
action_452 (63#) = happyGoto action_55
action_452 (65#) = happyGoto action_57
action_452 (66#) = happyGoto action_453
action_452 x = happyTcHack x happyFail

action_453 (193#) = happyShift action_474
action_453 (194#) = happyShift action_475
action_453 x = happyTcHack x happyFail

action_454 (22#) = happyGoto action_473
action_454 (23#) = happyGoto action_451
action_454 (125#) = happyGoto action_452
action_454 x = happyTcHack x happyReduce_285

action_455 x = happyTcHack x happyReduce_39

action_456 x = happyTcHack x happyReduce_78

action_457 (203#) = happyShift action_459
action_457 (205#) = happyShift action_27
action_457 (207#) = happyShift action_28
action_457 (209#) = happyShift action_29
action_457 (211#) = happyShift action_30
action_457 (215#) = happyShift action_31
action_457 (216#) = happyShift action_32
action_457 (217#) = happyShift action_33
action_457 (218#) = happyShift action_34
action_457 (220#) = happyShift action_35
action_457 (222#) = happyShift action_36
action_457 (45#) = happyGoto action_472
action_457 (46#) = happyGoto action_457
action_457 (59#) = happyGoto action_458
action_457 (71#) = happyGoto action_6
action_457 (72#) = happyGoto action_7
action_457 (78#) = happyGoto action_8
action_457 (79#) = happyGoto action_9
action_457 (80#) = happyGoto action_10
action_457 (81#) = happyGoto action_11
action_457 (87#) = happyGoto action_12
action_457 x = happyTcHack x happyReduce_85

action_458 x = happyTcHack x happyReduce_87

action_459 (203#) = happyShift action_471
action_459 (205#) = happyShift action_27
action_459 (207#) = happyShift action_28
action_459 (209#) = happyShift action_29
action_459 (211#) = happyShift action_30
action_459 (215#) = happyShift action_31
action_459 (216#) = happyShift action_32
action_459 (217#) = happyShift action_33
action_459 (218#) = happyShift action_34
action_459 (220#) = happyShift action_35
action_459 (222#) = happyShift action_36
action_459 (59#) = happyGoto action_470
action_459 (71#) = happyGoto action_6
action_459 (72#) = happyGoto action_7
action_459 (78#) = happyGoto action_8
action_459 (79#) = happyGoto action_9
action_459 (80#) = happyGoto action_10
action_459 (81#) = happyGoto action_11
action_459 (87#) = happyGoto action_12
action_459 x = happyTcHack x happyFail

action_460 (127#) = happyShift action_60
action_460 (135#) = happyShift action_61
action_460 (147#) = happyShift action_62
action_460 (151#) = happyShift action_63
action_460 (152#) = happyShift action_64
action_460 (153#) = happyShift action_65
action_460 (154#) = happyShift action_66
action_460 (155#) = happyShift action_67
action_460 (156#) = happyShift action_68
action_460 (157#) = happyShift action_69
action_460 (158#) = happyShift action_70
action_460 (159#) = happyShift action_71
action_460 (203#) = happyShift action_72
action_460 (215#) = happyShift action_73
action_460 (216#) = happyShift action_32
action_460 (218#) = happyShift action_34
action_460 (220#) = happyShift action_35
action_460 (222#) = happyShift action_36
action_460 (223#) = happyShift action_48
action_460 (47#) = happyGoto action_466
action_460 (48#) = happyGoto action_467
action_460 (63#) = happyGoto action_55
action_460 (65#) = happyGoto action_57
action_460 (66#) = happyGoto action_468
action_460 (68#) = happyGoto action_43
action_460 (70#) = happyGoto action_469
action_460 (71#) = happyGoto action_44
action_460 (72#) = happyGoto action_45
action_460 (82#) = happyGoto action_46
action_460 (83#) = happyGoto action_47
action_460 x = happyTcHack x happyFail

action_461 (201#) = happyShift action_465
action_461 x = happyTcHack x happyFail

action_462 x = happyTcHack x happyReduce_81

action_463 (127#) = happyShift action_60
action_463 (135#) = happyShift action_61
action_463 (147#) = happyShift action_62
action_463 (151#) = happyShift action_63
action_463 (152#) = happyShift action_64
action_463 (153#) = happyShift action_65
action_463 (154#) = happyShift action_66
action_463 (155#) = happyShift action_67
action_463 (156#) = happyShift action_68
action_463 (157#) = happyShift action_69
action_463 (158#) = happyShift action_70
action_463 (159#) = happyShift action_71
action_463 (203#) = happyShift action_72
action_463 (215#) = happyShift action_73
action_463 (216#) = happyShift action_32
action_463 (218#) = happyShift action_34
action_463 (220#) = happyShift action_35
action_463 (222#) = happyShift action_36
action_463 (223#) = happyShift action_48
action_463 (63#) = happyGoto action_55
action_463 (65#) = happyGoto action_57
action_463 (66#) = happyGoto action_464
action_463 (68#) = happyGoto action_43
action_463 (71#) = happyGoto action_44
action_463 (72#) = happyGoto action_45
action_463 (82#) = happyGoto action_46
action_463 (83#) = happyGoto action_47
action_463 x = happyTcHack x happyFail

action_464 (193#) = happyShift action_484
action_464 x = happyTcHack x happyFail

action_465 x = happyTcHack x happyReduce_84

action_466 (206#) = happyShift action_483
action_466 x = happyTcHack x happyFail

action_467 (214#) = happyShift action_482
action_467 x = happyTcHack x happyReduce_90

action_468 (127#) = happyShift action_60
action_468 (135#) = happyShift action_61
action_468 (147#) = happyShift action_62
action_468 (151#) = happyShift action_63
action_468 (152#) = happyShift action_64
action_468 (153#) = happyShift action_65
action_468 (154#) = happyShift action_66
action_468 (155#) = happyShift action_67
action_468 (156#) = happyShift action_68
action_468 (157#) = happyShift action_69
action_468 (158#) = happyShift action_70
action_468 (159#) = happyShift action_71
action_468 (203#) = happyShift action_72
action_468 (215#) = happyShift action_73
action_468 (63#) = happyGoto action_55
action_468 (65#) = happyGoto action_57
action_468 (66#) = happyGoto action_480
action_468 (69#) = happyGoto action_481
action_468 x = happyTcHack x happyReduce_152

action_469 (193#) = happyShift action_479
action_469 x = happyTcHack x happyFail

action_470 x = happyTcHack x happyReduce_88

action_471 (205#) = happyShift action_27
action_471 (207#) = happyShift action_28
action_471 (209#) = happyShift action_29
action_471 (211#) = happyShift action_30
action_471 (215#) = happyShift action_31
action_471 (216#) = happyShift action_32
action_471 (217#) = happyShift action_33
action_471 (218#) = happyShift action_34
action_471 (220#) = happyShift action_35
action_471 (222#) = happyShift action_36
action_471 (59#) = happyGoto action_478
action_471 (71#) = happyGoto action_6
action_471 (72#) = happyGoto action_7
action_471 (78#) = happyGoto action_8
action_471 (79#) = happyGoto action_9
action_471 (80#) = happyGoto action_10
action_471 (81#) = happyGoto action_11
action_471 (87#) = happyGoto action_12
action_471 x = happyTcHack x happyFail

action_472 x = happyTcHack x happyReduce_86

action_473 x = happyTcHack x happyReduce_41

action_474 (163#) = happyShift action_16
action_474 (182#) = happyShift action_17
action_474 (183#) = happyShift action_18
action_474 (205#) = happyShift action_27
action_474 (207#) = happyShift action_28
action_474 (209#) = happyShift action_29
action_474 (211#) = happyShift action_30
action_474 (215#) = happyShift action_31
action_474 (216#) = happyShift action_32
action_474 (217#) = happyShift action_33
action_474 (218#) = happyShift action_34
action_474 (220#) = happyShift action_35
action_474 (222#) = happyShift action_36
action_474 (49#) = happyGoto action_477
action_474 (57#) = happyGoto action_4
action_474 (59#) = happyGoto action_5
action_474 (71#) = happyGoto action_6
action_474 (72#) = happyGoto action_7
action_474 (78#) = happyGoto action_8
action_474 (79#) = happyGoto action_9
action_474 (80#) = happyGoto action_10
action_474 (81#) = happyGoto action_11
action_474 (87#) = happyGoto action_12
action_474 x = happyTcHack x happyFail

action_475 (193#) = happyShift action_476
action_475 x = happyTcHack x happyFail

action_476 (163#) = happyShift action_16
action_476 (182#) = happyShift action_17
action_476 (183#) = happyShift action_18
action_476 (205#) = happyShift action_27
action_476 (207#) = happyShift action_28
action_476 (209#) = happyShift action_29
action_476 (211#) = happyShift action_30
action_476 (215#) = happyShift action_31
action_476 (216#) = happyShift action_32
action_476 (217#) = happyShift action_33
action_476 (218#) = happyShift action_34
action_476 (220#) = happyShift action_35
action_476 (222#) = happyShift action_36
action_476 (49#) = happyGoto action_490
action_476 (57#) = happyGoto action_4
action_476 (59#) = happyGoto action_5
action_476 (71#) = happyGoto action_6
action_476 (72#) = happyGoto action_7
action_476 (78#) = happyGoto action_8
action_476 (79#) = happyGoto action_9
action_476 (80#) = happyGoto action_10
action_476 (81#) = happyGoto action_11
action_476 (87#) = happyGoto action_12
action_476 x = happyTcHack x happyFail

action_477 x = happyTcHack x happyReduce_42

action_478 x = happyTcHack x happyReduce_89

action_479 (163#) = happyShift action_16
action_479 (182#) = happyShift action_17
action_479 (183#) = happyShift action_18
action_479 (203#) = happyShift action_489
action_479 (205#) = happyShift action_27
action_479 (207#) = happyShift action_28
action_479 (209#) = happyShift action_29
action_479 (211#) = happyShift action_30
action_479 (215#) = happyShift action_31
action_479 (216#) = happyShift action_32
action_479 (217#) = happyShift action_33
action_479 (218#) = happyShift action_34
action_479 (220#) = happyShift action_35
action_479 (222#) = happyShift action_36
action_479 (49#) = happyGoto action_488
action_479 (57#) = happyGoto action_4
action_479 (59#) = happyGoto action_5
action_479 (71#) = happyGoto action_6
action_479 (72#) = happyGoto action_7
action_479 (78#) = happyGoto action_8
action_479 (79#) = happyGoto action_9
action_479 (80#) = happyGoto action_10
action_479 (81#) = happyGoto action_11
action_479 (87#) = happyGoto action_12
action_479 x = happyTcHack x happyFail

action_480 (127#) = happyShift action_60
action_480 (135#) = happyShift action_61
action_480 (147#) = happyShift action_62
action_480 (151#) = happyShift action_63
action_480 (152#) = happyShift action_64
action_480 (153#) = happyShift action_65
action_480 (154#) = happyShift action_66
action_480 (155#) = happyShift action_67
action_480 (156#) = happyShift action_68
action_480 (157#) = happyShift action_69
action_480 (158#) = happyShift action_70
action_480 (159#) = happyShift action_71
action_480 (203#) = happyShift action_72
action_480 (215#) = happyShift action_73
action_480 (63#) = happyGoto action_55
action_480 (65#) = happyGoto action_57
action_480 (66#) = happyGoto action_480
action_480 (69#) = happyGoto action_487
action_480 x = happyTcHack x happyReduce_152

action_481 x = happyTcHack x happyReduce_154

action_482 (127#) = happyShift action_60
action_482 (135#) = happyShift action_61
action_482 (147#) = happyShift action_62
action_482 (151#) = happyShift action_63
action_482 (152#) = happyShift action_64
action_482 (153#) = happyShift action_65
action_482 (154#) = happyShift action_66
action_482 (155#) = happyShift action_67
action_482 (156#) = happyShift action_68
action_482 (157#) = happyShift action_69
action_482 (158#) = happyShift action_70
action_482 (159#) = happyShift action_71
action_482 (203#) = happyShift action_72
action_482 (215#) = happyShift action_73
action_482 (47#) = happyGoto action_486
action_482 (48#) = happyGoto action_467
action_482 (63#) = happyGoto action_55
action_482 (65#) = happyGoto action_57
action_482 (66#) = happyGoto action_468
action_482 (70#) = happyGoto action_469
action_482 x = happyTcHack x happyFail

action_483 x = happyTcHack x happyReduce_79

action_484 (205#) = happyShift action_27
action_484 (207#) = happyShift action_28
action_484 (209#) = happyShift action_29
action_484 (211#) = happyShift action_30
action_484 (215#) = happyShift action_31
action_484 (216#) = happyShift action_32
action_484 (217#) = happyShift action_33
action_484 (218#) = happyShift action_34
action_484 (220#) = happyShift action_35
action_484 (222#) = happyShift action_36
action_484 (59#) = happyGoto action_485
action_484 (71#) = happyGoto action_6
action_484 (72#) = happyGoto action_7
action_484 (78#) = happyGoto action_8
action_484 (79#) = happyGoto action_9
action_484 (80#) = happyGoto action_10
action_484 (81#) = happyGoto action_11
action_484 (87#) = happyGoto action_12
action_484 x = happyTcHack x happyFail

action_485 (206#) = happyShift action_493
action_485 x = happyTcHack x happyFail

action_486 x = happyTcHack x happyReduce_91

action_487 x = happyTcHack x happyReduce_153

action_488 x = happyTcHack x happyReduce_92

action_489 (163#) = happyShift action_16
action_489 (182#) = happyShift action_17
action_489 (183#) = happyShift action_18
action_489 (203#) = happyShift action_492
action_489 (205#) = happyShift action_27
action_489 (207#) = happyShift action_28
action_489 (209#) = happyShift action_29
action_489 (211#) = happyShift action_30
action_489 (215#) = happyShift action_31
action_489 (216#) = happyShift action_32
action_489 (217#) = happyShift action_33
action_489 (218#) = happyShift action_34
action_489 (220#) = happyShift action_35
action_489 (222#) = happyShift action_36
action_489 (49#) = happyGoto action_491
action_489 (57#) = happyGoto action_4
action_489 (59#) = happyGoto action_5
action_489 (71#) = happyGoto action_6
action_489 (72#) = happyGoto action_7
action_489 (78#) = happyGoto action_8
action_489 (79#) = happyGoto action_9
action_489 (80#) = happyGoto action_10
action_489 (81#) = happyGoto action_11
action_489 (87#) = happyGoto action_12
action_489 x = happyTcHack x happyFail

action_490 x = happyTcHack x happyReduce_43

action_491 x = happyTcHack x happyReduce_93

action_492 (163#) = happyShift action_16
action_492 (182#) = happyShift action_17
action_492 (183#) = happyShift action_18
action_492 (205#) = happyShift action_27
action_492 (207#) = happyShift action_28
action_492 (209#) = happyShift action_29
action_492 (211#) = happyShift action_30
action_492 (215#) = happyShift action_31
action_492 (216#) = happyShift action_32
action_492 (217#) = happyShift action_33
action_492 (218#) = happyShift action_34
action_492 (220#) = happyShift action_35
action_492 (222#) = happyShift action_36
action_492 (49#) = happyGoto action_494
action_492 (57#) = happyGoto action_4
action_492 (59#) = happyGoto action_5
action_492 (71#) = happyGoto action_6
action_492 (72#) = happyGoto action_7
action_492 (78#) = happyGoto action_8
action_492 (79#) = happyGoto action_9
action_492 (80#) = happyGoto action_10
action_492 (81#) = happyGoto action_11
action_492 (87#) = happyGoto action_12
action_492 x = happyTcHack x happyFail

action_493 x = happyTcHack x happyReduce_82

action_494 x = happyTcHack x happyReduce_94

happyReduce_1 = happySpecReduce_1 4# reduction where {
  reduction
	(HappyAbsSyn5  happy_var_1)
	 =  HappyAbsSyn4
		 (PIface   happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_2 = happySpecReduce_1 4# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn4
		 (PType    happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_3 = happySpecReduce_1 4# reduction where {
  reduction
	(HappyAbsSyn96  happy_var_1)
	 =  HappyAbsSyn4
		 (PIdInfo  happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_4 = happySpecReduce_2 4# reduction where {
  reduction
	(HappyAbsSyn32  happy_var_2)
	_
	 =  HappyAbsSyn4
		 (PRules   happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_5 = happySpecReduce_2 4# reduction where {
  reduction
	(HappyAbsSyn35  happy_var_2)
	_
	 =  HappyAbsSyn4
		 (PDeprecs happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_6 = happyReduce 12# 5# reduction where {
  reduction
	((HappyAbsSyn30  happy_var_12) :
	(HappyAbsSyn26  happy_var_11) :
	(HappyAbsSyn24  happy_var_10) :
	(HappyAbsSyn6  happy_var_9) :
	(HappyAbsSyn13  happy_var_8) :
	_ :
	_ :
	(HappyAbsSyn8  happy_var_5) :
	(HappyTerminal (ITinteger  happy_var_4)) :
	(HappyAbsSyn62  happy_var_3) :
	(HappyAbsSyn61  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn5
		 (ParsedIface {
			pi_mod  = mkModule happy_var_3 happy_var_2,	-- Module itself
			pi_vers = fromInteger happy_var_4, 	-- Module version
			pi_orphan  = happy_var_5,
			pi_exports = happy_var_8,        -- Exports
			pi_usages  = happy_var_9,	-- Usages
			pi_insts   = happy_var_10,	-- Local instances
			pi_decls   = happy_var_11,	-- Decls
		 	pi_rules   = fst happy_var_12,	-- Rules 
		 	pi_deprecs = snd happy_var_12	-- Deprecations 
		      }) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_7 = happySpecReduce_0 6# reduction where {
  reduction
	 =  HappyAbsSyn6
		 ([])}

happyReduce_8 = happySpecReduce_2 6# reduction where {
  reduction
	(HappyAbsSyn7  happy_var_2)
	(HappyAbsSyn6  happy_var_1)
	 =  HappyAbsSyn6
		 (happy_var_2 : happy_var_1);
  reduction _ _  = notHappyAtAll }

happyReduce_9 = happyReduce 7# 7# reduction where {
  reduction
	(_ :
	(HappyAbsSyn10  happy_var_6) :
	(HappyAbsSyn9  happy_var_5) :
	(HappyAbsSyn8  happy_var_4) :
	(HappyTerminal (ITinteger  happy_var_3)) :
	(HappyAbsSyn62  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn7
		 ((mkSysModuleFS happy_var_2, fromInteger happy_var_3, happy_var_4, happy_var_5, happy_var_6)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_10 = happySpecReduce_0 8# reduction where {
  reduction
	 =  HappyAbsSyn8
		 (False)}

happyReduce_11 = happySpecReduce_1 8# reduction where {
  reduction
	_
	 =  HappyAbsSyn8
		 (True)}

happyReduce_12 = happySpecReduce_0 9# reduction where {
  reduction
	 =  HappyAbsSyn9
		 (False)}

happyReduce_13 = happySpecReduce_1 9# reduction where {
  reduction
	_
	 =  HappyAbsSyn9
		 (True)}

happyReduce_14 = happySpecReduce_0 10# reduction where {
  reduction
	 =  HappyAbsSyn10
		 (Everything)}

happyReduce_15 = happySpecReduce_2 10# reduction where {
  reduction
	(HappyAbsSyn11  happy_var_2)
	_
	 =  HappyAbsSyn10
		 (Specifically happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_16 = happySpecReduce_0 11# reduction where {
  reduction
	 =  HappyAbsSyn11
		 ([])}

happyReduce_17 = happySpecReduce_2 11# reduction where {
  reduction
	(HappyAbsSyn11  happy_var_2)
	(HappyAbsSyn12  happy_var_1)
	 =  HappyAbsSyn11
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_18 = happySpecReduce_2 12# reduction where {
  reduction
	(HappyTerminal (ITinteger  happy_var_2))
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn12
		 ((happy_var_1, fromInteger happy_var_2));
  reduction _ _  = notHappyAtAll }

happyReduce_19 = happySpecReduce_2 12# reduction where {
  reduction
	(HappyTerminal (ITinteger  happy_var_2))
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn12
		 ((happy_var_1, fromInteger happy_var_2));
  reduction _ _  = notHappyAtAll }

happyReduce_20 = happySpecReduce_0 13# reduction where {
  reduction
	 =  HappyAbsSyn13
		 ([])}

happyReduce_21 = happyReduce 5# 13# reduction where {
  reduction
	(_ :
	(HappyAbsSyn14  happy_var_4) :
	(HappyAbsSyn62  happy_var_3) :
	_ :
	(HappyAbsSyn13  happy_var_1) :
	happyRest)
	 = HappyAbsSyn13
		 ((mkSysModuleFS happy_var_3, happy_var_4) : happy_var_1) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_22 = happySpecReduce_0 14# reduction where {
  reduction
	 =  HappyAbsSyn14
		 ([])}

happyReduce_23 = happySpecReduce_2 14# reduction where {
  reduction
	(HappyAbsSyn14  happy_var_2)
	(HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn14
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_24 = happySpecReduce_1 15# reduction where {
  reduction
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn15
		 (AvailTC happy_var_1 [happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_25 = happySpecReduce_1 15# reduction where {
  reduction
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn15
		 (Avail happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_26 = happySpecReduce_2 15# reduction where {
  reduction
	(HappyAbsSyn16  happy_var_2)
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn15
		 (AvailTC happy_var_1 (happy_var_1:happy_var_2));
  reduction _ _  = notHappyAtAll }

happyReduce_27 = happySpecReduce_3 15# reduction where {
  reduction
	(HappyAbsSyn16  happy_var_3)
	_
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn15
		 (AvailTC happy_var_1 happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_28 = happySpecReduce_3 16# reduction where {
  reduction
	_
	(HappyAbsSyn16  happy_var_2)
	_
	 =  HappyAbsSyn16
		 (happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_29 = happySpecReduce_1 17# reduction where {
  reduction
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn17
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_30 = happySpecReduce_1 17# reduction where {
  reduction
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn17
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_31 = happySpecReduce_1 18# reduction where {
  reduction
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn16
		 ([happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_32 = happySpecReduce_2 18# reduction where {
  reduction
	(HappyAbsSyn16  happy_var_2)
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn16
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_33 = happySpecReduce_1 19# reduction where {
  reduction
	_
	 =  HappyAbsSyn19
		 (InfixL)}

happyReduce_34 = happySpecReduce_1 19# reduction where {
  reduction
	_
	 =  HappyAbsSyn19
		 (InfixR)}

happyReduce_35 = happySpecReduce_1 19# reduction where {
  reduction
	_
	 =  HappyAbsSyn19
		 (InfixN)}

happyReduce_36 = happySpecReduce_0 20# reduction where {
  reduction
	 =  HappyAbsSyn20
		 (9)}

happyReduce_37 = happySpecReduce_1 20# reduction where {
  reduction
	(HappyTerminal (ITinteger  happy_var_1))
	 =  HappyAbsSyn20
		 ((fromInteger happy_var_1));
  reduction _  = notHappyAtAll }

happyReduce_38 = happySpecReduce_0 21# reduction where {
  reduction
	 =  HappyAbsSyn21
		 ([])}

happyReduce_39 = happyReduce 4# 21# reduction where {
  reduction
	(_ :
	(HappyAbsSyn21  happy_var_3) :
	_ :
	_ :
	happyRest)
	 = HappyAbsSyn21
		 (happy_var_3) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_40 = happySpecReduce_1 22# reduction where {
  reduction
	(HappyAbsSyn23  happy_var_1)
	 =  HappyAbsSyn21
		 ([happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_41 = happySpecReduce_3 22# reduction where {
  reduction
	(HappyAbsSyn21  happy_var_3)
	_
	(HappyAbsSyn23  happy_var_1)
	 =  HappyAbsSyn21
		 (happy_var_1 : happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_42 = happyReduce 4# 23# reduction where {
  reduction
	((HappyAbsSyn49  happy_var_4) :
	_ :
	(HappyAbsSyn66  happy_var_2) :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn23
		 (mkClassOpSig False happy_var_2 happy_var_4 happy_var_1) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_43 = happyReduce 5# 23# reduction where {
  reduction
	((HappyAbsSyn49  happy_var_5) :
	_ :
	_ :
	(HappyAbsSyn66  happy_var_2) :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn23
		 (mkClassOpSig True  happy_var_2 happy_var_5 happy_var_1) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_44 = happySpecReduce_0 24# reduction where {
  reduction
	 =  HappyAbsSyn24
		 ([])}

happyReduce_45 = happySpecReduce_2 24# reduction where {
  reduction
	(HappyAbsSyn25  happy_var_2)
	(HappyAbsSyn24  happy_var_1)
	 =  HappyAbsSyn24
		 (happy_var_2 : happy_var_1);
  reduction _ _  = notHappyAtAll }

happyReduce_46 = happyReduce 6# 25# reduction where {
  reduction
	(_ :
	(HappyAbsSyn66  happy_var_5) :
	_ :
	(HappyAbsSyn49  happy_var_3) :
	_ :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn25
		 (InstDecl happy_var_3
				   EmptyMonoBinds	{- No bindings -}
				   []    		{- No user pragmas -}
				   happy_var_5			{- Dfun id -}
				   happy_var_1
) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_47 = happySpecReduce_0 26# reduction where {
  reduction
	 =  HappyAbsSyn26
		 ([])}

happyReduce_48 = happyReduce 4# 26# reduction where {
  reduction
	(_ :
	(HappyAbsSyn27  happy_var_3) :
	(HappyAbsSyn38  happy_var_2) :
	(HappyAbsSyn26  happy_var_1) :
	happyRest)
	 = HappyAbsSyn26
		 ((happy_var_2,happy_var_3):happy_var_1) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_49 = happyReduce 5# 27# reduction where {
  reduction
	((HappyAbsSyn28  happy_var_5) :
	(HappyAbsSyn49  happy_var_4) :
	_ :
	(HappyAbsSyn66  happy_var_2) :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn27
		 (SigD (IfaceSig happy_var_2 happy_var_4 (happy_var_5 happy_var_2) happy_var_1)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_50 = happyReduce 6# 27# reduction where {
  reduction
	((HappyAbsSyn49  happy_var_6) :
	_ :
	(HappyAbsSyn51  happy_var_4) :
	(HappyAbsSyn66  happy_var_3) :
	_ :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn27
		 (TyClD (TySynonym happy_var_3 happy_var_4 happy_var_6 happy_var_1)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_51 = happyReduce 6# 27# reduction where {
  reduction
	((HappyAbsSyn40  happy_var_6) :
	(HappyAbsSyn51  happy_var_5) :
	(HappyAbsSyn66  happy_var_4) :
	(HappyAbsSyn39  happy_var_3) :
	_ :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn27
		 (TyClD (TyData DataType happy_var_3 happy_var_4 happy_var_5 happy_var_6 Nothing noDataPragmas happy_var_1)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_52 = happyReduce 6# 27# reduction where {
  reduction
	((HappyAbsSyn43  happy_var_6) :
	(HappyAbsSyn51  happy_var_5) :
	(HappyAbsSyn66  happy_var_4) :
	(HappyAbsSyn39  happy_var_3) :
	_ :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn27
		 (TyClD (TyData NewType happy_var_3 happy_var_4 happy_var_5 happy_var_6 Nothing noDataPragmas happy_var_1)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_53 = happyReduce 7# 27# reduction where {
  reduction
	((HappyAbsSyn21  happy_var_7) :
	(HappyAbsSyn90  happy_var_6) :
	(HappyAbsSyn51  happy_var_5) :
	(HappyAbsSyn66  happy_var_4) :
	(HappyAbsSyn39  happy_var_3) :
	_ :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn27
		 (TyClD (mkClassDecl happy_var_3 happy_var_4 happy_var_5 happy_var_6 happy_var_7 EmptyMonoBinds 
					noClassPragmas happy_var_1)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_54 = happyReduce 4# 27# reduction where {
  reduction
	((HappyAbsSyn66  happy_var_4) :
	(HappyAbsSyn20  happy_var_3) :
	(HappyAbsSyn19  happy_var_2) :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn27
		 (FixD (FixitySig happy_var_4 (Fixity happy_var_3 happy_var_2) happy_var_1)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_55 = happySpecReduce_0 28# reduction where {
  reduction
	 =  HappyAbsSyn28
		 (\_ -> [])}

happyReduce_56 = happySpecReduce_1 28# reduction where {
  reduction
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn28
		 (\x -> case happy_var_1 of
				     POk _ (PIdInfo id_info) -> id_info
				     PFailed err -> 
				        pprPanic "IdInfo parse failed" 
				            (vcat [ppr x, err])
);
  reduction _  = notHappyAtAll }

happyReduce_57 = happySpecReduce_2 29# reduction where {
  reduction
	(HappyTerminal (ITpragma   happy_var_2))
	(HappyAbsSyn125  happy_var_1)
	 =  HappyAbsSyn29
		 (parseIface happy_var_2 PState{ bol = 0#, atbol = 1#,
							context = [],
							glasgow_exts = 1#,
							loc = happy_var_1 }
);
  reduction _ _  = notHappyAtAll }

happyReduce_58 = happySpecReduce_0 30# reduction where {
  reduction
	 =  HappyAbsSyn30
		 (([], []))}

happyReduce_59 = happySpecReduce_2 30# reduction where {
  reduction
	(HappyAbsSyn30  happy_var_2)
	(HappyAbsSyn30  happy_var_1)
	 =  HappyAbsSyn30
		 (let
				     append2 (xs1,ys1) (xs2,ys2) =
					(xs1 `app` xs2, ys1 `app` ys2)
				     xs `app` [] = xs -- performance paranoia
				     xs `app` ys = xs ++ ys
				  in append2 happy_var_1 happy_var_2
);
  reduction _ _  = notHappyAtAll }

happyReduce_60 = happySpecReduce_1 31# reduction where {
  reduction
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn30
		 (case happy_var_1 of
			     POk _ (PRules   rules)   -> (rules,[])
			     POk _ (PDeprecs deprecs) -> ([],deprecs)
			     PFailed err -> pprPanic "Rules/Deprecations parse failed" err
);
  reduction _  = notHappyAtAll }

happyReduce_61 = happySpecReduce_0 32# reduction where {
  reduction
	 =  HappyAbsSyn32
		 ([])}

happyReduce_62 = happySpecReduce_3 32# reduction where {
  reduction
	(HappyAbsSyn32  happy_var_3)
	_
	(HappyAbsSyn33  happy_var_1)
	 =  HappyAbsSyn32
		 (happy_var_1:happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_63 = happyReduce 7# 33# reduction where {
  reduction
	((HappyAbsSyn99  happy_var_7) :
	_ :
	(HappyAbsSyn102  happy_var_5) :
	(HappyAbsSyn66  happy_var_4) :
	(HappyAbsSyn34  happy_var_3) :
	(HappyTerminal (ITstring   happy_var_2)) :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn33
		 (IfaceRuleDecl happy_var_4 (UfRuleBody happy_var_2 happy_var_3 happy_var_5 happy_var_7) happy_var_1) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_64 = happyReduce 4# 34# reduction where {
  reduction
	(_ :
	(HappyAbsSyn34  happy_var_3) :
	_ :
	_ :
	happyRest)
	 = HappyAbsSyn34
		 (happy_var_3) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_65 = happySpecReduce_0 35# reduction where {
  reduction
	 =  HappyAbsSyn35
		 ([])}

happyReduce_66 = happySpecReduce_3 35# reduction where {
  reduction
	_
	(HappyAbsSyn36  happy_var_2)
	(HappyAbsSyn35  happy_var_1)
	 =  HappyAbsSyn35
		 (happy_var_2 : happy_var_1);
  reduction _ _ _  = notHappyAtAll }

happyReduce_67 = happySpecReduce_1 36# reduction where {
  reduction
	(HappyTerminal (ITstring   happy_var_1))
	 =  HappyAbsSyn36
		 (Deprecation (IEModuleContents undefined) happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_68 = happySpecReduce_2 36# reduction where {
  reduction
	(HappyTerminal (ITstring   happy_var_2))
	(HappyAbsSyn37  happy_var_1)
	 =  HappyAbsSyn36
		 (Deprecation happy_var_1 happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_69 = happySpecReduce_1 37# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn37
		 (IEVar      happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_70 = happySpecReduce_1 37# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn37
		 (IEThingAbs happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_71 = happySpecReduce_1 38# reduction where {
  reduction
	(HappyTerminal (ITinteger  happy_var_1))
	 =  HappyAbsSyn38
		 (fromInteger happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_72 = happySpecReduce_0 39# reduction where {
  reduction
	 =  HappyAbsSyn39
		 ([])}

happyReduce_73 = happyReduce 4# 39# reduction where {
  reduction
	(_ :
	_ :
	(HappyAbsSyn39  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn39
		 (happy_var_2) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_74 = happySpecReduce_0 40# reduction where {
  reduction
	 =  HappyAbsSyn40
		 ([])}

happyReduce_75 = happySpecReduce_2 40# reduction where {
  reduction
	(HappyAbsSyn41  happy_var_2)
	_
	 =  HappyAbsSyn40
		 (happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_76 = happySpecReduce_1 41# reduction where {
  reduction
	(HappyAbsSyn42  happy_var_1)
	 =  HappyAbsSyn41
		 ([happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_77 = happySpecReduce_3 41# reduction where {
  reduction
	(HappyAbsSyn41  happy_var_3)
	_
	(HappyAbsSyn42  happy_var_1)
	 =  HappyAbsSyn41
		 (happy_var_1 : happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_78 = happyReduce 4# 42# reduction where {
  reduction
	((HappyAbsSyn45  happy_var_4) :
	(HappyAbsSyn66  happy_var_3) :
	(HappyAbsSyn44  happy_var_2) :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn42
		 (mk_con_decl happy_var_3 happy_var_2 (VanillaCon happy_var_4) happy_var_1) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_79 = happyReduce 6# 42# reduction where {
  reduction
	(_ :
	(HappyAbsSyn47  happy_var_5) :
	_ :
	(HappyAbsSyn66  happy_var_3) :
	(HappyAbsSyn44  happy_var_2) :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn42
		 (mk_con_decl happy_var_3 happy_var_2 (RecCon happy_var_5)     happy_var_1) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_80 = happySpecReduce_0 43# reduction where {
  reduction
	 =  HappyAbsSyn43
		 ([])}

happyReduce_81 = happyReduce 5# 43# reduction where {
  reduction
	((HappyAbsSyn49  happy_var_5) :
	(HappyAbsSyn66  happy_var_4) :
	(HappyAbsSyn44  happy_var_3) :
	_ :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn43
		 ([mk_con_decl happy_var_4 happy_var_3 (NewCon happy_var_5 Nothing) happy_var_1]) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_82 = happyReduce 9# 43# reduction where {
  reduction
	(_ :
	(HappyAbsSyn49  happy_var_8) :
	_ :
	(HappyAbsSyn66  happy_var_6) :
	_ :
	(HappyAbsSyn66  happy_var_4) :
	(HappyAbsSyn44  happy_var_3) :
	_ :
	(HappyAbsSyn125  happy_var_1) :
	happyRest)
	 = HappyAbsSyn43
		 ([mk_con_decl happy_var_4 happy_var_3 (NewCon happy_var_8 (Just happy_var_6)) happy_var_1]) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_83 = happySpecReduce_0 44# reduction where {
  reduction
	 =  HappyAbsSyn44
		 (([],[]))}

happyReduce_84 = happyReduce 4# 44# reduction where {
  reduction
	(_ :
	(HappyAbsSyn39  happy_var_3) :
	(HappyAbsSyn51  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn44
		 ((happy_var_2,happy_var_3)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_85 = happySpecReduce_0 45# reduction where {
  reduction
	 =  HappyAbsSyn45
		 ([])}

happyReduce_86 = happySpecReduce_2 45# reduction where {
  reduction
	(HappyAbsSyn45  happy_var_2)
	(HappyAbsSyn46  happy_var_1)
	 =  HappyAbsSyn45
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_87 = happySpecReduce_1 46# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn46
		 (Unbanged happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_88 = happySpecReduce_2 46# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_2)
	_
	 =  HappyAbsSyn46
		 (Banged   happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_89 = happySpecReduce_3 46# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	_
	_
	 =  HappyAbsSyn46
		 (Unpacked happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_90 = happySpecReduce_1 47# reduction where {
  reduction
	(HappyAbsSyn48  happy_var_1)
	 =  HappyAbsSyn47
		 ([happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_91 = happySpecReduce_3 47# reduction where {
  reduction
	(HappyAbsSyn47  happy_var_3)
	_
	(HappyAbsSyn48  happy_var_1)
	 =  HappyAbsSyn47
		 (happy_var_1 : happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_92 = happySpecReduce_3 48# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	_
	(HappyAbsSyn50  happy_var_1)
	 =  HappyAbsSyn48
		 ((happy_var_1, Unbanged happy_var_3));
  reduction _ _ _  = notHappyAtAll }

happyReduce_93 = happyReduce 4# 48# reduction where {
  reduction
	((HappyAbsSyn49  happy_var_4) :
	_ :
	_ :
	(HappyAbsSyn50  happy_var_1) :
	happyRest)
	 = HappyAbsSyn48
		 ((happy_var_1, Banged   happy_var_4)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_94 = happyReduce 5# 48# reduction where {
  reduction
	((HappyAbsSyn49  happy_var_5) :
	_ :
	_ :
	_ :
	(HappyAbsSyn50  happy_var_1) :
	happyRest)
	 = HappyAbsSyn48
		 ((happy_var_1, Unpacked happy_var_5)) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_95 = happyReduce 4# 49# reduction where {
  reduction
	((HappyAbsSyn49  happy_var_4) :
	_ :
	(HappyAbsSyn50  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn49
		 (mkHsUsForAllTy happy_var_2 happy_var_4) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_96 = happyReduce 5# 49# reduction where {
  reduction
	((HappyAbsSyn49  happy_var_5) :
	_ :
	(HappyAbsSyn39  happy_var_3) :
	(HappyAbsSyn51  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn49
		 (mkHsForAllTy (Just happy_var_2) happy_var_3 happy_var_5) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_97 = happySpecReduce_3 49# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	_
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn49
		 (MonoFunTy happy_var_1 happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_98 = happySpecReduce_1 49# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn49
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_99 = happySpecReduce_3 50# reduction where {
  reduction
	_
	(HappyAbsSyn50  happy_var_2)
	_
	 =  HappyAbsSyn50
		 (happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_100 = happySpecReduce_3 51# reduction where {
  reduction
	_
	(HappyAbsSyn51  happy_var_2)
	_
	 =  HappyAbsSyn51
		 (happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_101 = happySpecReduce_0 52# reduction where {
  reduction
	 =  HappyAbsSyn39
		 ([])}

happyReduce_102 = happySpecReduce_3 52# reduction where {
  reduction
	_
	(HappyAbsSyn39  happy_var_2)
	_
	 =  HappyAbsSyn39
		 (happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_103 = happySpecReduce_1 53# reduction where {
  reduction
	(HappyAbsSyn54  happy_var_1)
	 =  HappyAbsSyn39
		 ([happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_104 = happySpecReduce_3 53# reduction where {
  reduction
	(HappyAbsSyn39  happy_var_3)
	_
	(HappyAbsSyn54  happy_var_1)
	 =  HappyAbsSyn39
		 (happy_var_1 : happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_105 = happySpecReduce_2 54# reduction where {
  reduction
	(HappyAbsSyn60  happy_var_2)
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn54
		 ((HsPClass happy_var_1 happy_var_2));
  reduction _ _  = notHappyAtAll }

happyReduce_106 = happySpecReduce_3 54# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	_
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn54
		 ((HsPIParam happy_var_1 happy_var_3));
  reduction _ _ _  = notHappyAtAll }

happyReduce_107 = happySpecReduce_0 55# reduction where {
  reduction
	 =  HappyAbsSyn55
		 ([ ])}

happyReduce_108 = happySpecReduce_1 55# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn55
		 ([ happy_var_1 ]);
  reduction _  = notHappyAtAll }

happyReduce_109 = happySpecReduce_1 55# reduction where {
  reduction
	(HappyAbsSyn56  happy_var_1)
	 =  HappyAbsSyn55
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_110 = happySpecReduce_3 56# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	_
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn56
		 ([happy_var_1,happy_var_3]);
  reduction _ _ _  = notHappyAtAll }

happyReduce_111 = happySpecReduce_3 56# reduction where {
  reduction
	(HappyAbsSyn56  happy_var_3)
	_
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn56
		 (happy_var_1 : happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_112 = happySpecReduce_1 57# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn49
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_113 = happySpecReduce_2 57# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_2)
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn49
		 (MonoTyApp happy_var_1 happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_114 = happySpecReduce_3 57# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	(HappyAbsSyn58  happy_var_2)
	_
	 =  HappyAbsSyn49
		 (MonoUsgTy happy_var_2 happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_115 = happySpecReduce_1 58# reduction where {
  reduction
	_
	 =  HappyAbsSyn58
		 (MonoUsOnce)}

happyReduce_116 = happySpecReduce_1 58# reduction where {
  reduction
	_
	 =  HappyAbsSyn58
		 (MonoUsMany)}

happyReduce_117 = happySpecReduce_1 58# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn58
		 (MonoUsVar happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_118 = happySpecReduce_1 59# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn49
		 (MonoTyVar happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_119 = happySpecReduce_1 59# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn49
		 (MonoTyVar happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_120 = happySpecReduce_3 59# reduction where {
  reduction
	_
	(HappyAbsSyn56  happy_var_2)
	_
	 =  HappyAbsSyn49
		 (MonoTupleTy happy_var_2 True{-boxed-});
  reduction _ _ _  = notHappyAtAll }

happyReduce_121 = happySpecReduce_3 59# reduction where {
  reduction
	_
	(HappyAbsSyn55  happy_var_2)
	_
	 =  HappyAbsSyn49
		 (MonoTupleTy happy_var_2 False{-unboxed-});
  reduction _ _ _  = notHappyAtAll }

happyReduce_122 = happySpecReduce_3 59# reduction where {
  reduction
	_
	(HappyAbsSyn49  happy_var_2)
	_
	 =  HappyAbsSyn49
		 (MonoListTy  happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_123 = happyReduce 4# 59# reduction where {
  reduction
	(_ :
	(HappyAbsSyn60  happy_var_3) :
	(HappyAbsSyn66  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn49
		 (MonoDictTy happy_var_2 happy_var_3) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_124 = happyReduce 5# 59# reduction where {
  reduction
	(_ :
	(HappyAbsSyn49  happy_var_4) :
	_ :
	(HappyAbsSyn66  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn49
		 (MonoIParamTy happy_var_2 happy_var_4) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_125 = happySpecReduce_3 59# reduction where {
  reduction
	_
	(HappyAbsSyn49  happy_var_2)
	_
	 =  HappyAbsSyn49
		 (happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_126 = happySpecReduce_0 60# reduction where {
  reduction
	 =  HappyAbsSyn60
		 ([])}

happyReduce_127 = happySpecReduce_2 60# reduction where {
  reduction
	(HappyAbsSyn60  happy_var_2)
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn60
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_128 = happySpecReduce_1 61# reduction where {
  reduction
	(HappyTerminal (ITstring   happy_var_1))
	 =  HappyAbsSyn61
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_129 = happySpecReduce_0 61# reduction where {
  reduction
	 =  HappyAbsSyn61
		 (opt_InPackage)}

happyReduce_130 = happySpecReduce_1 62# reduction where {
  reduction
	(HappyTerminal (ITconid    happy_var_1))
	 =  HappyAbsSyn62
		 (mkSysModuleFS happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_131 = happySpecReduce_1 63# reduction where {
  reduction
	(HappyTerminal (ITvarid    happy_var_1))
	 =  HappyAbsSyn63
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_132 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("!"))}

happyReduce_133 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("as"))}

happyReduce_134 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("qualified"))}

happyReduce_135 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("hiding"))}

happyReduce_136 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("forall"))}

happyReduce_137 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("foreign"))}

happyReduce_138 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("export"))}

happyReduce_139 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("label"))}

happyReduce_140 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("dynamic"))}

happyReduce_141 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("unsafe"))}

happyReduce_142 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("with"))}

happyReduce_143 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("ccall"))}

happyReduce_144 = happySpecReduce_1 63# reduction where {
  reduction
	_
	 =  HappyAbsSyn63
		 (SLIT("stdcall"))}

happyReduce_145 = happySpecReduce_1 64# reduction where {
  reduction
	(HappyTerminal (ITqvarid   happy_var_1))
	 =  HappyAbsSyn64
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_146 = happySpecReduce_1 64# reduction where {
  reduction
	(HappyTerminal (ITqvarsym  happy_var_1))
	 =  HappyAbsSyn64
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_147 = happySpecReduce_1 65# reduction where {
  reduction
	(HappyAbsSyn63  happy_var_1)
	 =  HappyAbsSyn17
		 (mkSysOccFS varName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_148 = happySpecReduce_1 66# reduction where {
  reduction
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn66
		 (mkRdrUnqual happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_149 = happySpecReduce_1 67# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_150 = happySpecReduce_1 67# reduction where {
  reduction
	(HappyAbsSyn64  happy_var_1)
	 =  HappyAbsSyn66
		 (mkSysQual varName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_151 = happySpecReduce_1 68# reduction where {
  reduction
	(HappyTerminal (ITipvarid  happy_var_1))
	 =  HappyAbsSyn66
		 (mkSysUnqual ipName (tailFS happy_var_1));
  reduction _  = notHappyAtAll }

happyReduce_152 = happySpecReduce_0 69# reduction where {
  reduction
	 =  HappyAbsSyn50
		 ([])}

happyReduce_153 = happySpecReduce_2 69# reduction where {
  reduction
	(HappyAbsSyn50  happy_var_2)
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn50
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_154 = happySpecReduce_2 70# reduction where {
  reduction
	(HappyAbsSyn50  happy_var_2)
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn50
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_155 = happySpecReduce_1 71# reduction where {
  reduction
	(HappyTerminal (ITconid    happy_var_1))
	 =  HappyAbsSyn63
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_156 = happySpecReduce_1 71# reduction where {
  reduction
	(HappyTerminal (ITconsym   happy_var_1))
	 =  HappyAbsSyn63
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_157 = happySpecReduce_1 72# reduction where {
  reduction
	(HappyTerminal (ITqconid   happy_var_1))
	 =  HappyAbsSyn64
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_158 = happySpecReduce_1 72# reduction where {
  reduction
	(HappyTerminal (ITqconsym  happy_var_1))
	 =  HappyAbsSyn64
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_159 = happySpecReduce_1 73# reduction where {
  reduction
	(HappyAbsSyn63  happy_var_1)
	 =  HappyAbsSyn17
		 (mkSysOccFS dataName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_160 = happySpecReduce_1 74# reduction where {
  reduction
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn66
		 (mkRdrUnqual happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_161 = happySpecReduce_1 75# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_162 = happySpecReduce_1 75# reduction where {
  reduction
	(HappyAbsSyn64  happy_var_1)
	 =  HappyAbsSyn66
		 (mkSysQual dataName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_163 = happySpecReduce_0 76# reduction where {
  reduction
	 =  HappyAbsSyn50
		 ([])}

happyReduce_164 = happySpecReduce_2 76# reduction where {
  reduction
	(HappyAbsSyn50  happy_var_2)
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn50
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_165 = happySpecReduce_1 77# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_166 = happySpecReduce_1 77# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_167 = happySpecReduce_1 78# reduction where {
  reduction
	(HappyAbsSyn63  happy_var_1)
	 =  HappyAbsSyn63
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_168 = happySpecReduce_1 79# reduction where {
  reduction
	(HappyAbsSyn63  happy_var_1)
	 =  HappyAbsSyn17
		 (mkSysOccFS tcName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_169 = happySpecReduce_1 80# reduction where {
  reduction
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn66
		 (mkRdrUnqual happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_170 = happySpecReduce_1 81# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_171 = happySpecReduce_1 81# reduction where {
  reduction
	(HappyAbsSyn64  happy_var_1)
	 =  HappyAbsSyn66
		 (mkSysQual tcName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_172 = happySpecReduce_1 82# reduction where {
  reduction
	(HappyAbsSyn63  happy_var_1)
	 =  HappyAbsSyn66
		 (mkSysUnqual clsName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_173 = happySpecReduce_1 83# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_174 = happySpecReduce_1 83# reduction where {
  reduction
	(HappyAbsSyn64  happy_var_1)
	 =  HappyAbsSyn66
		 (mkSysQual clsName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_175 = happySpecReduce_1 84# reduction where {
  reduction
	(HappyTerminal (ITvarid    happy_var_1))
	 =  HappyAbsSyn66
		 (mkSysUnqual uvName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_176 = happySpecReduce_1 85# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_177 = happySpecReduce_0 86# reduction where {
  reduction
	 =  HappyAbsSyn50
		 ([])}

happyReduce_178 = happySpecReduce_2 86# reduction where {
  reduction
	(HappyAbsSyn50  happy_var_2)
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn50
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_179 = happySpecReduce_1 87# reduction where {
  reduction
	(HappyTerminal (ITvarid    happy_var_1))
	 =  HappyAbsSyn66
		 (mkSysUnqual tvName happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_180 = happySpecReduce_1 87# reduction where {
  reduction
	(HappyTerminal (ITvarsym   happy_var_1))
	 =  HappyAbsSyn66
		 (mkSysUnqual tvName happy_var_1 {- Allow t2 as a tyvar -});
  reduction _  = notHappyAtAll }

happyReduce_181 = happySpecReduce_3 88# reduction where {
  reduction
	(HappyAbsSyn94  happy_var_3)
	_
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn88
		 (IfaceTyVar happy_var_1 happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_182 = happySpecReduce_1 88# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn88
		 (IfaceTyVar happy_var_1 boxedTypeKind);
  reduction _  = notHappyAtAll }

happyReduce_183 = happySpecReduce_0 89# reduction where {
  reduction
	 =  HappyAbsSyn51
		 ([])}

happyReduce_184 = happySpecReduce_2 89# reduction where {
  reduction
	(HappyAbsSyn51  happy_var_2)
	(HappyAbsSyn88  happy_var_1)
	 =  HappyAbsSyn51
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_185 = happySpecReduce_0 90# reduction where {
  reduction
	 =  HappyAbsSyn90
		 ([])}

happyReduce_186 = happySpecReduce_2 90# reduction where {
  reduction
	(HappyAbsSyn90  happy_var_2)
	_
	 =  HappyAbsSyn90
		 (reverse happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_187 = happySpecReduce_3 91# reduction where {
  reduction
	(HappyAbsSyn92  happy_var_3)
	_
	(HappyAbsSyn90  happy_var_1)
	 =  HappyAbsSyn90
		 (happy_var_3 : happy_var_1);
  reduction _ _ _  = notHappyAtAll }

happyReduce_188 = happySpecReduce_1 91# reduction where {
  reduction
	(HappyAbsSyn92  happy_var_1)
	 =  HappyAbsSyn90
		 ([happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_189 = happySpecReduce_3 92# reduction where {
  reduction
	(HappyAbsSyn50  happy_var_3)
	_
	(HappyAbsSyn50  happy_var_1)
	 =  HappyAbsSyn92
		 ((reverse happy_var_1, reverse happy_var_3));
  reduction _ _ _  = notHappyAtAll }

happyReduce_190 = happySpecReduce_0 93# reduction where {
  reduction
	 =  HappyAbsSyn50
		 ([])}

happyReduce_191 = happySpecReduce_2 93# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_2)
	(HappyAbsSyn50  happy_var_1)
	 =  HappyAbsSyn50
		 (happy_var_2 : happy_var_1);
  reduction _ _  = notHappyAtAll }

happyReduce_192 = happySpecReduce_1 94# reduction where {
  reduction
	(HappyAbsSyn94  happy_var_1)
	 =  HappyAbsSyn94
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_193 = happySpecReduce_3 94# reduction where {
  reduction
	(HappyAbsSyn94  happy_var_3)
	_
	(HappyAbsSyn94  happy_var_1)
	 =  HappyAbsSyn94
		 (mkArrowKind happy_var_1 happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_194 = happySpecReduce_1 95# reduction where {
  reduction
	(HappyTerminal (ITvarsym   happy_var_1))
	 =  HappyAbsSyn94
		 (if happy_var_1 == SLIT("*") then
						boxedTypeKind
					  else if happy_var_1 == SLIT("?") then
						openTypeKind
					  else panic "ParseInterface: akind"
);
  reduction _  = notHappyAtAll }

happyReduce_195 = happySpecReduce_3 95# reduction where {
  reduction
	_
	(HappyAbsSyn94  happy_var_2)
	_
	 =  HappyAbsSyn94
		 (happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_196 = happySpecReduce_0 96# reduction where {
  reduction
	 =  HappyAbsSyn96
		 ([])}

happyReduce_197 = happySpecReduce_2 96# reduction where {
  reduction
	(HappyAbsSyn96  happy_var_2)
	(HappyAbsSyn97  happy_var_1)
	 =  HappyAbsSyn96
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_198 = happySpecReduce_2 97# reduction where {
  reduction
	(HappyTerminal (ITinteger  happy_var_2))
	_
	 =  HappyAbsSyn97
		 (HsArity (exactArity (fromInteger happy_var_2)));
  reduction _ _  = notHappyAtAll }

happyReduce_199 = happySpecReduce_3 97# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_3)
	(HappyAbsSyn98  happy_var_2)
	_
	 =  HappyAbsSyn97
		 (HsUnfold happy_var_2 happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_200 = happySpecReduce_1 97# reduction where {
  reduction
	_
	 =  HappyAbsSyn97
		 (HsCprInfo)}

happyReduce_201 = happySpecReduce_1 97# reduction where {
  reduction
	(HappyTerminal (ITstrict happy_var_1))
	 =  HappyAbsSyn97
		 (HsStrictness (HsStrictnessInfo happy_var_1));
  reduction _  = notHappyAtAll }

happyReduce_202 = happySpecReduce_1 97# reduction where {
  reduction
	_
	 =  HappyAbsSyn97
		 (HsNoCafRefs)}

happyReduce_203 = happySpecReduce_2 97# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_2)
	_
	 =  HappyAbsSyn97
		 (HsWorker happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_204 = happySpecReduce_0 98# reduction where {
  reduction
	 =  HappyAbsSyn98
		 (NoInlinePragInfo)}

happyReduce_205 = happySpecReduce_3 98# reduction where {
  reduction
	_
	(HappyTerminal (ITinteger  happy_var_2))
	_
	 =  HappyAbsSyn98
		 (IMustNotBeINLINEd True  (Just (fromInteger happy_var_2)));
  reduction _ _ _  = notHappyAtAll }

happyReduce_206 = happyReduce 4# 98# reduction where {
  reduction
	(_ :
	(HappyTerminal (ITinteger  happy_var_3)) :
	_ :
	_ :
	happyRest)
	 = HappyAbsSyn98
		 (IMustNotBeINLINEd False (Just (fromInteger happy_var_3))) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_207 = happyReduce 4# 99# reduction where {
  reduction
	((HappyAbsSyn99  happy_var_4) :
	_ :
	(HappyAbsSyn34  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn99
		 (foldr UfLam happy_var_4 happy_var_2) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_208 = happyReduce 7# 99# reduction where {
  reduction
	(_ :
	(HappyAbsSyn107  happy_var_6) :
	_ :
	(HappyAbsSyn66  happy_var_4) :
	_ :
	(HappyAbsSyn99  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn99
		 (UfCase happy_var_2 happy_var_4 happy_var_6) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_209 = happyReduce 8# 99# reduction where {
  reduction
	((HappyAbsSyn99  happy_var_8) :
	_ :
	_ :
	(HappyAbsSyn99  happy_var_5) :
	_ :
	(HappyAbsSyn116  happy_var_3) :
	_ :
	_ :
	happyRest)
	 = HappyAbsSyn99
		 (UfLet (UfNonRec happy_var_3 happy_var_5) happy_var_8) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_210 = happyReduce 6# 99# reduction where {
  reduction
	((HappyAbsSyn99  happy_var_6) :
	_ :
	_ :
	(HappyAbsSyn106  happy_var_3) :
	_ :
	_ :
	happyRest)
	 = HappyAbsSyn99
		 (UfLet (UfRec happy_var_3) happy_var_6) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_211 = happySpecReduce_3 99# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	(HappyTerminal (ITstring   happy_var_2))
	_
	 =  HappyAbsSyn99
		 (UfLitLit happy_var_2 happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_212 = happySpecReduce_2 99# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_2)
	_
	 =  HappyAbsSyn99
		 (UfNote UfInlineMe happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_213 = happySpecReduce_2 99# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_2)
	_
	 =  HappyAbsSyn99
		 (UfNote UfInlineCall happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_214 = happySpecReduce_3 99# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_3)
	(HappyAbsSyn49  happy_var_2)
	_
	 =  HappyAbsSyn99
		 (UfNote (UfCoerce happy_var_2) happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_215 = happySpecReduce_2 99# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_2)
	(HappyAbsSyn121  happy_var_1)
	 =  HappyAbsSyn99
		 (UfNote (UfSCC happy_var_1) happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_216 = happySpecReduce_1 99# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_1)
	 =  HappyAbsSyn99
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_217 = happySpecReduce_2 100# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_2)
	(HappyAbsSyn99  happy_var_1)
	 =  HappyAbsSyn99
		 (UfApp happy_var_1 happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_218 = happySpecReduce_1 100# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_1)
	 =  HappyAbsSyn99
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_219 = happySpecReduce_2 101# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_2)
	_
	 =  HappyAbsSyn99
		 (UfType happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_220 = happySpecReduce_1 101# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_1)
	 =  HappyAbsSyn99
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_221 = happySpecReduce_0 102# reduction where {
  reduction
	 =  HappyAbsSyn102
		 ([])}

happyReduce_222 = happySpecReduce_2 102# reduction where {
  reduction
	(HappyAbsSyn102  happy_var_2)
	(HappyAbsSyn99  happy_var_1)
	 =  HappyAbsSyn102
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_223 = happySpecReduce_1 103# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn99
		 (UfVar happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_224 = happySpecReduce_1 103# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn99
		 (UfVar happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_225 = happySpecReduce_1 103# reduction where {
  reduction
	(HappyAbsSyn113  happy_var_1)
	 =  HappyAbsSyn99
		 (UfLit happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_226 = happySpecReduce_3 103# reduction where {
  reduction
	_
	(HappyAbsSyn99  happy_var_2)
	_
	 =  HappyAbsSyn99
		 (happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_227 = happySpecReduce_3 103# reduction where {
  reduction
	_
	(HappyAbsSyn102  happy_var_2)
	_
	 =  HappyAbsSyn99
		 (UfTuple (mkRdrNameWkr (mkTupConRdrName (length happy_var_2))) happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_228 = happySpecReduce_3 103# reduction where {
  reduction
	_
	(HappyAbsSyn102  happy_var_2)
	_
	 =  HappyAbsSyn99
		 (UfTuple (mkRdrNameWkr (mkUbxTupConRdrName (length happy_var_2))) happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_229 = happyReduce 5# 103# reduction where {
  reduction
	(_ :
	(HappyAbsSyn49  happy_var_4) :
	(HappyAbsSyn120  happy_var_3) :
	(HappyTerminal (ITccall happy_var_2)) :
	_ :
	happyRest)
	 = HappyAbsSyn99
		 (let
                                 (is_dyn, is_casm, may_gc) = happy_var_2

			         target | is_dyn    = DynamicTarget (error "CCall dyn target bogus unique")
					| otherwise = StaticTarget happy_var_3

	                         ccall = CCall target is_casm may_gc cCallConv
 	                     in
			     UfCCall ccall happy_var_4
) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_230 = happySpecReduce_0 104# reduction where {
  reduction
	 =  HappyAbsSyn102
		 ([ ])}

happyReduce_231 = happySpecReduce_1 104# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_1)
	 =  HappyAbsSyn102
		 ([ happy_var_1 ]);
  reduction _  = notHappyAtAll }

happyReduce_232 = happySpecReduce_1 104# reduction where {
  reduction
	(HappyAbsSyn102  happy_var_1)
	 =  HappyAbsSyn102
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_233 = happySpecReduce_3 105# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_3)
	_
	(HappyAbsSyn99  happy_var_1)
	 =  HappyAbsSyn102
		 ([happy_var_1,happy_var_3]);
  reduction _ _ _  = notHappyAtAll }

happyReduce_234 = happySpecReduce_3 105# reduction where {
  reduction
	(HappyAbsSyn102  happy_var_3)
	_
	(HappyAbsSyn99  happy_var_1)
	 =  HappyAbsSyn102
		 (happy_var_1 : happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_235 = happySpecReduce_0 106# reduction where {
  reduction
	 =  HappyAbsSyn106
		 ([])}

happyReduce_236 = happyReduce 5# 106# reduction where {
  reduction
	((HappyAbsSyn106  happy_var_5) :
	_ :
	(HappyAbsSyn99  happy_var_3) :
	_ :
	(HappyAbsSyn116  happy_var_1) :
	happyRest)
	 = HappyAbsSyn106
		 ((happy_var_1,happy_var_3) : happy_var_5) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_237 = happySpecReduce_1 107# reduction where {
  reduction
	(HappyAbsSyn108  happy_var_1)
	 =  HappyAbsSyn107
		 ([happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_238 = happySpecReduce_3 107# reduction where {
  reduction
	(HappyAbsSyn107  happy_var_3)
	_
	(HappyAbsSyn108  happy_var_1)
	 =  HappyAbsSyn107
		 (happy_var_1 : happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_239 = happySpecReduce_3 108# reduction where {
  reduction
	(HappyAbsSyn99  happy_var_3)
	_
	(HappyAbsSyn109  happy_var_1)
	 =  HappyAbsSyn108
		 ((fst happy_var_1, snd happy_var_1, happy_var_3));
  reduction _ _ _  = notHappyAtAll }

happyReduce_240 = happySpecReduce_1 109# reduction where {
  reduction
	(HappyAbsSyn113  happy_var_1)
	 =  HappyAbsSyn109
		 ((UfLitAlt  happy_var_1, []));
  reduction _  = notHappyAtAll }

happyReduce_241 = happySpecReduce_3 109# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	(HappyTerminal (ITstring   happy_var_2))
	_
	 =  HappyAbsSyn109
		 ((UfLitLitAlt happy_var_2 happy_var_3, []));
  reduction _ _ _  = notHappyAtAll }

happyReduce_242 = happySpecReduce_2 109# reduction where {
  reduction
	(HappyAbsSyn50  happy_var_2)
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn109
		 ((UfDataAlt happy_var_1, happy_var_2));
  reduction _ _  = notHappyAtAll }

happyReduce_243 = happySpecReduce_3 109# reduction where {
  reduction
	_
	(HappyAbsSyn50  happy_var_2)
	_
	 =  HappyAbsSyn109
		 ((UfDataAlt (mkTupConRdrName (length happy_var_2)), happy_var_2));
  reduction _ _ _  = notHappyAtAll }

happyReduce_244 = happySpecReduce_3 109# reduction where {
  reduction
	_
	(HappyAbsSyn50  happy_var_2)
	_
	 =  HappyAbsSyn109
		 ((UfDataAlt (mkUbxTupConRdrName (length happy_var_2)), happy_var_2));
  reduction _ _ _  = notHappyAtAll }

happyReduce_245 = happySpecReduce_1 109# reduction where {
  reduction
	_
	 =  HappyAbsSyn109
		 ((UfDefault, []))}

happyReduce_246 = happySpecReduce_3 109# reduction where {
  reduction
	_
	(HappyAbsSyn109  happy_var_2)
	_
	 =  HappyAbsSyn109
		 (happy_var_2);
  reduction _ _ _  = notHappyAtAll }

happyReduce_247 = happySpecReduce_0 110# reduction where {
  reduction
	 =  HappyAbsSyn50
		 ([])}

happyReduce_248 = happySpecReduce_2 110# reduction where {
  reduction
	(HappyAbsSyn50  happy_var_2)
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn50
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_249 = happySpecReduce_1 111# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_250 = happySpecReduce_2 111# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_2)
	_
	 =  HappyAbsSyn66
		 (happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_251 = happySpecReduce_1 112# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn50
		 ([happy_var_1]);
  reduction _  = notHappyAtAll }

happyReduce_252 = happySpecReduce_3 112# reduction where {
  reduction
	(HappyAbsSyn50  happy_var_3)
	_
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn50
		 (happy_var_1 : happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_253 = happySpecReduce_1 113# reduction where {
  reduction
	(HappyAbsSyn114  happy_var_1)
	 =  HappyAbsSyn113
		 (mkMachInt happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_254 = happySpecReduce_1 113# reduction where {
  reduction
	(HappyTerminal (ITchar     happy_var_1))
	 =  HappyAbsSyn113
		 (MachChar happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_255 = happySpecReduce_1 113# reduction where {
  reduction
	(HappyTerminal (ITstring   happy_var_1))
	 =  HappyAbsSyn113
		 (MachStr happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_256 = happySpecReduce_1 113# reduction where {
  reduction
	(HappyAbsSyn115  happy_var_1)
	 =  HappyAbsSyn113
		 (MachDouble happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_257 = happySpecReduce_2 113# reduction where {
  reduction
	(HappyAbsSyn114  happy_var_2)
	_
	 =  HappyAbsSyn113
		 (mkMachWord happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_258 = happySpecReduce_2 113# reduction where {
  reduction
	(HappyAbsSyn114  happy_var_2)
	_
	 =  HappyAbsSyn113
		 (mkMachWord64 happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_259 = happySpecReduce_2 113# reduction where {
  reduction
	(HappyAbsSyn114  happy_var_2)
	_
	 =  HappyAbsSyn113
		 (mkMachInt64 happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_260 = happySpecReduce_2 113# reduction where {
  reduction
	(HappyAbsSyn115  happy_var_2)
	_
	 =  HappyAbsSyn113
		 (MachFloat happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_261 = happySpecReduce_2 113# reduction where {
  reduction
	(HappyAbsSyn114  happy_var_2)
	_
	 =  HappyAbsSyn113
		 (MachAddr happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_262 = happySpecReduce_1 114# reduction where {
  reduction
	(HappyTerminal (ITinteger  happy_var_1))
	 =  HappyAbsSyn114
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_263 = happySpecReduce_2 114# reduction where {
  reduction
	(HappyTerminal (ITinteger  happy_var_2))
	_
	 =  HappyAbsSyn114
		 ((-happy_var_2));
  reduction _ _  = notHappyAtAll }

happyReduce_264 = happySpecReduce_1 115# reduction where {
  reduction
	(HappyTerminal (ITrational happy_var_1))
	 =  HappyAbsSyn115
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_265 = happySpecReduce_2 115# reduction where {
  reduction
	(HappyTerminal (ITrational happy_var_2))
	_
	 =  HappyAbsSyn115
		 ((-happy_var_2));
  reduction _ _  = notHappyAtAll }

happyReduce_266 = happySpecReduce_1 116# reduction where {
  reduction
	(HappyAbsSyn116  happy_var_1)
	 =  HappyAbsSyn116
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_267 = happySpecReduce_1 116# reduction where {
  reduction
	(HappyAbsSyn116  happy_var_1)
	 =  HappyAbsSyn116
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_268 = happySpecReduce_0 117# reduction where {
  reduction
	 =  HappyAbsSyn34
		 ([])}

happyReduce_269 = happySpecReduce_2 117# reduction where {
  reduction
	(HappyAbsSyn34  happy_var_2)
	(HappyAbsSyn116  happy_var_1)
	 =  HappyAbsSyn34
		 (happy_var_1 : happy_var_2);
  reduction _ _  = notHappyAtAll }

happyReduce_270 = happySpecReduce_3 118# reduction where {
  reduction
	(HappyAbsSyn49  happy_var_3)
	_
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn116
		 (UfValBinder happy_var_1 happy_var_3);
  reduction _ _ _  = notHappyAtAll }

happyReduce_271 = happyReduce 4# 119# reduction where {
  reduction
	((HappyAbsSyn94  happy_var_4) :
	_ :
	(HappyAbsSyn66  happy_var_2) :
	_ :
	happyRest)
	 = HappyAbsSyn116
		 (UfTyBinder happy_var_2 happy_var_4) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_272 = happySpecReduce_2 119# reduction where {
  reduction
	(HappyAbsSyn66  happy_var_2)
	_
	 =  HappyAbsSyn116
		 (UfTyBinder happy_var_2 boxedTypeKind);
  reduction _ _  = notHappyAtAll }

happyReduce_273 = happySpecReduce_1 120# reduction where {
  reduction
	(HappyTerminal (ITstring   happy_var_1))
	 =  HappyAbsSyn120
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_274 = happySpecReduce_1 120# reduction where {
  reduction
	(HappyTerminal (ITlitlit   happy_var_1))
	 =  HappyAbsSyn120
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_275 = happySpecReduce_1 120# reduction where {
  reduction
	(HappyTerminal (ITvarid    happy_var_1))
	 =  HappyAbsSyn120
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_276 = happySpecReduce_1 120# reduction where {
  reduction
	(HappyTerminal (ITconid    happy_var_1))
	 =  HappyAbsSyn120
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_277 = happyReduce 4# 121# reduction where {
  reduction
	(_ :
	(HappyAbsSyn62  happy_var_3) :
	_ :
	_ :
	happyRest)
	 = HappyAbsSyn121
		 (AllCafsCC happy_var_3) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_278 = happyReduce 7# 121# reduction where {
  reduction
	(_ :
	(HappyAbsSyn124  happy_var_6) :
	(HappyAbsSyn123  happy_var_5) :
	(HappyAbsSyn62  happy_var_4) :
	(HappyAbsSyn63  happy_var_3) :
	_ :
	_ :
	happyRest)
	 = HappyAbsSyn121
		 (NormalCC { cc_name = happy_var_3, cc_mod = happy_var_4,
                                          cc_is_dupd = happy_var_5, cc_is_caf = happy_var_6 }) : happyRest;
  reduction _ = notHappyAtAll }

happyReduce_279 = happySpecReduce_1 122# reduction where {
  reduction
	(HappyTerminal (ITconid    happy_var_1))
	 =  HappyAbsSyn63
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_280 = happySpecReduce_1 122# reduction where {
  reduction
	(HappyAbsSyn63  happy_var_1)
	 =  HappyAbsSyn63
		 (happy_var_1);
  reduction _  = notHappyAtAll }

happyReduce_281 = happySpecReduce_0 123# reduction where {
  reduction
	 =  HappyAbsSyn123
		 (OriginalCC)}

happyReduce_282 = happySpecReduce_1 123# reduction where {
  reduction
	_
	 =  HappyAbsSyn123
		 (DupdCC)}

happyReduce_283 = happySpecReduce_0 124# reduction where {
  reduction
	 =  HappyAbsSyn124
		 (NotCafCC)}

happyReduce_284 = happySpecReduce_1 124# reduction where {
  reduction
	_
	 =  HappyAbsSyn124
		 (CafCC)}

happyReduce_285 = happyMonadReduce 0# 125# HappyAbsSyn125 reduction where {
  reduction
	(happyRest)
	 =  getSrcLocP}

happyReduce_286 = happyMonadReduce 0# 126# HappyAbsSyn126 reduction where {
  reduction
	(happyRest)
	 =  checkVersion Nothing}

happyReduce_287 = happyMonadReduce 1# 126# HappyAbsSyn126 reduction where {
  reduction
	((HappyTerminal (ITinteger  happy_var_1)) :
	happyRest)
	 =  checkVersion (Just (fromInteger happy_var_1));
  reduction _ = notHappyAtAll }

happyNewToken action sts stk
	= lexer(\tk -> 
	let cont i = action i i tk (HappyState action) sts stk in
	case tk of {
	ITeof -> action 231# 231# (error "reading EOF!") (HappyState action) sts stk;
	ITas -> cont 127#;
	ITcase -> cont 128#;
	ITclass -> cont 129#;
	ITdata -> cont 130#;
	ITdefault -> cont 131#;
	ITderiving -> cont 132#;
	ITdo -> cont 133#;
	ITelse -> cont 134#;
	IThiding -> cont 135#;
	ITif -> cont 136#;
	ITimport -> cont 137#;
	ITin -> cont 138#;
	ITinfix -> cont 139#;
	ITinfixl -> cont 140#;
	ITinfixr -> cont 141#;
	ITinstance -> cont 142#;
	ITlet -> cont 143#;
	ITmodule -> cont 144#;
	ITnewtype -> cont 145#;
	ITof -> cont 146#;
	ITqualified -> cont 147#;
	ITthen -> cont 148#;
	ITtype -> cont 149#;
	ITwhere -> cont 150#;
	ITforall -> cont 151#;
	ITforeign -> cont 152#;
	ITexport -> cont 153#;
	ITlabel -> cont 154#;
	ITdynamic -> cont 155#;
	ITunsafe -> cont 156#;
	ITwith -> cont 157#;
	ITstdcallconv -> cont 158#;
	ITccallconv -> cont 159#;
	ITinterface -> cont 160#;
	IT__export -> cont 161#;
	ITdepends -> cont 162#;
	IT__forall -> cont 163#;
	ITletrec -> cont 164#;
	ITcoerce -> cont 165#;
	ITinlineMe -> cont 166#;
	ITinlineCall -> cont 167#;
	ITdefaultbranch -> cont 168#;
	ITbottom -> cont 169#;
	ITinteger_lit -> cont 170#;
	ITfloat_lit -> cont 171#;
	ITword_lit -> cont 172#;
	ITint64_lit -> cont 173#;
	ITword64_lit -> cont 174#;
	ITrational_lit -> cont 175#;
	ITaddr_lit -> cont 176#;
	ITlit_lit -> cont 177#;
	ITstring_lit -> cont 178#;
	ITccall happy_dollar_dollar -> cont 179#;
	ITscc -> cont 180#;
	ITsccAllCafs -> cont 181#;
	ITusage -> cont 182#;
	ITfuall -> cont 183#;
	ITarity -> cont 184#;
	ITspecialise -> cont 185#;
	ITnocaf -> cont 186#;
	ITunfold happy_dollar_dollar -> cont 187#;
	ITstrict happy_dollar_dollar -> cont 188#;
	ITrules -> cont 189#;
	ITcprinfo -> cont 190#;
	ITdeprecated -> cont 191#;
	ITdotdot -> cont 192#;
	ITdcolon -> cont 193#;
	ITequal -> cont 194#;
	ITlam -> cont 195#;
	ITvbar -> cont 196#;
	ITlarrow -> cont 197#;
	ITrarrow -> cont 198#;
	ITat -> cont 199#;
	ITtilde -> cont 200#;
	ITdarrow -> cont 201#;
	ITminus -> cont 202#;
	ITbang -> cont 203#;
	ITbiglam -> cont 204#;
	ITocurly -> cont 205#;
	ITccurly -> cont 206#;
	ITobrack -> cont 207#;
	ITcbrack -> cont 208#;
	IToparen -> cont 209#;
	ITcparen -> cont 210#;
	IToubxparen -> cont 211#;
	ITcubxparen -> cont 212#;
	ITsemi -> cont 213#;
	ITcomma -> cont 214#;
	ITvarid    happy_dollar_dollar -> cont 215#;
	ITconid    happy_dollar_dollar -> cont 216#;
	ITvarsym   happy_dollar_dollar -> cont 217#;
	ITconsym   happy_dollar_dollar -> cont 218#;
	ITqvarid   happy_dollar_dollar -> cont 219#;
	ITqconid   happy_dollar_dollar -> cont 220#;
	ITqvarsym  happy_dollar_dollar -> cont 221#;
	ITqconsym  happy_dollar_dollar -> cont 222#;
	ITipvarid  happy_dollar_dollar -> cont 223#;
	ITpragma   happy_dollar_dollar -> cont 224#;
	ITchar     happy_dollar_dollar -> cont 225#;
	ITstring   happy_dollar_dollar -> cont 226#;
	ITinteger  happy_dollar_dollar -> cont 227#;
	ITrational happy_dollar_dollar -> cont 228#;
	ITlitlit   happy_dollar_dollar -> cont 229#;
	ITunknown  happy_dollar_dollar -> cont 230#;
	})

happyThen :: P a -> (a -> P b) -> P b
happyThen = (thenP)
happyReturn = (returnP)
parseIface = happyParse


happyError :: P a
happyError buf PState{ loc = loc } = PFailed (ifaceParseErr buf loc)

data IfaceStuff = PIface 	ParsedIface
		| PIdInfo	[HsIdInfo RdrName]
		| PType		RdrNameHsType
		| PRules	[RdrNameRuleDecl]
		| PDeprecs	[RdrNameDeprecation]

mk_con_decl name (ex_tvs, ex_ctxt) details loc = mkConDecl name ex_tvs ex_ctxt details loc
-- $Id: HappyTemplate-ghc,v 1.12 1999/06/30 14:14:33 simonmar Exp $

{-
	The stack is in the following order throughout the parse:

	i	current token number
	j	another copy of this to avoid messing with the stack
	tk	current token semantic value
	st	current state
	sts	state stack
	stk	semantic stack
-}

-----------------------------------------------------------------------------

happyParse = happyNewToken action_0 [] []

-- All this HappyState stuff is simply because we can't have recursive
-- types in Haskell without an intervening data structure.

newtype HappyState b c = HappyState
	(Int# ->			-- token number
	 Int# ->			-- token number (yes, again)
	 b -> 				-- token semantic value
	 HappyState b c ->		-- current state
	 [HappyState b c] ->		-- state stack
	 c)

-----------------------------------------------------------------------------
-- Accepting the parse

happyAccept j tk st sts [ HappyAbsSyn4 ans ] = happyReturn ans
happyAccept j tk st sts _ = happyTcHack j notHappyAtAll

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 1# tk st sts stk@(HappyErrorToken (I# i) : _) =
--     _trace "shifting the error token" $
     new_state i i tk (HappyState new_state) (st:sts) stk

happyShift new_state i tk st sts stk =
     happyNewToken new_state (st:sts) (HappyTerminal tk:stk)

-----------------------------------------------------------------------------
-- Reducing

-- happyReduce is specialised for the common cases.

-- don't allow reductions when we're in error recovery, because this can
-- lead to an infinite loop.

happySpecReduce_0 i fn 1# tk st sts stk
     = happyFail 1# tk st sts stk 
happySpecReduce_0 i fn j tk st@(HappyState action) sts stk
     = action i j tk st (st:sts) (fn : stk)

happySpecReduce_1 i fn 1# tk st sts stk
     = happyFail 1# tk st sts stk 
happySpecReduce_1 i fn j tk _ sts@(st@(HappyState action):_) (v1:stk')
     = action i j tk st sts (fn v1 : stk')
happySpecReduce_1 _ _ _ _ _ _ _
     = notHappyAtAll

happySpecReduce_2 i fn 1# tk st sts stk
     = happyFail 1# tk st sts stk 
happySpecReduce_2 i fn j tk _ (_:sts@(st@(HappyState action):_)) (v1:v2:stk')
     = action i j tk st sts (fn v1 v2 : stk')
happySpecReduce_2 _ _ _ _ _ _ _
     = notHappyAtAll

happySpecReduce_3 i fn 1# tk st sts stk
     = happyFail 1# tk st sts stk 
happySpecReduce_3 i fn j tk _ (_:_:sts@(st@(HappyState action):_)) 
	(v1:v2:v3:stk')
     = action i j tk st sts (fn v1 v2 v3 : stk')
happySpecReduce_3 _ _ _ _ _ _ _
     = notHappyAtAll

happyReduce k i fn 1# tk st sts stk
     = happyFail 1# tk st sts stk 
happyReduce k i fn j tk st sts stk
     = action i j tk st' sts' (fn stk)
       where sts'@(st'@(HappyState action):_) = drop (I# k) (st:sts)

happyMonadReduce k i c fn 1# tk st sts stk
     = happyFail 1# tk st sts stk 
happyMonadReduce k i c fn j tk st sts stk
     = happyThen (fn stk) (\r -> action i j tk st' sts' (c r : stk'))
       where sts'@(st'@(HappyState action):_) = drop (I# k) (st:sts)
	     stk' = drop (I# k) stk

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction

happyGoto action j tk st = action j j tk (HappyState action)

-----------------------------------------------------------------------------
-- Error recovery (1# is the error token)

-- fail if we are in recovery and no more states to discard
happyFail  1# tk st' [] stk = 
--	trace "failing" $ 
    	happyError

-- discard a state
happyFail  1# tk st' (st@(HappyState action):sts) (saved_tok : _ : stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	action 1# 1# tk st sts (saved_tok:stk)

-- Enter error recovery: generate an error token,
-- 			 save the old token and carry on.
happyFail  i tk st@(HappyState action) sts stk =
--	trace "entering error recovery" $
	action 1# 1# tk st sts (HappyErrorToken (I# i) : stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

happyTcHack :: Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.

